///<file name="3D">

///<section name="threejs_editor_like_a_main?">
//	$(document)._ready(

DEBUG_TRACER = false;
function debug_tracer_console() {
	if (DEBUG_TRACER) {
		console.log.apply(null, debug_tracer_console.arguments);
	}
}

PICKER_PANEL = true;
start3D = function () {
// musim zabezpecit velkost kontajnera ... bud prerabkou TreeUtils, alebo blikutim 
// z display:none na block
  var encapsulator = document.getElementById('editor_3D')
  ,	nodisp = getComputedStyle(encapsulator).display == 'none'
  ,	actdisp = encapsulator.style.display
  ;
  if (nodisp) {
	encapsulator.style.display = 'block';
  }
  var app = ThreeUtils.setupApp({
	containerid : 'threejs_canvas', 
    grid : true
  });
  if (navigator.userAgent.indexOf("Firefox") > -1) {
// oprava zoom faktor-a pre Firefox:
	if (app.editorControls) {
		app.editorControls.zoomSpeed *= 100/3;
	}
  }

  var raycaster = new THREE.Raycaster();
  
	var picktext = document.getElementById('picktext')
	,	sel1 = document.querySelector('select[name=vyber_plochu_3D]')
	,	sel2 = document.querySelector('select[name=vyber_plocha]')
	;

//	  // initialize object to perform world/screen calculations		???? netreba pre raypicking
//	  var projector = new THREE.Projector();
  
/*
  var objects = [];
  var sceneobjects = new THREE.Group();
  app.scene.add(sceneobjects);

  var spheregeom = new THREE.SphereGeometry(10, 32, 32);
  var bluemat = new THREE.MeshPhongMaterial({ color: 0x6666ff });
  bluemat.side = THREE.DoubleSide;
  spheregeom.mat = bluemat;
  var sphere = new THREE.Mesh(spheregeom, spheregeom.mat.clone());
  sphere.name = "sphere";
  sceneobjects.add(sphere);
  objects.push(sphere);

  var cubegeom = new THREE.CubeGeometry(15, 15, 15);
  var redmat = new THREE.MeshPhongMaterial({ color: 0xff6666 });
  redmat.side = THREE.DoubleSide;
  cubegeom.mat = redmat;
  var cube = new THREE.Mesh(cubegeom, cubegeom.mat.clone());
  cube.name = "cube";
  sceneobjects.add(cube);
  objects.push(cube);

  var cylgeom = new THREE.CylinderGeometry(5, 5, 20, 32, 1);
  var greenmat = new THREE.MeshPhongMaterial({ color: 0x66ff66 });
  greenmat.side = THREE.DoubleSide;
  cylgeom.mat = greenmat;
  var cyl = new THREE.Mesh(cylgeom, cylgeom.mat.clone());
  cyl.name = "cyl";
  cyl.negative = true;
  sceneobjects.add(cyl);
  objects.push(cyl);

  var cyl2 = new THREE.Mesh(cylgeom, cylgeom.mat.clone());
  cyl2.setRotationFromAxisAngle(new THREE.Vector3(1, 0, 0), Math.PI / 2);
  cyl2.name = "cyl2";
  cyl2.negative = true;
  sceneobjects.add(cyl2);
  objects.push(cyl2);

  var cyl3 = new THREE.Mesh(cylgeom, cylgeom.mat.clone());
  cyl3.setRotationFromAxisAngle(new THREE.Vector3(0, 0, 1), Math.PI / 2);
  cyl3.name = "cyl3";
  cyl3.negative = true;
  sceneobjects.add(cyl3);
  objects.push(cyl3);
*/
  app.camera.position.set(-100, 70, 70);	//	app.camera.position.set(50, 50, 50);
  app.camera.lookAt(new THREE.Vector3(0, 0, 0));

// _______________________________________
	app.panelator = new THREE.Group();
	app.panelator.name = '__panelator__';
	app.scene.add( app.panelator );
// _______________________________________

/*					var geometry = new THREE.CylinderGeometry( 0, 2, 10, 0.3 );
//	//				geometry.translate( 0, 50, 0 );
//	//				geometry.rotateX( Math.PI / 2 );
//					helper = new THREE.Mesh( geometry, new THREE.MeshNormalMaterial() );
//					helper.name="helper";
//					app.scene.add( helper );
//					helper.translate( 0, 50, 0 );
//					helper.rotateX( Math.PI / 2 );	*/

function onMouseClick/*Move*/( event ) {
    var mouse = {}
	,	renderer = app.renderer
	,	camera = app.camera
	;
//	https://stackoverflow.com/questions/45535513/update-three-js-raycaster-after-css-tranformation/45537592#45537592
	mouse.x = ( event./*clientX*/offsetX / renderer.domElement.clientWidth ) * 2 - 1;
	mouse.y = - ( event./*clientY*/offsetY / renderer.domElement.clientHeight ) * 2 + 1;
// console.log( event.clientX,event.offsetX,renderer.domElement.clientWidth, event.clientY,event.offsetY,renderer.domElement.clientHeight );	
	raycaster.setFromCamera( mouse, camera );
	// See if the ray from the camera into the world hits one of our meshes
	var intersects = raycaster.intersectObjects( [app.panelator], true );

	if ( intersects.length > 0 ) {
/*		// Toggle rotation bool for meshes that we clicked
//			helper.position.set( 0, 0, 0 );
//	//		helper.lookAt( intersects[ 0 ].face.normal );
//			helper.position.copy( intersects[ 0 ].point );
//	//	console.log( intersects[ 0 ].point );		*/

		var rgxp = /.+(__edges|__box)$/gmi
		,	objs = {}
		,	intersect_str = ""
	//	,	currobj
	//	,	numIntersections = 2
	//	,	insidecount = 0
		;
		for (var i = 0; i < intersects.length; i++) {
			var intersection = intersects[i];
			var obj = intersection.object
			,	oname = obj.name
			;
			if (oname.match(rgxp)) continue;
			objs[oname] = true;
/*			// intersections are in local coordinates
//			var normalMatrix = new THREE.Matrix3().getNormalMatrix(obj.matrixWorld);
//			var worldNormal = intersection.face.normal.clone().applyMatrix3(normalMatrix).normalize();
//
//			var DdN = raycaster.ray.direction.dot(worldNormal);
//			var reverse = DdN > 0 ? -1 : 1;
//			insidecount = insidecount + reverse * (obj.negative ? -1 : 1);
//			if (i > 0) intersect_str += "->";
//			if (DdN > 0) intersect_str += "/";	*/

//			intersect_str += '['+obj.name+']';

/*			intersect_str += "[" + worldNormal.x + "," +  worldNormal.y + "," + worldNormal.z + "]";
//			if (insidecount == numIntersections) {
//				obj.material.color.setRGB(1, 1, 1);
//				currobj = obj;
//				break;
//			}	*/
		}
		if (picktext) {
//			picktext.innerHTML = insidecount + " - " + (currobj ? currobj.name : "none") + " (" + intersect_str + ")";
			picktext.innerHTML = intersect_str;
console.log(intersect_str);
		}
		var onames = Object.keys(objs);
		if (onames.length) { 
console.log(onames.join(']['));
			if (PICKER_PANEL) {
				var val = onames[0]
				sel1.value = val; aFireEvent(sel1,'change');
				sel2.value = val; aFireEvent(sel2,'change');
				AppendableTable( stavitel.panely[val].ref.druh_plochy.el
					.queryXpath('.//ancestor-or-self::a:tr',__,1)
				).select();
			}
		}
	}
}  

//  window.addEventListener('mousemove', onMouseMove, false);
	app.container.addEventListener(/*'mousemove'*/'click', onMouseClick/*Move*/, false);


	ThreeUtils.animate();
  
	if (nodisp) {
		encapsulator.style.display = actdisp;
	}

	return app;
}

center3D = function() {
	app3D.camera.position.set(-100, 70, 70);
	app3D.camera.lookAt(new THREE.Vector3(0, 0, 0));
	app3D.controls.target.set(0,0,0);
}

app3D = start3D();
scene = app3D.scene;	// export as window.scene for ThreeJSinspector DevTools
//	);
///</section">


///<section name="clipper">
/// <wiki>https://sourceforge.net/p/jsclipper/wiki/Home%206</wiki>
/// <wiki>https://sourceforge.net/p/jsclipper/wiki/ExPolygons%20and%20PolyTree%206/</wiki>

// Converts Paths to SVG path string
// and scales down the coordinates
function paths2string (paths, scaleX, scaleY) {
  var svgpath = "", i, j;
  if (!scaleX) scaleX = 1;
  if (!scaleY) scaleY = 1;
  for(i = 0; i < paths.length; i++) {
    for(j = 0; j < paths[i].length; j++){
      if (!j) svgpath += "M";
      else svgpath += "L";
      svgpath += (paths[i][j].X / scaleX) + ", " + (paths[i][j].Y / scaleY);
    }
    svgpath += "Z";
  }
  if (svgpath=="") svgpath = "M0,0";
  return svgpath;
}

/// funkcia clipIt vykonava cez velku kniznicu Clipper
/// Boolean operacie nad polygonmi najuniverzalnejsou metodou
/// Vatti clipping algorithm
/// vyuzivam na vypocet potrebnych informacii:
/// - vysledne polygony po operacii (standartne Difference)
/// - plocha vysledku
/// - obvod vysledku 
/// - ale aj plocha Intersect - pre urcenie odpocitavanej ciastky
var cpr = new ClipperLib.Clipper();
/* Because Clipper library handles coordinates as integers, 
you have to scale them up before adding them to Clipper 
(and scale them back down before drawing). */
cpr_scaling_factor = 1000;	
//	https://sourceforge.net/p/jsclipper/wiki/ExPolygons%20and%20PolyTree%206/?version=3
function scaleDownExPolygon(exPolygons, scale) {
  var a, i, j, exPolygon, holes, outer, polygon;
  if (!scale) scale = 1;
  for (a = 0, alen = exPolygons.length; a < alen; a++) {
    exPolygon = exPolygons[a];
    holes = exPolygon.holes;
    outer = exPolygon.outer;
    for (i = 0, ilen = holes.length; i < ilen; i++) {
      polygon = holes[i];
      for (j = 0, jlen = polygon.length; j < jlen; j++) {
        point = polygon[j];
        point.X = Number(point.X) / scale;
        point.Y = Number(point.Y) / scale;
      }
    }
    for (j = 0, jlen = outer.length; j < jlen; j++) {
      point = outer[j];
      point.X = Number(point.X) / scale;
      point.Y = Number(point.Y) / scale;
    }
  }
  return exPolygons;
}
function clipItOne( subj_paths, clip_paths, clipType ) {
	clipType = clipType || ClipperLib.ClipType.ctIntersection;
	cpr.Clear();
	ClipperLib.JS.ScaleUpPaths(subj_paths, cpr_scaling_factor);
	ClipperLib.JS.ScaleUpPaths(clip_paths, cpr_scaling_factor);
	
	cpr.AddPaths(subj_paths, ClipperLib.PolyType.ptSubject, true);
	cpr.AddPaths(clip_paths, ClipperLib.PolyType.ptClip, true);	
	var ctResult_paths = new ClipperLib.Paths()
	,	succeeded = cpr.Execute(	clipType, ctResult_paths, ClipperLib.PolyFillType.pftNonZero, ClipperLib.PolyFillType.pftNonZero)
	;
	var area = ClipperLib.JS.AreaOfPolygons(ctResult_paths) / (cpr_scaling_factor * cpr_scaling_factor)	// / (1000 * 1000)
	,	perimeter = ClipperLib.JS.PerimeterOfPaths(ctResult_paths, true, 1) / cpr_scaling_factor		// / 1000	
	;
	ClipperLib.JS.ScaleDownPaths(subj_paths, cpr_scaling_factor);
	ClipperLib.JS.ScaleDownPaths(clip_paths, cpr_scaling_factor);
	ClipperLib.JS.ScaleDownPaths(ctResult_paths, cpr_scaling_factor);
	return {
		paths : ctResult_paths
	,	area : area
	,	perimeter : perimeter
	};
}
function clipIt( subj_paths, clip_paths, cfg ) {
//	cfg: {
//		clipType : 	0 ... ClipperLib.ClipType.ctIntersection	1 ... ClipperLib.ClipType.ctUnion
//					2 ... ClipperLib.ClipType.ctDifference		3 ... ClipperLib.ClipType.ctXor
//		subject_fillType :	0 ... ClipperLib.PolyFillType.pftEvenOdd	1 ... ClipperLib.PolyFillType.pftNonZero
//		clip_fillType : 	2 ... ClipperLib.PolyFillType.pftPositive	3 ... ClipperLib.PolyFillType.pftNegative
//	}
	cpr.Clear();
	ClipperLib.JS.ScaleUpPaths(subj_paths, cpr_scaling_factor);
	ClipperLib.JS.ScaleUpPaths(clip_paths, cpr_scaling_factor);
	
	var clipType = cfg && cfg.clipType || ClipperLib.ClipType.ctDifference
	,	subject_fillType = cfg && cfg.subject_fillType || ClipperLib.PolyFillType.pftNonZero
	,	clip_fillType = cfg && cfg.clip_fillType || ClipperLib.PolyFillType.pftNonZero
	;
	cpr.AddPaths(subj_paths, ClipperLib.PolyType.ptSubject, true);
	var	ctNoHole_paths = new ClipperLib.Paths()
	,	succeeded_NH = cpr.Execute(ClipperLib.ClipType.ctUnion, ctNoHole_paths, subject_fillType, clip_fillType)
	;
	cpr.AddPaths(clip_paths, ClipperLib.PolyType.ptClip, true);	
	var ctDifference_paths = new ClipperLib.Paths()
	,	succeeded_D = cpr.Execute(					clipType, ctDifference_paths, subject_fillType, clip_fillType)
	
	,	ctIntersection_paths = new ClipperLib.Paths()
	,	succeeded_I = cpr.Execute( ClipperLib.ClipType.ctIntersection, ctIntersection_paths, subject_fillType, clip_fillType)
	
	,	solution_polytree = new ClipperLib.PolyTree()
	,	succeeded_PT = cpr.Execute(clipType, solution_polytree, subject_fillType, clip_fillType)
	,	solution_expolygons = new ClipperLib.ExPolygons()
	,	solution_expolygons = ClipperLib.JS.PolyTreeToExPolygons(solution_polytree)
	;
	var areaDiff = ClipperLib.JS.AreaOfPolygons(ctDifference_paths) / (cpr_scaling_factor * cpr_scaling_factor)	// / (1000 * 1000)
	,	areaInter = ClipperLib.JS.AreaOfPolygons(ctIntersection_paths) / (cpr_scaling_factor * cpr_scaling_factor)	// / (1000 * 1000)
	,	perimeter = ClipperLib.JS.PerimeterOfPaths(ctDifference_paths, true, 1) / cpr_scaling_factor		// / 1000	
	,	areaNoHoles = ClipperLib.JS.AreaOfPolygons(ctNoHole_paths) / (cpr_scaling_factor * cpr_scaling_factor)	// / (1000 * 1000)
	,	perimeterNoHoles = ClipperLib.JS.PerimeterOfPaths(ctNoHole_paths, true, 1) / cpr_scaling_factor		// / 1000	
	;
	ClipperLib.JS.ScaleDownPaths(subj_paths, cpr_scaling_factor);
	ClipperLib.JS.ScaleDownPaths(clip_paths, cpr_scaling_factor);
	ClipperLib.JS.ScaleDownPaths(ctNoHole_paths, cpr_scaling_factor);
	ClipperLib.JS.ScaleDownPaths(ctDifference_paths, cpr_scaling_factor);
	ClipperLib.JS.ScaleDownPaths(ctIntersection_paths, cpr_scaling_factor);
	scaleDownExPolygon(solution_expolygons, cpr_scaling_factor);	// special case
	return {
		paths: {
			ctNoHole_paths : ctNoHole_paths
		,	ctDifference_paths : ctDifference_paths
		,	ctIntersection_paths : ctIntersection_paths
		}
	,	expolygons : solution_expolygons
	,	areaDiff : areaDiff
	,	areaInter : areaInter
	,	perimeter : perimeter
	,	areaNoHoles : areaNoHoles
	,	perimeterNoHoles : perimeterNoHoles
	};
}
/* example:	
//	pap = clipIt(
//			[	[{X:10,Y:10},{X:110,Y:10},{X:110,Y:110},{X:10,Y:110}]
//			,	[{X:20,Y:20},{X:20,Y:100},{X:100,Y:100},{X:100,Y:20}]
//			]
//		,	[	[{X:50,Y:50},{X:150,Y:50},{X:150,Y:150},{X:50,Y:150}]
//			,	[{X:60,Y:60},{X:60,Y:140},{X:140,Y:140},{X:140,Y:60}]
//			]
//		);
//	d = paths2string( pap.paths, 10 );
//	shapes = transformSVGPath(d);
//	plocha_shapes_3D(shapes);
*/

///</section>

///<section name="transformSVGpath">	// https://codepen.io/januff/pen/avajMa

/// funkcia transformSVGPath konvertuje SVG path d attribute
/// na Threejs Shape
function transformSVGPath(pathStr) {

    const DEGS_TO_RADS = Math.PI / 180,
        UNIT_SIZE = 1;

    const DIGIT_0 = 48, DIGIT_9 = 57, COMMA = 44, SPACE = 32, PERIOD = 46,
        MINUS = 45;

	var paths = [];
	var path = new THREE.Shape();

	var idx = 1, len = pathStr.length, activeCmd,
		x = 0, y = 0, nx = 0, ny = 0, firstX = null, firstY = null,
		x1 = 0, x2 = 0, y1 = 0, y2 = 0,
		rx = 0, ry = 0, xar = 0, laf = 0, sf = 0, cx, cy;

	function eatNum() {
		var sidx, c, isFloat = false, s;
		// eat delims
		while (idx < len) {
			c = pathStr.charCodeAt(idx);
			if (c !== COMMA && c !== SPACE)
				break;
			idx++;
		}
		if (c === MINUS)
			sidx = idx++;
		else
			sidx = idx;
		// eat number
		while (idx < len) {
			c = pathStr.charCodeAt(idx);
			if (DIGIT_0 <= c && c <= DIGIT_9) {
				idx++;
				continue;
			}
			else if (c === PERIOD) {
				idx++;
				isFloat = true;
				continue;
			}

			s = pathStr.substring(sidx, idx);
			return isFloat ? parseFloat(s) : parseInt(s);
		}

		s = pathStr.substring(sidx);
		return isFloat ? parseFloat(s) : parseInt(s);
	}

	function nextIsNum() {
		var c;
		// do permanently eat any delims...
		while (idx < len) {
			c = pathStr.charCodeAt(idx);
			if (c !== COMMA && c !== SPACE)
				break;
			idx++;
		}
		c = pathStr.charCodeAt(idx);
		return (c === MINUS || (DIGIT_0 <= c && c <= DIGIT_9));
	}

	var canRepeat;
	var enteredSub = false;
	var zSeen = false;
	activeCmd = pathStr[0];

	while (idx <= len) {
		canRepeat = true;
		switch (activeCmd) {
			// moveto commands, become lineto's if repeated
			case 'M':
				enteredSub = false;
				x = eatNum();
				y = eatNum();
				path.moveTo(x, y);
				activeCmd = 'L';
				break;
			case 'm':
				x += eatNum();
				y += eatNum();
				path.moveTo(x, y);
				activeCmd = 'l';
				break;
			case 'Z':
			case 'z':
				// z is a special case. This ends a segment and starts
				// a new path. Since the three.js path is continuous
				// we should start a new path here. This also draws a
				// line from the current location to the start location.
				canRepeat = false;
				if (x !== firstX || y !== firstY)
					path.lineTo(firstX, firstY);

				paths.push(path);

				// reset the elements
				firstX = null;
				firstY = null;

				// avoid x,y being set incorrectly
				enteredSub = true;

				path = new THREE.Shape();

				zSeen = true;

				break;
			// - lines!
			case 'L':
			case 'H':
			case 'V':
				nx = (activeCmd === 'V') ? x : eatNum();
				ny = (activeCmd === 'H') ? y : eatNum();
				path.lineTo(nx, ny);
				x = nx;
				y = ny;
				break;
			case 'l':
			case 'h':
			case 'v':
				nx = (activeCmd === 'v') ? x : (x + eatNum());
				ny = (activeCmd === 'h') ? y : (y + eatNum());
				path.lineTo(nx, ny);
				x = nx;
				y = ny;
				break;
			// - cubic bezier
			case 'C':
				x1 = eatNum(); y1 = eatNum();
			case 'S':
				if (activeCmd === 'S') {
					x1 = 2 * x - x2; y1 = 2 * y - y2;
				}
				x2 = eatNum();
				y2 = eatNum();
				nx = eatNum();
				ny = eatNum();
				path.bezierCurveTo(x1, y1, x2, y2, nx, ny);
				x = nx; y = ny;
				break;
			case 'c':
				x1 = x + eatNum();
				y1 = y + eatNum();
			case 's':
				if (activeCmd === 's') {
					x1 = 2 * x - x2;
					y1 = 2 * y - y2;
				}
				x2 = x + eatNum();
				y2 = y + eatNum();
				nx = x + eatNum();
				ny = y + eatNum();
				path.bezierCurveTo(x1, y1, x2, y2, nx, ny);
				x = nx; y = ny;
				break;
			// - quadratic bezier
			case 'Q':
				x1 = eatNum(); y1 = eatNum();
			case 'T':
				if (activeCmd === 'T') {
					x1 = 2 * x - x1;
					y1 = 2 * y - y1;
				}
				nx = eatNum();
				ny = eatNum();
				path.quadraticCurveTo(x1, y1, nx, ny);
				x = nx;
				y = ny;
				break;
			case 'q':
				x1 = x + eatNum();
				y1 = y + eatNum();
			case 't':
				if (activeCmd === 't') {
					x1 = 2 * x - x1;
					y1 = 2 * y - y1;
				}
				nx = x + eatNum();
				ny = y + eatNum();
				path.quadraticCurveTo(x1, y1, nx, ny);
				x = nx; y = ny;
				break;
			// - elliptical arc
			case 'A':
				rx = eatNum();
				ry = eatNum();
				xar = eatNum() * DEGS_TO_RADS;
				laf = eatNum();
				sf = eatNum();
				nx = eatNum();
				ny = eatNum();
				if (rx !== ry) {
					console.warn("Forcing elliptical arc to be a circular one :(",
						rx, ry);
				}
				// SVG implementation notes does all the math for us! woo!
				// http://www.w3.org/TR/SVG/implnote.html#ArcImplementationNotes
				// step1, using x1 as x1'
				x1 = Math.cos(xar) * (x - nx) / 2 + Math.sin(xar) * (y - ny) / 2;
				y1 = -Math.sin(xar) * (x - nx) / 2 + Math.cos(xar) * (y - ny) / 2;
				// step 2, using x2 as cx'
				var norm = Math.sqrt(
					(rx*rx * ry*ry - rx*rx * y1*y1 - ry*ry * x1*x1) /
						(rx*rx * y1*y1 + ry*ry * x1*x1));
				if (laf === sf)
					norm = -norm;
				x2 = norm * rx * y1 / ry;
				y2 = norm * -ry * x1 / rx;
				// step 3
				cx = Math.cos(xar) * x2 - Math.sin(xar) * y2 + (x + nx) / 2;
				cy = Math.sin(xar) * x2 + Math.cos(xar) * y2 + (y + ny) / 2;

				var u = new THREE.Vector2(1, 0),
					v = new THREE.Vector2((x1 - x2) / rx,
						(y1 - y2) / ry);
				var startAng = Math.acos(u.dot(v) / u.length() / v.length());
				if (u.x * v.y - u.y * v.x < 0)
					startAng = -startAng;

				// we can reuse 'v' from start angle as our 'u' for delta angle
				u.x = (-x1 - x2) / rx;
				u.y = (-y1 - y2) / ry;

				var deltaAng = Math.acos(v.dot(u) / v.length() / u.length());
				// This normalization ends up making our curves fail to triangulate...
				if (v.x * u.y - v.y * u.x < 0)
					deltaAng = -deltaAng;
				if (!sf && deltaAng > 0)
					deltaAng -= Math.PI * 2;
				if (sf && deltaAng < 0)
					deltaAng += Math.PI * 2;

				path.absarc(cx, cy, rx, startAng, startAng + deltaAng, sf);
				x = nx;
				y = ny;
				break;

			case ' ':
				// if it's an empty space, just skip it, and see if we can find a real command
				break;

			default:
				throw new Error("weird path command: " + activeCmd);
		}
		if (firstX === null && !enteredSub) {
			firstX = x;
			firstY = y;
		}

		// just reissue the command
		if (canRepeat && nextIsNum())
			continue;
		activeCmd = pathStr[idx++];
	}

	if (zSeen) {
		return paths;
	} else {
		paths.push(path);
		return paths;
	}
}

///</section>




/* change grid:
gg = new LabeledGrid(20, 20, 10,[0,1,0], 0x000055, 0.2,  true, "#000000", "left");
//	LabeledGrid {uuid: "CE747BDE-7A50-4222-9F2F-206B0D0AE155", name: "grid", type: "Object3D", parent: null, children: Array(3), …}
app3D.scene.children.splice(1,1,gg)
//	[LabeledGrid]
*/
function change_3D_grid( gx, gy, grid_name ) {
	grid_name = grid_name || 'grid';
	gx = parseFloat(gx);
	gy = parseFloat(gy);
	var grid3D = app3D.scene.getObjectByName(grid_name)
	,	grid_index = app3D.scene.children.indexOf(grid3D)
	;
	var ngrid = new LabeledGrid(gx, gy, 10,[0,1,0], 0x000055, 0.2,  true, "#000000", "left");
	ngrid.rotateZ(-90*Math.PI/180);
	app3D.scene.add(ngrid);	// aby existoval parent (inak by bol null)
	app3D.scene.children.splice( grid_index, 1, ngrid);
	app3D.scene.children.pop();	// odstranime pridany (preradeny)
}

///<section name="custom_funcs">

/*	priklad:
defs = { dlzka:3.45, sirka:2.54, name:'prva', x:1,y:2,z:0
, otvory:[
    { vyska:1.5, sirka:0.75, x:1.5, y:0.5 }
]};
vyrob_plochu_3D(defs);


defs = { dlzka:13.45, sirka:12.54, name:'druha', x:1,y:2,z:0
, otvory:[
    { vyska:4.5, sirka:6.75, x:8.5, y:-1.5 }
]}
*/
function vyrob_plochu_3D( defs ) {
	var tvar = defs.tvar ||  [ 
			{x:0,y:0}
		,	{x:defs.dlzka,y:0}
		,	{x:defs.dlzka,y:defs.sirka}
		,	{x:0,y:defs.sirka} 
		]
	,	i, le = tvar.length
	,	points = []
	,	areas = [], area = 0
	,	obvod = 0
	;
	for(i=0;i<le;i++) {
		if (i > 0) {
			obvod += Math.sqrt( (tvar[i].x - tvar[i-1].x)*(tvar[i].x - tvar[i-1].x) 
							+ (tvar[i].y - tvar[i-1].y)*(tvar[i].y - tvar[i-1].y) 
							);
		}
		points.push( new THREE.Vector2( tvar[i].x,tvar[i].y ));
	}	// zabezpecime uzavretie VZDY !
	if ( (tvar[le-1].x != tvar[0].x) || (tvar[le-1].y != tvar[0].y) ) {
		obvod += Math.sqrt( (tvar[0].x - tvar[i-1].x)*(tvar[0].x - tvar[i-1].x) 
						+ (tvar[0].y - tvar[i-1].y)*(tvar[0].y - tvar[i-1].y) 
						);
		points.push( new THREE.Vector2( tvar[0].x,tvar[0].y ));
	}
	var shape = new THREE.Shape( points )
	,	shapeA = THREE.ShapeUtils.area(points)
	;
	area += shapeA; areas.push( shapeA );	// 0 ... area of PLOCHA contour 
	if (defs.otvory) {
		defs.otvory.forEach( function(v) {
			tvar = v.tvar ||  [ 
				{x:v.x+0,y:v.y+0}
			, 	{x:v.x+v.sirka,y:v.y+0}
			,	{x:v.x+v.sirka,y:v.y+v.vyska}
			,	{x:v.x+0,y:v.y+v.vyska} 
			];
			le = tvar.length, points = [];
			for(i=0;i<le;i++) {
				points.push( new THREE.Vector2( tvar[i].x,tvar[i].y ));
			}		// zabezpecime uzavretie VZDY !
			if ( (tvar[le-1].x != tvar[0].x) || (tvar[le-1].y != tvar[0].y) ) {
				points.push( new THREE.Vector2( tvar[0].x,tvar[0].y ));
			}
			shape.holes.push(new THREE.Shape( points ));
			shapeA = THREE.ShapeUtils.area(points);
			area -= shapeA; areas.push( shapeA );	// 1...n ... areas of OTVORY contour 
		});
	}
	var mesh = plocha_shapes_3D( shape, defs ).mesh;
	return { mesh:mesh, areas:areas, area:area, obvod:obvod };
}

function plocha_shapes_3D ( shapes, defs ) {
	defs = defs || {};
	defs.name = defs.name || 'new';
	var extrudeSettings = {
		steps: 2,
		amount: defs.hrubka || 0.3,
		bevelEnabled: false,	// true
		bevelThickness: 1,
		bevelSize: 1,
		bevelSegments: 1
	};
// remove old if exists
	app3D.scene.remove(app3D.scene.getObjectByName(defs.name));
	
	var stenaobjects = new THREE.Group();
	stenaobjects.name = defs.name;
	app3D.panelator.add(stenaobjects);	//app3D.scene.add(stenaobjects);
	
	var geometry = new THREE.ExtrudeGeometry( shapes, extrudeSettings )
	,	material = new THREE.MeshBasicMaterial( { color: 0x00ff00, side : THREE.DoubleSide  } )
	,	mesh = new THREE.Mesh( geometry, material ) 
	,	edges = new THREE.EdgesGeometry( geometry )
	,	lines = new THREE.LineSegments( edges, new THREE.LineBasicMaterial( { color: 0x000000, side : THREE.DoubleSide } ) )
	;
	mesh.name = defs.name;
	lines.name = defs.name+'__edges';
	stenaobjects.add(mesh);
	stenaobjects.add(lines);
	var	box = new THREE.BoxHelper( stenaobjects, 0xffff00 );
	box.visible = false;
	box.name = defs.name+'__box';
	stenaobjects.add(box);
	
	return { panel:stenaobjects, mesh:mesh, edges:lines };
}

function expoly_to_shape ( expolygons ) {
	var shapes = []
	,	areas_perimeter = []
	;
	expolygons.forEach( function(expoly) {
		var points = []
		,	areas = [], area = 0
		,	obvod = 0
		,	tvar = expoly.outer, le = expoly.outer.length
		;
		for(i=0;i<le;i++) {
			if (i > 0) {
				obvod += Math.sqrt( (tvar[i].X - tvar[i-1].X)*(tvar[i].X - tvar[i-1].X) 
								+ (tvar[i].Y - tvar[i-1].Y)*(tvar[i].Y - tvar[i-1].Y) 
								);
			}
			points.push( new THREE.Vector2( tvar[i].X,tvar[i].Y ));
		}	// zabezpecime uzavretie VZDY !
		if ( (tvar[le-1].X != tvar[0].X) || (tvar[le-1].Y != tvar[0].Y) ) {
			obvod += Math.sqrt( (tvar[0].X - tvar[i-1].X)*(tvar[0].X - tvar[i-1].X) 
							+ (tvar[0].Y - tvar[i-1].Y)*(tvar[0].Y - tvar[i-1].Y) 
							);
			points.push( new THREE.Vector2( tvar[0].X,tvar[0].Y ));
		}
		var shape = new THREE.Shape( points )
		,	shapeA = THREE.ShapeUtils.area(points)
		;
		area += shapeA; areas.push( shapeA );	// 0 ... area of PLOCHA contour 
		if (expoly.holes) {
			expoly.holes.forEach( function(v) {
				tvar = v;
				le = tvar.length, points = [];
				for(i=0;i<le;i++) {
					points.push( new THREE.Vector2( tvar[i].X,tvar[i].Y ));
				}		// zabezpecime uzavretie VZDY !
				if ( (tvar[le-1].X != tvar[0].X) || (tvar[le-1].Y != tvar[0].Y) ) {
					points.push( new THREE.Vector2( tvar[0].X,tvar[0].Y ));
				}
				shape.holes.push(new THREE.Shape( points ));
				shapeA = THREE.ShapeUtils.area(points);
				area -= shapeA; areas.push( shapeA );	// 1...n ... areas of OTVORY contour 
			});
		}
		shapes.push( shape );
		areas_perimeter.push( { areas:areas, obsah:area, obvod:obvod } );
	});
	return { shapes:shapes, areas_perimeter:areas_perimeter };
}


/* Horiz, SVJZ	transalcie a rotacie X Y Z:
vychadzame z toho, ze sa v zakladnom stave pozerame na JuhoVychodnu stranu baraku
a podlaha vypada nasledovne:
	
	Horiz:		-90,0,	0
	J	:		0,	0,	0		tran	0,	0,	0
	S	:		0,180,	0		tran	AD,	0,	0
*/

var selected_3D_panel = null;

var Name3D_rgxp = /(\d+)_(\d+)z(\d+)_/img;


function placement_3D_handler(evt) {
	var inp = (evt instanceof Event) ? evt.target : evt
	,	name = inp.name
	,	val = parseFloat(inp.value)
	,	frme = inp.form.elements
	,	meno_plochy = frme.vyber_plochu_3D.value
	,	previous_selected_3D_panel = selected_3D_panel
	,	change_tvar3D = true;
	;
// always :
	//	selected_3D_panel = app3D.scene.children[ 2+ inp.form.elements.vyber_plochu_3D.selectedIndex];
	selected_3D_panel = app3D.scene.getObjectByName(meno_plochy);
	switch(name) {
		case 'vyber_plochu_3D':	{ // select
			if (previous_selected_3D_panel) {
				previous_selected_3D_panel.children[1].material.color.setRGB(0,0,0);
				previous_selected_3D_panel.children[2].visible = false;
			}
			var pos = selected_3D_panel.position
			,	rot = selected_3D_panel.rotation
	//		,	cubo = selected_3D_panel.children[0]
	//		,	colors = isArr(cubo.material) 		 // ExtrudeGeometry ma iba 2 farby ... shape a extrude
	//				? [cubo.material[0].color.getHexString(),cubo.material.color[1].getHexString(),]
	//				: [cubo.material.color.getHexString(),'#ffff00','#c0c0c0']
			;
			frme.color_3D.value = '#'+selected_3D_panel.children[0].material.color.getHexString();
			frme.translate_X.value = pos.x;
			frme.translate_Y.value = pos.y;
			frme.translate_Z.value = pos.z;
			frme.rotate_X.value = rot._x/Math.PI * 180;
			frme.rotate_Y.value = rot._y/Math.PI * 180;
			frme.rotate_Z.value = rot._z/Math.PI * 180;
			selected_3D_panel.children[1].material.color.setRGB(1,1,1);
			selected_3D_panel.children[2].visible = true;
			change_tvar3D = false;
			break;
		}
		case 'color_3D' : {
			// var	material = new THREE.MeshBasicMaterial( { color: inp.value, side : THREE.DoubleSide } );
// Grupa panelu obsahuje 0...stena, 1...edges
// material menime stene
// poziciu ... translate a rotate menime celej grupe
			//selected_3D_panel.children[0].material = material;
			selected_3D_panel.children[0].material.color.set(inp.value);
			break;
		}
	//	case 'color_3D_in' :
	//		selected_3D_panel.children[0].material.color.set(inp.value);
	//		break;
		case 'translate_X':
		case 'translate_Y':
		case 'translate_Z': {
			var x = parseFloat(frme.translate_X.value)
			,	y = parseFloat(frme.translate_Y.value)
			,	z = parseFloat(frme.translate_Z.value)
			;
			selected_3D_panel.position.set(
				isNaN(x) ? 0 : x, isNaN(y) ? 0 : y, isNaN(z) ? 0 : z
			);
			break;
		}
		case 'rotate_X':
		case 'rotate_Y':
		case 'rotate_Z': {
			var x = parseFloat(frme.rotate_X.value)
			,	y = parseFloat(frme.rotate_Y.value)
			,	z = parseFloat(frme.rotate_Z.value)
			,	radx = (isNaN(x) ? 0 : x) * Math.PI/180
			,	rady = (isNaN(y) ? 0 : y) * Math.PI/180
			,	radz = (isNaN(z) ? 0 : z) * Math.PI/180
			;
			selected_3D_panel.rotation.set( radx, rady, radz );
			break;
		}
	}
	if (change_tvar3D) {
		Name3D_rgxp.lastIndex = 0;
		var	matches = Name3D_rgxp.exec(meno_plochy)
		,	idx = matches && (matches[2]-1) || 0
		,	pocet = matches && (matches[3]) || 1
		,	panel = this.stavitel.panely[meno_plochy]
		,	tvar2D3D = JSON5.parseOr(panel.ref.tvar2D3D.val)
		,	tvar3D = tvar2D3D.tvar3D || {pole:[]};
		;		
// osetrovacky nasobnych ploch ====================================	
		
	// kazda plocha v zostave rovnakych ploch
	// ma svoje specificke vlastnosti (minimalne vlastnu color, position, rotation )
		tvar3D.pole = isArr(tvar3D.pole) ? tvar3D.pole : [];
		for(var i=0; i< pocet; i++) {
	// okna rozlozime len tak do riadku s odstupom 2 metre
			tvar3D.pole[i] = tvar3D.pole[i] || {};
		}
	// pokial je povodne pole vacsie (po znizeni poctu ploch), zmensime ho
		var pl = tvar3D.pole.length;
		for(var i=pl-1; i>= pocet; i--) {
			tvar3D.pole.pop();
		}
// osetrovacky nasobnych ploch ------------------------------------			
			
		tvar3D.pole[idx] = {
			color: frme.color_3D.value
	//	,	color_in: frme.color_3D_in.value
		,	position : JSON.parse(JSON.stringify(selected_3D_panel.position))
		,	rotation : JSON.parse(JSON.stringify(selected_3D_panel.rotation))
		};
		tvar2D3D.tvar3D = tvar3D;
		panel.ref.tvar2D3D.el.value = panel.ref.tvar2D3D.val = JSON.stringify( tvar2D3D );
	}
}

///</section>

///<section name="svg_tvar_handler">

stavitel = {
// data usporiadane do formy parametrickeho pola
// [ { meno, druh, pocet, vyska, sirka, tvar2D3D: { tvar2D:{....} , tvar3D : {....}}
//		otvory : [
//			{ meno, druh, pocet, vyska, sirka, tvar2D: {....}
//		]
//	 }
// ]
	panely : []

,	plochotvory : []
,	teple_plochy : []
,	teple_objemy : []

/// metoda getData naplni teple_plochy, teple_objemy, plochotvory
,	getData : function( projekt ) {
debug_tracer_console('getData', projekt);	
		this.plochotvory = [];
		this.teple_plochy = [];
		this.teple_objemy = [];
		var projekt = projekt || Actual_CalculForms.save()
		,	project = JSON5.parseOr( projekt,{} ) 
		,	rgxpn = /(.+?)_\d+/gim, matchname, name
		,	rgxp = /_\d+/gim, matches, idx1, idx2
		,	me = this
		;
		var	SkladbaStavby = /*Actual_CalculForms.*/project.Skladba.stavby
		,	frme = document.forms.Skladba.elements.stavby.elements
		,	names = SkladbaStavby && Object.keys(SkladbaStavby) || []
		;
		names.forEach( function(v,i) {
			rgxpn.lastIndex = 0;
			matchname = rgxpn.exec(v);
			if (matchname) {
				name = matchname[1];
				rgxp.lastIndex = 0;
				matches = rgxp.exec(v);	// first index
				idx1 = parseFloat(matches[0].replace('_',''));
				me.plochotvory[idx1] = me.plochotvory[idx1] || {}
				matches = rgxp.exec(v);	// second index
				if (matches) {
					me.plochotvory[idx1].otvory = me.plochotvory[idx1].otvory || [];
					idx2 = parseFloat(matches[0].replace('_',''));
					me.plochotvory[idx1].otvory[idx2] = me.plochotvory[idx1].otvory[idx2] || {};
					me.plochotvory[idx1].otvory[idx2][name] = { 
						el:	frme[v]	//SkladbaStavby[v]
					,	val:(SkladbaStavby[v].type=='checkbox') ? SkladbaStavby[v].checked : SkladbaStavby[v].value 
					};
				} else {
					me.plochotvory[idx1][name] = {
						el:	frme[v]	//SkladbaStavby[v]
					,	val:(SkladbaStavby[v].type=='checkbox') ? SkladbaStavby[v].checked : SkladbaStavby[v].value 
					};
				}
			}
		});
		var	teple_plochy = project.vyhrievane_plochy.teple_plochy
		,	frme = document.forms.vyhrievane_plochy.elements.teple_plochy.elements
		,	names = teple_plochy && Object.keys(teple_plochy) || []
		;
		names.forEach( function(v,i) {
			rgxpn.lastIndex = 0;
			matchname = rgxpn.exec(v);
			if (matchname) {
				name = matchname[1];
				rgxp.lastIndex = 0;
				matches = rgxp.exec(v);	// first index
				idx1 = parseFloat(matches[0].replace('_',''));
				me.teple_plochy[idx1] = me.teple_plochy[idx1] || {};
				
				me.teple_plochy[idx1][name] = {
					el:	frme[v]
				,	val:(teple_plochy[v].type=='checkbox') ? teple_plochy[v].checked : teple_plochy[v].value 
				};
			}
		});
		var	teple_objemy = project.vyhrievane_plochy.teple_objemy
		,	frme = document.forms.vyhrievane_plochy.elements.teple_objemy.elements
		,	names = teple_objemy && Object.keys(teple_objemy) || []
		;
		names.forEach( function(v,i) {
			rgxpn.lastIndex = 0;
			matchname = rgxpn.exec(v);
			if (matchname) {
				name = matchname[1];
				rgxp.lastIndex = 0;
				matches = rgxp.exec(v);	// first index
				idx1 = parseFloat(matches[0].replace('_',''));
				me.teple_objemy[idx1] = me.teple_objemy[idx1] || {};
				
				me.teple_objemy[idx1][name] = {
					el:	frme[v]
				,	val:(teple_objemy[v].type=='checkbox') ? teple_objemy[v].checked : teple_objemy[v].value 
				};
			}
		});
		
// prehladanim mien ziskame definicne data DRUHOV ploch a otvorov,
// ale nie ich fyzicke rozlozenie, nakolko pri menach sa nespracovava ich pocet.
// Preto musi byt vykonany nasledny beh, generujuci KAZDU PLOCHU a v nej KAZDY OTVOR,
// aby sme mali panely stavebnej skladacky:
// 	Spracujem iba plochotvory , teple plochy a objemy ma NATERAZ nezaujimaju
//	(tie pridu na radu az v pripade snahy o ich automaticke generovanie
//	pomocou oznacovania miestnosti vnutornou teplotou )

// naming : 	plocha, otvor ...  "1_1z3", "1_1z3"
//						komponent druhu 1 _ prvy z troch

		me.panely = {};
		var p=1;
		this.plochotvory.forEach( function(plocha) {
			var pocet = plocha.pocet.val;
			for (var ip=1; ip <= pocet; ip++) {	// ponechame cislovanie od 1
				var p_name = ''+p+'_'+ip+'z'+pocet+'_'+plocha.meno.val
				,	panel = me.panely[p_name] = {
					ref : plocha
				,	shapes : { subj_paths:[], clip_paths:[] }
				,	otvory : {}
				};
				var o = 1;
				if (plocha.otvory) {
					plocha.otvory.forEach( function(otvor) {
						var opocet = otvor.opocet.val;
						for (var io=1; io <= opocet; io++) {	// ponechame cislovanie od 1
							var o_name = ''+o+'_'+io+'z'+opocet+'_'+otvor.omeno.val;
							panel.otvory[o_name] = {
								ref : otvor
							,	shapes : { subj_paths:[] }	// otvor nema clip_paths
							}
						}
						o++;
					});
				}
			}
			p++;
		});
			
		return this.plochotvory;
	}

,	update : function( projekt ) {
debug_tracer_console('update', projekt);	
		this.getData();
// osadenie otions selectorov:		
		this.set_vyber_plochy(document.getElementById('special_vyber_plochu_3D', false));
		this.set_vyber_plochy(document.forms.placement_3D.elements.vyber_plochu_3D, false);
		var sel_plocha = document.forms.svg_data.elements.vyber_plocha;
		this.set_vyber_plochy(sel_plocha, true, true);
		this.analyza_rozlozenia();
		this.ukladaci_automat();
	}
,	subj_paths : []
,	clip_paths : []
//,	solution_clipper : null
,	init_subj_clip_paths : function() {
		this.subj_paths = [];
		this.clip_paths = [];
	}
,	adder_subj_paths : function( tvar ) {
		var svgg = document.querySelector('#svg_canvas svg g#plocha>g#'+tvar)	// 2D.vyber_tvar_plocha)
		,	ptvar = svgg.querySelector('path')
		,	points = path_points(ptvar,'clipper',{x:1,y:-1})
		;
		this.subj_paths.push(points);
		return points;
	}
,	adder_clip_paths : function( tvar ) {
		var svgg = document.querySelector('#svg_canvas svg g#otvory>g#'+tvar)	// 2D.vyber_tvar_plocha)
		,	ptvar = svgg.querySelector('path')
		,	points = path_points(ptvar,'clipper',{x:1,y:-1})
		;
		this.clip_paths.push(points);
		return points;
	}
,	panel_expoly_3D_SVGclip : function( defs, kresli ) {
		var pap = clipIt( this.subj_paths, this.clip_paths )
//		,	d = paths2string( pap.paths )
//		,	shapes = transformSVGPath(d)	// neurobi HOLES, treba EXPOLYGON !
		,	dd = paths2string( pap.paths.ctDifference_paths, 1, -1 )
		,	svgclipath = document.querySelector('#svg_canvas svg g#clipper>path')
		,	shapes_areas = expoly_to_shape( pap.expolygons )	//.shapes
		;
//		this.solution_clipper = pap;
		svgclipath.setAttribute('d', dd);
		var mesh = null;
		if (kresli) {
			mesh = plocha_shapes_3D(shapes_areas.shapes, defs).mesh;
		}
		return { mesh: mesh, shapes_areas: shapes_areas };
	}
,	panel_kresli_3D : function( plocha, defs ) {
		var pap = clipIt( [plocha.shapes.subj_paths], plocha.shapes.clip_paths )
		,	shapes_areas = expoly_to_shape( pap.expolygons )
		;
		var panelMOE = plocha_shapes_3D(shapes_areas.shapes, defs);
		return { panelMOE: panelMOE, shapes_areas: shapes_areas };
	}
,	clean_panelizator : function() {
		var group = app3D.panelator;
		if (group) {
			for (var i = group.children.length - 1; i >= 0; i--) {
				group.remove(group.children[i]);
			}	
		}
	}


/* Rozoberac a usporiadavatel 3D objektov
	Pri ukladani a posudzovani spravnosti definicie a ulozenia ploch a otvorov
moze nastat viacero situacii, ktore treba spracovat a navrhnut riesenie
	PLOCHA bez otvorov 
		ak je obsah = 0, alebo obvod = 0 ... problem zadania plochy
	PLOCHA s otvormi:
		_______________		obsahP - ( obsahO1 + obsahO2 ) = clip_obsahP
		|  ___  ___   |
		|  | |  | |   |		v poriadku, pokial vypocitany klipovany obsah plochy
		|  |_|  |_|   |		zodpoveda standartnemu odcitaniu obsahu otvorov od obsahu plochy
		|_____________|

	            ___ 	
		________| }____		obsahP - ( obsahO1 + obsahO2 ) < clip_obsahP
	 ___|       |_|   |     ak je vypocitany klipovany obsah vacsi ako standartny rozdiel 
	 | ||             |		otvory su umiestnene bud mimo plochy
	 |_||             |		zodpoveda standartnemu odcitaniu obsahu otvorov od obsahu plochy
		|_____________|
		
V pripade nezhody je treba identifikovat problemy:
	na strane otvorov :
		kazdy s kazdym vykonat 	OTVOR_1 INTERSECT OTVOR_2
			pokial existuje neprazdny ... hlasit prekryvanie sa u oboch 
	na strane plochy :
		s kazdym otvorom vykonat 	OTVOR INTERSECT PLOCHA
			pokial je prazdny ... hlasit otvor mimo plochu
			pokial obsah(OTVOR) > obsah(INTERSECT) ... hlasit otvor nie je cely v ploche
				a vypocitat a priradit otvoru plochu =  obsah(INTERSECT)
*/
,	analyza_rozlozenia : function( panely ) {
debug_tracer_console('analyza_rozlozenia', panely);	
		panely = panely || this.panely;
		var me = this;
		Object.keys(panely).forEach( function( meno_plochy ){
			var plocha = panely[meno_plochy]
			,	diery = [], diery_mena = []
			,	pap = clipItOne( [plocha.shapes.subj_paths], [], ClipperLib.ClipType.ctUnion )
			,	ko = (pap.area <=0) || (pap.perimeter <=0)
			,	t_Info
			;
			plocha.shapes.msg = ko ? 'plocha nemá žiadny obsah, či obvod \n' : '';
// plocha musi byt prepisana na 0			
			Object.keys(plocha.otvory).forEach( function( meno_otvoru ){
				plocha.otvory[meno_otvoru].shapes.msg = '';
				diery.push( plocha.otvory[meno_otvoru] );
				diery_mena.push(meno_otvoru); 
			});
			for(var i=0; i<diery.length; i++) {
				for(var j=i+1; j<diery.length; j++) {
					var shape_otvor_I = diery[i].shapes
					,	shape_otvor_J = diery[j].shapes
					;
					pap = clipItOne( [shape_otvor_I.subj_paths], [shape_otvor_J.subj_paths], ClipperLib.ClipType.ctIntersection );
					ko = (pap.area > 0);
					shape_otvor_I.msg += !ko ? '' : ( 'otvor '+diery_mena[i]+' sa prekrýva s otvorom '+diery_mena[j]+' \n' );
					shape_otvor_J.msg += !ko ? '' : ( 'otvor '+diery_mena[j]+' sa prekrýva s otvorom '+diery_mena[i]+' \n' );
// plocha otvoru J musi byt zmensena o rozdiel jeho plochy a INTERSECTION
				}
			}
			for(var i=0; i<diery.length; i++) {
				var shape_otvor = diery[i].shapes
				;
				pap = clipItOne( [shape_otvor.subj_paths], [plocha.shapes.subj_paths], ClipperLib.ClipType.ctIntersection );
				ko = (pap.area == 0);
				plocha.shapes.msg += !ko ? '' : ( 'plocha '+meno_plochy+' má otvor '+diery_mena[i]+' mimo seba \n' );
				shape_otvor.msg += !ko ? '' : ( 'otvor '+diery_mena[i]+' je mimo plochy '+meno_plochy+' \n' );
// plocha otvoru MIMO musi byt NULA
				pap = clipItOne( [shape_otvor.subj_paths], [plocha.shapes.subj_paths], ClipperLib.ClipType.ctDifference );
				ko = (pap.area > 0);
				plocha.shapes.msg += !ko ? '' : ( 'otvor '+diery_mena[i]+' presahuje cez plochu '+meno_plochy+' \n' );
				shape_otvor.msg += !ko ? '' : ( 'otvor '+diery_mena[i]+' presahuje cez plochu '+meno_plochy+' \n' );
// plocha otvoru musi byt zmensena o DIFFERENCE
				me.set_info_otvor(diery[i]);
			}	
			me.set_info_plocha(plocha);
		});
	}

	
,	transforFncs : {
		360	:	function(o, i, sj,vz){ // Horizontálna	
					o.position.set( 0, 0+i*1, 0 );
					o.rotation.set( +Math.PI/2, 0, 0);
				} 
	,	0	:	function(o, i, sj,vz){ // Sever	
					o.position.set( +(sj/2+5+i*1), 0, 0 );
					o.rotation.set( 0, -Math.PI/2, 0);
				} 
	,	45	:	function(o, i, sj,vz){ // Severovýchod	
					o.position.set( +(vz/2+5+i*1), 0, +(sj/2+5+i*1) );
					o.rotation.set( 0, +Math.PI/4, 0);
				} 
	,	90	:	function(o, i, sj,vz){ // Východ	
					o.position.set( 0, 0, +(vz/2+5+i*1) );
					o.rotation.set( 0, 0, 0);
				} 
	,	135	:	function(o, i, sj,vz){ // Juhovýchod	
					o.position.set( -(vz/2+5+i*1), 0, +(sj/2+5+i*1) );
					o.rotation.set( 0, -Math.PI/4, 0);
				} 
	,	180	:	function(o, i, sj,vz){ // Juh	
					o.position.set( -(sj/2+5+i*1), 0, 0 );
					o.rotation.set( 0, -Math.PI/2, 0);
				} 
	,	225	:	function(o, i, sj,vz){ // Juhozápad	
					o.position.set( -(vz/2+5+i*1), 0, -(sj/2+5+i*1) );
					o.rotation.set( 0, -Math.PI/4*3, 0);
				} 
	,	270	:	function(o, i, sj,vz){ // Západ	
					o.position.set( 0, 0, -(vz/2+5+i*1) );
					o.rotation.set( 0, 0, 0);
				} 
	,	315	:	function(o, i, sj,vz){ // Severozápad	
					o.position.set( +(vz/2+5+i*1), 0, -(sj/2+5+i*1) );
					o.rotation.set( 0, -Math.PI/4, 0);
				} 
	} 	
/* ukladaci automat ma na starosti ukladanie ploch akoby panelov 
a otvorov v plochach = paneloch automaticky tak, aby co najmenej dochadzalo
jednak k prekryvaniu otvorov v paneli,
jednak k ukladaniu panelov podla ich orientacie tak, akoby sa staval domcek
od zakladov.
	Predpoklada sa teda zadavanie vonkajsej obalky rieseneho objektu 
od najspodnejsej podlahy, nasledne jej obvodove steny, stropy prizemia
a znova obvodove steny 1.-podlazia, strop nad nimi .... atd az po strechu

	Ukladanie otvorov v paneli:
	-----------------------------
default nastavenie pozicie otvoru (kazdeho tvaru) je na X,Y 1m, 1m
Pokial sa pozicia ktorehokolvek otvoru prestavi rucne, 
panel dostane signalku IWI (I Want It) a automat sa nebude zaoberat
snahou o  automatizovane pozicionovanie ziadnou zmenou hodnot ani na ploche,
ani na otvoroch (...TODO spravit signalku zrusenie IWI v snahe o auto rozklad).
Automatizovane rozkladanie funguje nasledovne:
	Vsetko sa bude odvijat od BR(boundng rectangle) jednotlivych komponentov,
t.j. panelu samotneho a jemu priradenym otvorom.
Automaticke skladanie je skladanie BR komponentov, nezavisle od ich
skutocneho tvaru - na upresnenie ma uzivatel dostatocne editacne prostriedky.
	Zakladnu vysku od spodneho okraja panelu urcime na default 1m
Prvy otvor umiestnime na default vysku (od BR(panel).bottom) 
a odstup od BR(panel).left - laveho okraja [1,1] 
urcime jeho BR a druhy otvor sa pokusime umiestnit 1m od BR.right, pokial
BR(predosly_otvor).right + 1 + BR(aktualny_otvor).width < BR(panel).width 
t.j. pokial vpravo od predosleho otvoru (+1m) je dost miesta na aktualny otvor.
	Popritom vyratavame 
najvyssi_vrch_otvorov = MAX(najvyssi_vrch_otvorov + BR(otvor).height) 
Pokial nie je napravo dost miesta, skontrolujeme, ci nepresahujeme vrch panelu
	BR(panel).top > najvyssi_vrch_otvorov
Pokial nepresahujeme, zvysime vysku na najvyssi_vrch_otvorov + 1m
	a pokracujeme znova umiestnovanim otvorov od BR(panel).left + 1m
Ak presahujeme, jednoducho dalej ukladame otvory v dosial dosiahnutej vyske
vpravo s odstupom 1m nezavisle na presahovani cez BR(panel).right

	Ukladanie panelov:
	--------------------
Pokial prvym definovanym panelom BUDE horizontalna PODLAHA,
umiestnime ju na aktualnu_vyskovu_uroven 0 pre druh konstrukcie PVT 11
a default -1m pre PVT 12.
	Podlaha by mala zarucovat miesto steny podla SVJZ orientacie.
Panely na strane prislusnej orientacie budeme umiestnovat
podobnym principom na zaklade BR ako otvory v paneli:
	Lavy spodny roh = Bottom-left corner BR(panel) 
umiestnime na poziciu LAVEHO rohu BR(podlaha), prislusiacemu
podla orientacie panelu. 
	Dalsi panel umiestnime bez odstupu na poziciu 
nPos = BR(podlaha).LeftCornerOrient + BR(predchadzajuci_panel).width
pokial plati, ze nebudeme presahovat
BR{podlaha).withOrient > nPos + BR(aktualny_panel).width
Priebezne vypocitavame vysku ako 
najvyssi_vrch_panelov = MAX(najvyssi_vrch_panelov + BR(panel).height) 
Pokial nastane presah, zvysime vysku na najvyssi_vrch_panelov
a znova zacneme umiestnovat od BR(podlaha).LeftCornerOrient

	Kazda dalsia horizontalna plocha (PSS 2, SVP 3, SNP 4, VDH 6, VHD 7, PV1 11, PV2, 12)
sa bude ukladat na aktualny najvyssi_vrch_panelov (ak je uz nastaveny)
alebo na aktualnu_vyskovu_uroven + priemerna_vyska_podlazi
 
	Startovacia situacia (pre dalsie vylepsenia) :
Vsetky	horizontalne panely naukladam do stredu nad seba
a na okraj mriezky na prislusne stredy stran a rohy
naukladam vedla seba vsetky zvisle panely.
	Nasledne sa pokusim urobit prostriedok pre rucne lepenie panelov
tak, ze budem oznacovat HRANY (prva ... kam prilepit, druha ... co prilepit)

[ Tu vznika este otazka, ako maju byt urcovane rozmery panelov 
a tym, kde vlastne sa maju spajat.
Dohodneme sa tak, ze spojnicou bude VZDY stred hrany, t.j. hrubka panelu / 2
___  os spojnice   os spojnice  ___ / spolocna spojnica
  /|/            _/_ 		      /L
 / |            /  /|            ///
/ /	           /  / |           ///
 /		      /  /
 
 Matematicky by to malo fungovat tak, ze sa vypocita usecka spojnice 
 na paneli, KU KTOREMU ideme prilepovat = HOTOVY_PANEL,
 os spojnice na paneli, KTORY ideme prilepovat = LEPENY_PANEL
 a vypocitame transformaciu = translate, rotate pre LEPENY_PANEL
 tak, aby osi spojnic splynuli
 
var quaternion = new THREE.Quaternion(); // create one and reuse it
quaternion.setFromUnitVectors( v1, v2 ); 
//	var matrix = new THREE.Matrix4(); // create one and reuse it
//	matrix.makeRotationFromQuaternion( quaternion );
//	object.applyMatrix( matrix );
object.applyQuaternion( quaternion );
]	
*/
,	ukladaci_automat : function( panely ) {
debug_tracer_console('ukladaci_automat', panely);	
		panely = panely || this.panely;
		this.clean_panelizator();
		var frme = document.forms.placement_3D.elements
		,	me = this
		,	p_vyska = 0
		,	sj = parseFloat(frme.grid_X.value)
		,	vz = parseFloat(frme.grid_Z.value)
		,	orient_idx = {360:0,0:0,45:0,90:0,135:0,180:0,225:0,270:0,315:0}
		;
		Object.keys(panely).forEach( function( meno_plochy, idx ){
			Name3D_rgxp.lastIndex = 0;
			var plocha = panely[meno_plochy]
			,	orient = plocha.ref.orient.val
			,	matches = Name3D_rgxp.exec(meno_plochy)
			,	idx = matches && (matches[2]-1) || 0
			,	tvar2D3D = JSON5.parseOr( plocha.ref.tvar2D3D.val, {} )
			,	pos3D = tvar2D3D.tvar3D && tvar2D3D.tvar3D.pole &&  tvar2D3D.tvar3D.pole[idx] 
			,	trans = null
			;
	// konverzia zo starej ne POLE definicie tvar3D - cka:
	if ( isEmp(pos3D) 
		&& ( (tvar2D3D.tvar3D && tvar2D3D.tvar3D.position) 
			|| isDef(tvar2D3D.tvar3D && tvar2D3D.tvar3D.rotation) 
	)	) {
		tvar2D3D.tvar3D.pole = tvar2D3D.tvar3D.pole || [];
		pos3D = tvar2D3D.tvar3D.pole[idx] = {
			color : tvar2D3D.tvar3D.color
		,	position : tvar2D3D.tvar3D.position
		,	rotation : tvar2D3D.tvar3D.rotation
		};
		delete tvar2D3D.tvar3D.color;
		delete tvar2D3D.tvar3D.position;
		delete tvar2D3D.tvar3D.rotation;
	}
	
			if ( ! isEmp(pos3D) ) {	// pokial uzivatel menil 3D transformaciu, 
//pouzijeme jeho zapamatane zadanie
				trans = function(o, i, sj,vz) {
					o.children[0].material.color.set(pos3D.color);
					o.position.set( pos3D.position.x, pos3D.position.y, pos3D.position.z );
					o.rotation.set( pos3D.rotation._x, pos3D.rotation._y, pos3D.rotation._z );
				}
			} else {	// pokial nie je uzivatelom uz editovane, riesime
// pouzivame definicie z VykurTeplo_kalkul.js (pre rozlisenie druhu a orientacie)
// doplnene o zakladnu formu transformacie podla druhu a orientacie
		//		var v = plocha.ref
		//		,	a_d_k = abbr_druh_konstrukcie.find( function(f) {
		//				return f.val == v.druh_plochy.val;
		//			})	//	[v.druh_plochy.val-1]
		//		,	a_o = abr_orientacia.find( function(f) {
		//				return f.val == v.orient.val;
		//			})
		//		;
				trans = me.transforFncs[orient];
			}
			
			var panelG = me.panel_kresli_3D(plocha, {name:meno_plochy} ).panelMOE.panel;
			if (typeof trans == 'function') {
				trans(panelG, orient_idx[orient]++, sj, vz);
			}
		});
}
	
/// metoda set_vyber_plochy vyplni selektor ploch a spusti onchange
/// selektorom moze byt vyberatko plochy pre SVG definiciu
///		document.forms.svg_data.elements.vyber_plocha
/// ale aj vyberatko plochy na 3D manipulaciu: 
///		document.forms.placement_3D.elements.vyber_plochu_3D
,	set_vyber_plochy : function( sel, through, gotvar ) {
debug_tracer_console('set_vyber_plochy', sel, through);	
		if (sel) {
			do {
				sel.options.remove(0);
			} while (sel.options.length);
			
			var mena_ploch = Object.keys(this.panely);
			for (var i=0; i < mena_ploch.length; i++) {
				var meno_plochy = mena_ploch[i]
				,	plocha = this.panely[meno_plochy]
				,	opt = new Option(meno_plochy)	//,i)
				;
				if (plocha.ref.obal.val) {
					opt.classList.add('obal');
				}
				sel.options.add(opt);
				if (through) {
					sel.selectedIndex = i;
					this.set_vyber_otvory(sel.form.elements.vyber_otvory, opt.text, through);
					this.set_tvar_plocha(sel);
				}
			}
			sel.selectedIndex = Math.min(this.actual_sel_plocha, sel.options.length - 1);
			sel.title = (sel.selectedIndex > -1) ? sel.options[sel.selectedIndex].text : '';	//	sel.title = sel.value;	ani value sa nenastavi okamzite po selectedIndex !!!
			
			if (gotvar) {
// vytvorenie event-u nezarucuje okamzite vykonanie	!			
// a potrebujem zabezpecit, aby vo vykonavani ostatnych onchange eventov
// boli vyplnene option selektora otvorov
				svg_tvar_handler(sel);	//aFireEvent(sel,'change');	//this.set_vyber_otvory(sel.form.elements.vyber_otvory, sel.options[sel.selectedIndex].text)
				// =	stavitel.set_vyber_otvory(frme.vyber_otvory, inp.options[inp.selectedIndex].text );
				// =	stavitel.set_tvar_plocha(inp);
			}
		}
		return sel;
	}

/// metoda set_vyber_otvory (volana v onchange vyber_plochy) 
/// vyplni selektor ploche prislusnych otvorov a spusti onchange
,	set_vyber_otvory : function(sel, meno_plochy, through) {
debug_tracer_console('set_vyber_otvory', sel, meno_plochy, through);	
		if (sel) {
			do {
				sel.options.remove(0);
			} while (sel.options.length);
			var otvory = this.panely[meno_plochy].otvory
			,	mena_otvorov = Object.keys(otvory)
			;
			for (var i=0; i<mena_otvorov.length; i++) {
				var meno_otvoru = mena_otvorov[i]
				,	otvor = otvory[meno_otvoru]
				,	opt = new Option(meno_otvoru)	//,i)
				;
				if (otvor.ref.osolar.val) {
					opt.classList.add('osolar');
				}
				sel.options.add(opt);
				if (through) {
					sel.selectedIndex = i;
					this.set_tvar_otvory(sel, meno_plochy);
				}
			}
			sel.selectedIndex = Math.min(this.actual_sel_otvor, sel.options.length - 1);
			sel.title = (sel.selectedIndex > -1) ? sel.options[sel.selectedIndex].text : '';	//	sel.title = sel.value;	ani value sa nenastavi okamzite po selectedIndex !!!
debug_tracer_console('set_vyber_otvory ... sel.selectedIndex:', sel.selectedIndex, meno_plochy, through);	
			svg_tvar_handler(sel);	//aFireEvent(sel,'change');
debug_tracer_console('set_vyber_otvory/svg_tvar_handler ... sel.selectedIndex:', sel.selectedIndex, meno_plochy, through);	
				// =	stavitel.set_tvar_otvory(inp, frme.vyber_plocha.value);
		}
		return sel;
	}

,	set_info_plocha : function( plocha ) {
		var msg = plocha && plocha.shapes.msg || '';
		if (plocha) {
			t_Info = nearestParent( plocha.ref.plocha.el, 'tr' ).querySelector('.t_Info');
			t_Info.title = msg;	t_Info.classList[msg ? 'add':'remove']('warn3D');
		}
		t_Info = document.forms.svg_data.querySelector('table.tbl_plocha .t_Info');
		t_Info.title = msg;	t_Info.classList[msg ? 'add':'remove']('warn3D');
	}
/// metoda set_tvar_plocha nastavi SVG tvar a tabulku hodnot
/// podla ulozenej definicie tvaru, resp. podla default OBDLZNIK tvaru
/// spustenim :
/// 1. stavitel.update
///	2. onchange zadavacich inputov
,	set_tvar_plocha : function( sel, plocha_value ) {
debug_tracer_console('set_tvar_plocha', sel, plocha_value);	
		var meno_plochy = plocha_value || sel.value
		,	po = this.panely[meno_plochy]
		,	plocha_ref = po.ref
		,	tvar2D3D = JSON5.parseOr( plocha_ref.tvar2D3D.val, {})
		,	tvar2D = tvar2D3D.tvar2D
		,	frme = sel.form.elements	// document.forms.svg_data
		;
		if (tvar2D) {	// podla tvarovej definicie
			if (tvar2D.vyber_tvar_plocha == 'obdlznik') {
				tvar2D.obdlznik_plocha_usek_AyBy_By_Cy = plocha_ref.sirka.val;
				tvar2D.obdlznik_plocha_usek_AxDx_Dx_Cx = plocha_ref.dlzka.val;
			}
		} else {	// inak default obdlznik
			tvar2D = tvar2D3D.tvar2D = {	
				vyber_tvar_plocha : 'obdlznik'
			,	obdlznik_plocha_usek_AyBy_By_Cy : plocha_ref.sirka.val
			,	obdlznik_plocha_usek_AxDx_Dx_Cx : plocha_ref.dlzka.val
			}
		}
		var defs = {
				name : sel.options[sel.selectedIndex].text
			,	order : sel.value
			,	tvar2D3D : tvar2D3D
			}
		;
		Object.keys(tvar2D).forEach( function(v) {
			if (isDef(frme[v])) {
				frme[v].value = tvar2D[v];
				svg_tvar_handler(frme[v]);	//aFireEvent(frme[v],'change');
			}
		})
		this.init_subj_clip_paths( meno_plochy );
		var points = this.adder_subj_paths( tvar2D.vyber_tvar_plocha, meno_plochy );
		
		po.shapes.subj_paths = points;
		if (po.otvory) {
			var selo = frme.vyber_otvory
			,	mena_otvorov = Object.keys(po.otvory)
			;
			for(var i = 0; i < mena_otvorov.length; i++) {
				selo.selectedIndex = i;
			//	selo.title = selo.value;	ani value sa nenastavi okamzite po selectedIndex !!!
				selo.title = (selo.selectedIndex > -1) ? selo.options[selo.selectedIndex].text : '';
				svg_tvar_handler(selo);	//aFireEvent(selo,'change', selo.options[si].text);
			}				
// toto prepisuje odpamatane nastavenie, platne po set_vyber_otvory
			selo.selectedIndex = Math.min(this.actual_sel_otvor, selo.options.length - 1);
			selo.title = (selo.selectedIndex > -1) ? selo.options[selo.selectedIndex].text : '';
			svg_tvar_handler(selo);	//aFireEvent(sel,'change');
debug_tracer_console('set_tvar_plocha OTVORY ... sel.selectedIndex:', selo.selectedIndex, meno_plochy);	
		}
		po.shapes.clip_paths = JSON.parse(JSON.stringify(this.clip_paths));
		
		var defs = { name:meno_plochy }	// hrubka, name
		,	panel3D = this.panel_expoly_3D_SVGclip( defs, false )	// nekresli
		,	expoliesAP = panel3D.shapes_areas.areas_perimeter
		,	obsah = 0, obvod = 0
		;
		expoliesAP.forEach( function(ap) {
			obsah += ap.obsah;
			obvod += ap.obvod;
		});
//console.log(defs, panel3D.shapes_areas.areas_perimeter);
/* teoreticky aj prakticky mozu HOLES rozsekat povodne celistvu plochu na viacero
samostatnych EXpolygon casti ... preto radsej pre vseobecnost spocitam plochy 
a obvody celeho pola ...
*/
		tvar2D3D.tvar2D.areas_perimeter = {
			obsah : obsah
		,	obvod : obvod
//		,	areas : expoliesAP
		}
		plocha_ref.tvar2D3D.el.value = plocha_ref.tvar2D3D.val = JSON.stringify(tvar2D3D);
//	osetrenie vypoctu plochy a obvodu podla tvaru :
		var z3D = plocha_ref.z3D.el.checked = plocha_ref.z3D.val = (tvar2D3D.tvar2D.vyber_tvar_plocha != 'obdlznik');
		plocha_ref.dlzka.el.style.display = z3D ? 'none' : '';
		plocha_ref.sirka.el.style.display = z3D ? 'none' : '';
		plocha_ref.fix_dlzka.el.style.display = z3D ? '' : 'none';
		plocha_ref.fix_sirka.el.style.display = z3D ? '' : 'none';
		if (z3D) {
			plocha_ref.fix_dlzka.el.value = plocha_ref.fix_dlzka.val = 1;
		//		var v = plocha.ref
		//		,	a_d_k = abbr_druh_konstrukcie.find( function(f) {
		//				return f.val == v.druh_plochy.val;
		//			})	//	[v.druh_plochy.val-1]
			plocha_ref.fix_sirka.el.value = plocha_ref.fix_sirka.val = obsah;
			plocha_ref.fix_plocha.el.value = obsah;			
		}
		if (plocha_ref.druh_plochy.val >= 11) {	// PV1_11, PVT_12
			var konstrukcia = JSON5.parseOr(plocha_ref.konstrukcia.val,{})
			,	Uval = plocha_ref.u	// viditelna a platna hodnota
			,	pt = podlaha_na_terene( {
					plocha : obsah
				,	obvod : obvod
				,	hrubka : (konstrukcia.hrubka || 300)  / 1000	// z mm na metre
				,	Uval : konstrukcia.Uval || 0.15 // ???? co sem dat ?????
				,	rf : konstrukcia.Rval || ( 1 / konstrukcia.Uval )	// cca bez  rsi a rse
				} )
			;
// fix_u predstavuje podla faktora tvaru korigovanu hodnotu U podlahy
			plocha_ref.fix_u.el.value = plocha_ref.fix_u.val = pt.u_koef;
		}
		this.set_info_plocha(po);
	}

,	rgxp_bod_XY : /_bod_(\w)([xy])_/gim
//	,	rgxp_bodA_XY : /_bod_A([xy])_/gim
,	get_tvar_bodA_XY : function(tvar2D, xy) {
		var names = Object.keys(tvar2D)
		,	le = names.length
		,	rxy = /_bod_A([xy])_/gim	//	this.rgxp_bodA_XY
		,	matches, retval
		;
		for (var i=0; i<le; i++) {
			rxy.lastIndex = 0;
			matches = rxy.exec(names[i]);
			if (matches && matches[1] == xy) {
				retval = tvar2D[names[i]];
				break;
			}
		}
		return retval;
	}	
	
,	set_info_otvor : function( otvor ) {
		var msg = otvor && otvor.shapes.msg || ''
		,	t_Info
		;
		if (otvor) {
			t_Info = nearestParent( otvor.ref.oplocha.el, 'tr' ).querySelector('.t_Info');
			t_Info.title = msg;	t_Info.classList[msg ? 'add':'remove']('warn3D');
		}
		t_Info = document.forms.svg_data.querySelector('table.tbl_otvory .t_Info');
		t_Info.title = msg;	t_Info.classList[msg ? 'add':'remove']('warn3D');
	}
/// metoda set_tvar_otvory nastavi SVG tvar a tabulku hodnot
/// podla ulozenej definicie tvaru, resp. podla default OBDLZNIK tvaru
/// spustenim :
/// 1. stavitel.update
///	2. onchange zadavacich inputov
,	set_tvar_otvory : function( sel, meno_plochy, otvor_value ) {
debug_tracer_console('set_tvar_otvory', sel, meno_plochy, otvor_value);	
		Name3D_rgxp.lastIndex = 0;
		var plo = this.panely[meno_plochy]
		,	otv = plo.otvory
		,	meno_otvoru = otvor_value || sel.value
		,	matches = Name3D_rgxp.exec(meno_otvoru)
		,	idx = matches && (matches[2]-1) || 0	
			//sel.selectedIndex ... nemoze byt v moznej kombinacii druhov okien !!!
		,	po
		,	frme = sel.form.elements	// document.forms.svg_data
		;
		if (otv && meno_otvoru) {
			po =  otv[meno_otvoru];
			var otvor_ref = po.ref
			,	opocet = parseFloat(otvor_ref.opocet.val)
			,	tvar2D = JSON5.parseOr( otvor_ref.tvar2D.val, null )
			;
			if (tvar2D) {	// podla tvarovej definicie
		// ale je nutne osetrit prepnutie naspat na obdlznik so zmenou sirka vyska
				if (tvar2D.vyber_tvar_otvory == 'obdlznik') {
					tvar2D.obdlznik_otvory_usek_AyBy_By_Cy = otvor_ref.ovyska.val;
					tvar2D.obdlznik_otvory_usek_AxDx_Dx_Cx = otvor_ref.osirka.val;
				}
			} else {	// inak default obdlznik
				tvar2D = {	
					vyber_tvar_otvory : 'obdlznik'
				,	obdlznik_otvory_bod_Ax_Bx_Cx_Dx : 0
				,	obdlznik_otvory_bod_Ay_By_Cy_Dy : 0
				,	obdlznik_otvory_usek_AyBy_By_Cy : otvor_ref.ovyska.val
				,	obdlznik_otvory_usek_AxDx_Dx_Cx : otvor_ref.osirka.val
				}
			}
// osetrovacky nasobnych otvorov ====================================	
// vsunute sem kvoli potrebe osetrenie zakladneho stavu tvar2D,
// podmieneneho formou tvaru
		
			if ( ! isArr(tvar2D.pole)) {	// pokus o osetrenie kompatibility z bez POLE oveho ulozenia projektu
				tvar2D.pole = [{	x: 1,	y: 1	}];		// len tak nejaky offset
			}
			for(var i=0; i<opocet; i++) {
	// okna rozlozime len tak do riadku s odstupom 2 metre
				tvar2D.pole[i] = tvar2D.pole[i] || {x:1+i*2,y:1};
			}
	// pokial je povodne pole vacsie (po znizeni poctu okien), zmensime ho
			var pl = tvar2D.pole.length;
			for(var i=pl-1; i>=opocet; i--) {
				tvar2D.pole.pop();
			}
	// zakladna definicia druhu otvoru je pre vsetky v zostave rovnaka
	// a teda staci mi pocitat s default (1,1) definiciou tvaru 
	// pre potreby najdenia obvodu a obsahu
// osetrovacky nasobnych otvorov ------------------------------------			
			var rxy = this.rgxp_bod_XY, matches
			Object.keys(tvar2D).forEach( function(v) {
				if (isDef(frme[v])) {
					rxy.lastIndex = 0; matches = rxy.exec(v);
					if (matches) {
						var xy = matches[2];
						frme[v].value = +tvar2D[v]+ tvar2D.pole[idx][xy]
					} else {
						frme[v].value = tvar2D[v];
					}
					svg_tvar_handler(frme[v]);	//aFireEvent(frme[v],'change');
				}
			})		
			var points = this.adder_clip_paths( tvar2D.vyber_tvar_otvory, meno_plochy, meno_otvoru )
			,	pap = clipIt( [points], [] )
			,	obsah = pap.areaDiff, obvod = pap.perimeter
			;		
			po.shapes.subj_paths = points;
			
			tvar2D.area_perimeter = {
				obsah : obsah
			,	obvod : obvod
			}
			otvor_ref.tvar2D.el.value = otvor_ref.tvar2D.val = JSON.stringify(tvar2D);
			// preniest hodnoty obsahu a obvodu (do titulku)
			// (v pripade neobdlznikoveho tvaru aktualizovat hodnoty dlxka x sirka na 1 x obsah)
//	osetrenie vypoctu plochy a obvodu podla tvaru :
			var z3D = otvor_ref.oz3D.el.checked = otvor_ref.oz3D.val = (tvar2D.vyber_tvar_otvory != 'obdlznik');
			otvor_ref.osirka.el.style.display = z3D ? 'none' : '';
			otvor_ref.ovyska.el.style.display = z3D ? 'none' : '';
			otvor_ref.fix_osirka.el.style.display = z3D ? '' : 'none';
			otvor_ref.fix_ovyska.el.style.display = z3D ? '' : 'none';
			if (z3D) {
				otvor_ref.fix_osirka.el.value = otvor_ref.fix_osirka.val = 1;
				otvor_ref.fix_ovyska.el.value = otvor_ref.fix_ovyska.val = obsah;			
			}
		} else {
			frme['vyber_tvar_otvory'].selectedIndex = 0;	// ziadny
			svg_tvar_handler(frme['vyber_tvar_otvory']);	//aFireEvent(frme[v],'change');
		}
		this.set_info_otvor(po);
	}

,	actual_sel_plocha : 0
,	actual_sel_otvor : 0
,	store_actual_vybery : function() {
		this.actual_sel_plocha = document.forms.svg_data.elements.vyber_plocha.selectedIndex;
		this.actual_sel_otvor = document.forms.svg_data.elements.vyber_otvory.selectedIndex;		
debug_tracer_console('store_actual_vybery', this.actual_sel_plocha, this.actual_sel_otvor);	
	}
/// metoda store_tvar_plocha reaguje na tlacitko OK a uklada
/// definiciu tvaru do riadku vybranej plochy - textarea[name=tvar2D3D]
,	store_tvar_plocha : function( evt ) {
debug_tracer_console('store_tvar_plocha', evt);	
		var el = (evt instanceof Event) ? evt.target : evt
		,	frme = el.form.elements
		,	plocha = frme.vyber_plocha.value
		,	trs = stored_svg_tvar.plocha_trs
		,	tvar2D = {
				vyber_tvar_plocha : frme.vyber_tvar_plocha.value
			,	rot_plocha : frme.rot_plocha.value
			}
		;
		this.store_actual_vybery();
		if (plocha && trs) {
			trs.forEach( function(v) {
				v.queryXpath('.//*[@name]', function(o) {
					tvar2D[o.name] = o.value;
				});
			});
			var po = this.panely[plocha]
			,	tvar2D3D = JSON5.parseOr(po.ref.tvar2D3D.val,{})
			;
			tvar2D3D.tvar2D = tvar2D;
			po.ref.tvar2D3D.el.value = JSON5.stringify(tvar2D3D);
		}
		this.update();
		return tvar2D;
	}

/// metoda store_tvar_otvory reaguje na tlacitko OK a uklada
/// definiciu tvaru do riadku vybraneho otvoru - textarea[name=tvar2D]
,	store_tvar_otvory : function( evt ) {
debug_tracer_console('store_tvar_otvory', evt);	
		Name3D_rgxp.lastIndex = 0;
		var el = (evt instanceof Event) ? evt.target : evt
		,	frme = el.form.elements
		,	plocha = frme.vyber_plocha.value
		,	otvor = frme.vyber_otvory.value
		,	matches = Name3D_rgxp.exec(otvor)
		,	idx = matches && (matches[2]-1) || 0
		,	trs = stored_svg_tvar.otvory_trs
//		,	base_tvar = frme.base_tvar.checked
		;
		this.store_actual_vybery();
		if (plocha && otvor && trs) {
			var po = this.panely[plocha].otvory[otvor]
			,	el_tvar2D = po.ref.tvar2D.el
			,	tvar2Dact = JSON5.parseOr(po.ref.tvar2D.val,{})
			,	tvar2D = {
					vyber_tvar_otvory : frme.vyber_tvar_otvory.value
				,	rot_otvory : frme.rot_otvory.value
				,	pole : tvar2Dact.pole
				}
			;
// najprv musim nacitat aktualne hodnoty : 
			trs.forEach( function(v) {
				v.queryXpath('.//*[@name]', function(o) {
					var val = parseFloat(o.value);
					val =  isNbr(val) ? val : 0;	// osetrenie vadneho zadania cisla
					tvar2D[o.name] = o.value;
				});
			});
// offset v POLE bude VZDY rovny vo formulari zadanemu bodu A:
			tvar2D.pole[idx].x = +this.get_tvar_bodA_XY(tvar2D,'x');
			tvar2D.pole[idx].y = +this.get_tvar_bodA_XY(tvar2D,'y');
// a formularom zadane hodnoty bodov sa prepocitaju spatnaou transpoziciou
// t.j. odcitanim offsetu:
			var rxy = this.rgxp_bod_XY;
			Object.keys(tvar2D).forEach( function(v) {
				rxy.lastIndex = 0; matches = rxy.exec(v);
				if (matches) {
					var xy = matches[2];
					tvar2D[v] -= tvar2D.pole[idx][xy];
				}
			});
			el_tvar2D.value = JSON5.stringify(tvar2D);
		}
		this.update();
		return tvar2D;
	}

///	metoda special_action vykonava vybranu aktivitu na vybranymi panelmi
,	special_action : function( evt, r_action, r_forma ) {
		var el = (evt instanceof Event) ? evt.currentTarget : evt
		,	par = el.parentNode
		,	sel_panely = par.querySelector('#special_vyber_plochu_3D')
		,	sel_action = par.querySelector('#aktivita_3D_druh')
		,	sel_forma = par.querySelector('#aktivita_3D_forma')
		,	action = r_action || sel_action && sel_action.value
		,	forma = r_forma || sel_forma && sel_forma.value
		;
		for (var i=0; i<sel_panely.options.length; i++) {
			var opt = sel_panely.options[i]
			,	osel = opt.selected
			,	panel = app3D.scene.getObjectByName(opt.value)
			;
			if (!osel || !panel) continue;
			var pbody = panel.children[0];
			switch(action+'_'+forma) {
				
				case 'hideview_set': {
					pbody.visible = true;
					break; }
				case 'hideview_reset': {
					pbody.visible = false;
					break; }
				case 'hideview_switch': {
					pbody.visible = !pbody.visible;
					break; }
					
				case 'transpar_set': {
					pbody.material.opacity = 0.5;
					pbody.material.transparent = true;
					break; }
				case 'transpar_reset': {
					pbody.material.opacity = 1;
					pbody.material.transparent = false;
					break; }
				case 'transpar_switch': {
					pbody.material.opacity = pbody.material.transparent ? 1 : 0.5;
					pbody.material.transparent = !pbody.material.transparent;
					break; }
					
/*				case 'depozite_set': {
					break; }
				case 'depozite_reset': {
					break; }
				case 'depozite_switch': {
					break; }	*/
			}
//	console.log({v:pbody.visible,t:pbody.material.transparent,o:pbody.material.opacity});
		}
	}
}


///</section>

///<section name="svg_tvar_handler">

/// funkcia svg_dep_set_value osadzuje hodnoty number input-ov
/// presne podla suradnic bodov v aktualnom SVG tvare
function svg_dep_set_value(inp, points) {
	var name = inp.name, aval
	,	tags = name.split('_'), start = 3
//	,	tvar = tags[0]
//	,	plo_otvo = tags[1]
	,	bod_usek = tags[2]
	;
	switch(bod_usek) {
		case 'usek':
// usek sa VZDY ocakava ratat IBA medzi rovnakymi koordinatmi x, resp. y
			var sek = tags[start]
			,	i1_ref = sek.charCodeAt(0) - 65
			,	xy1 = (sek[1].toLowerCase() == 'x') ? 0:1
			,	i2_ref = sek.charCodeAt(2) - 65
			,	xy2 = (sek[3].toLowerCase() == 'x') ? 0:1
			,	aval = Math.abs( points[ 2 * i2_ref + xy2 ] - points[ 2 * i1_ref + xy1 ] )
			;
			break;
		case 'bod':
			var ref_bod = tags[start]
			,	i_ref = ref_bod.charCodeAt(0) - 65	// 65 = 0x41 = 'A'.charCodeAt(0)
			,	coord = ref_bod.toLowerCase()[1]
			,	xy = (coord == 'x') ? 0 : 1
			,	aval = points[ 2 * i_ref + xy ]
			;
			break;
	}
	inp.value = aval;
}

/// funkcia switch_tvar prepina viditelnost SVG tvarov
/// a tabulkovych riadkov podla vybraneho tvaru
/// automaticky rozoznava, ci ide o tvar plocha, alebo otvory
/// a tiez rovno vola nastavenie spravnych hodnot (svg_dep_set_value)
/// zobrazene riadky tabulky list-uje v 'stored_svg_tvar'
function switch_tvar( inp, plo_otvo ) {
	var svggs = document.querySelectorAll('#svg_canvas svg g#'+plo_otvo+'>g')
	,	svgg
	,	tbltrs = inp.form.querySelectorAll('table.tbl_'+plo_otvo+' tbody tr')
	,	trs = []
	,	val = inp.value
	;
	for(var i=0;i < svggs.length;i++) {
		if (svggs[i].id == val) {
			svggs[i].style.display = '';
			svgg = svggs[i];
		} else {
			svggs[i].style.display = 'none';
		}
	}	
// zaroven je vhodne naplnat tabulu spravnymi hodnotami:
	var ptvar = svgg.querySelector('path')
	,	points = path_points(ptvar,__,{x:1,y:-1})
	,	inps 
	;
	for(var i=0;i < tbltrs.length;i++) {
		if (tbltrs[i].classList.contains(val)) {
			trs.push( tbltrs[i] );
			tbltrs[i].style.display = 'table-row';
			inps = tbltrs[i].querySelectorAll('input[type=number]');
			for(var j=0;j < inps.length;j++) {
				svg_dep_set_value( inps[j], points );
			}
		} else {
			tbltrs[i].style.display = 'none';
		}
	}
	stored_svg_tvar[plo_otvo+'_trs'] = trs;
	return { g:svgg, trs:trs };
}

var stored_svg_tvar = {
	plocha : null
,	otvory : null
,	plocha_trs : null	// zobrazene zadavacie riadky pre tvar plocha
,	otvory_trs : null	// zobrazene zadavacie riadky pre tvar orvory
};

/// centralna ONCHANGE funkcionalita pre SVG tvary a prepinace
function svg_tvar_handler(evt) {
	var inp = (evt instanceof Event) ? evt.target : evt
	,	type = inp.type
	,	name = inp.name
	,	val = inp.value
	,	frm = inp.form
	;
	if (! frm)	return;
debug_tracer_console('svg_tvar_handler', type, name);	
	
	var	frme = frm && frm.elements
	,	plo_otvo = nearestParent(inp,'table').className.replace('tbl_','') 
	;
	switch (type) {
		case 'select-one': {
			switch (name) {
				case 'vyber_plocha':		
					stavitel.set_vyber_otvory(frme.vyber_otvory, inp.options[inp.selectedIndex].text );
					stavitel.set_tvar_plocha(inp);
					break;
				case 'vyber_tvar_plocha':
					var svgg = switch_tvar(inp, plo_otvo).g;	//document.querySelector('#svg_canvas svg g#plocha>g#'+val);
					stored_svg_tvar.plocha = svgg.innerHTML;
					break;
				case 'rot_plocha':			break;
				case 'vyber_otvory':		
					stavitel.set_tvar_otvory(inp, frme.vyber_plocha.value);
					break;
				case 'vyber_tvar_otvory':	
					var svgg = switch_tvar(inp, plo_otvo).g;	//document.querySelector('#svg_canvas svg g#otvory>g#'+val);
					stored_svg_tvar.otvory = svgg.innerHTML;
					break;
				case 'rot_otvory':			break;
			}
//			this.analyza_rozlozenia( ??? )
//			this.set_info_plocha(po ??? );
			break;
		}
		case 'checkbox': 
			switch (name) {
				case 'hide_tvar':
					document.querySelector('div#svg_canvas svg g#plocha').style.display = 
						inp.checked ? 'none' : '';
					document.querySelector('div#svg_canvas svg g#clipper').style.display = 
						inp.checked ? '' : 'none';
					break;
//				case 'base_tvar':
// TODO				
//					break;
			}
			break;
		case 'number':
			svg_dep_edit(name, val);
//			this.analyza_rozlozenia( ??? )
//			this.set_info_plocha(po ??? );
			break;
	}
/*
ttt = 'ABCDEFGHIJKL';
for(var i=0;i<ttt.length;i++) {
console.log(ttt.charCodeAt(i) - 65);
}	//	0,1,2,3,4,5,6,7,8,9,10,11
*/
}

/// funkcia path_points rozobera PATH D definiciu do pola koordinatov
function path_points( ptvar, format, scale /* {x:1,y:-1} */) {
	var	points = [];
	if (ptvar) {
		points = ptvar.getAttribute('d').split(/[^-\+\d\.]+/g);
		points.shift();	// prve je vzdy M ... medzera 
		if (points.length % 2) {
			points.pop();
		}
		points.forEach( function(v,i) {
			points[i] = parseFloat(v);
		})
	}
	if (scale && scale.x && scale.y) {
		for (var i=0; i<points.length; i+=2) {
			points[i] *= scale.x;
			points[i+1] *= scale.y;
		}
	}
	switch (format) {
		case 'clipper' : 
			var xypoints = [];
			for (var i=0; i<points.length; i+=2) {
				xypoints.push( {X:points[i], Y:points[i+1]} );
			}
			points = xypoints;
			break;
	}
	return points;
}
// tvar je ZASADNE vo forme jednoducheho path v strukture :
// M x y [ L x y ] ... ziadne ine formy sa neakceptuju 
// meno ciselnej hodnoty je poskladane tak, aby urcovalo, co a ako sa ma pomenit
// obdlznik_plocha_usek_AyBy_By_Cy	... pri zadani vysky obdlznika AB zmen hodnotu By a sucasne Cy ...
// obdlznik_otvory_bod_Ay_By_Cy_Dy	... pri zadani offset-u okna zmen vsetky y koordinaty
function svg_dep_edit(name, val) {
	var numVal = Math.abs(parseFloat(val)),	i, delta
	,	tags = name.split('_'),	start = 3
	,	tvar = tags[0]
	,	plo_otvo = tags[1]
	,	bod_usek = tags[2]
//	var	tvar = nearestParent(inp,'tr').className
	,	svgg = document.querySelector('#svg_canvas svg g#'+plo_otvo+' g#'+tvar)
	,	ptvar = svgg.querySelector('path')
	,	points = path_points(ptvar,__,{x:1,y:-1})
	,	delta = null
	;
	switch(bod_usek) {
		case 'usek':
// usek sa VZDY ocakava ratat IBA medzi rovnakymi koordinatmi x, resp. y
			var sek = tags[3]
			,	i1_ref = sek.charCodeAt(0) - 65
			,	xy1 = (sek[1].toLowerCase() == 'x') ? 0:1
			,	i2_ref = sek.charCodeAt(2) - 65
			,	xy2 = (sek[3].toLowerCase() == 'x') ? 0:1
			,	aval = Math.abs( points[ 2 * i2_ref + xy2 ] - points[ 2 * i1_ref + xy1 ] )
			,	delta = (val - aval) * ( points[ 2 * i2_ref + xy2 ] >= points[ 2 * i1_ref + xy1 ] ? 1 : -1)
			;
			start = 4;
	//		break;
		case 'bod':
			for(i=start; i<tags.length; i++) {
				var ref_bod = tags[i]
				,	i_ref = ref_bod.charCodeAt(0) - 65	// 65 = 0x41 = 'A'.charCodeAt(0)
				,	coord = ref_bod.toLowerCase()[1]
				,	xy = (coord == 'x') ? 0 : 1
				,	aval = points[ 2 * i_ref + xy ]
				;
				if ( (delta === null) && (i==start) ) {
					delta = val - aval;
				}
				points[ 2 * i_ref + xy ] += delta;
				var pismeno = svgg.queryXpath('.//s:text[normalize-space(.)="'+ref_bod[0]+'"]',__,1)
				,	p_val = parseFloat(pismeno.getAttribute(coord))
				;
				pismeno.setAttribute(coord, p_val + (xy ? -1 : 1) * delta);
			}
			break;
	}
	var d='';
	for(i=0;i<points.length;i+=2) {
		d+=(i==0 ? 'M ':' L ')+points[i]+' '+ (-points[i+1]);
	}
	ptvar.setAttribute('d',d+' Z');
}



/* netreba SVG path area kalkulatory, ked ThreeJS ma v sebe zakomponovane area !!!
var polyPts = [100, 100, 150, 150, 200, 100, 200, 200, 150, 150, 100, 200, 100, 100, ];
var area = areaFromCoords(polyPts);
function areaFromCoords(coordArray) {
    var x = coordArray;
    var a = 0;
    if (x.length % 2) return;
    for (var i = 0, iLen = x.length - 2; i < iLen; i += 2) {
        a += x[i] * x[i + 3] - x[i + 2] * x[i + 1];
    }
    return Math.abs(a / 2);
}

//	https://www.mathopenref.com/coordpolygonareacalc.html
function calcArea(xCoords) { 
  area = 0;
  var numCoords = xCoords.length;
  for(var i=0; i<numCoords; i++) {
	  nexti = (i+1) % numC   y2)) / 6;
}

function bez3_sauc(x0, y0, x1, y1, x2, y2, x3, y3) {
  return (  x3*(  -y0 - 3*y1 - 6*y2) -
          3*x2*(   y0 +   y1 - 2*y3) +
          3*x1*(-2*y0 +   y2 +   y3) +
            x0*( 6*y1 + 3*y2 +   y3)) / 20;
}
*/

///</section>


///</file>

