/*
Komukoľvek, kto získa kópiu tohto softvéru a súvisiacich súborov dokumentácie („Softvér“), 
sa týmto udeľuje bezplatné povolenie obchodovať so Softvérom bez obmedzení, 
ako aj neobmedzené právo na použitie, kopírovanie, úpravu, spojenie, zverejnenie, 
distribuovanie, ďalšie udelenie licencie a/alebo predaj kópií Softvéru a umožnenie osobám, 
ktorým sa Softvér poskytuje, aby tak učinili, a to za nasledovných podmienok:
Hore uvedené oznámenie o autorských právach a toto oznámenie o povolení budú súčasťou 
všetkých kópií alebo zásadných častí Softvéru. 
 
TENTO SOFTVÉR SA POSKYTUJE „TAK, AKO JE“, BEZ AKÝCHKOĽVEK ZÁRUK, VYJADRENÝCH PRIAMO ČI NEPRIAMO, 
VRÁTANE (NIE VŠAK VÝLUČNE) ZÁRUKY PREDAJNOSTI, VHODNOSTI NA KONKRÉTNY ÚČEL A NEPORUŠENIA PRAVIDIEL. 
AUTORI ALEBO DRŽITELIA AUTORSKÝCH PRÁV V NIJAKOM PRÍPADE NEMÔŽU BRAŤ ZODPOVEDNOSŤ 
ZA AKÉKOĽVEK REKLAMÁCIE, ŠKODY ALEBO BYŤ INAK ZODPOVEDNÍ, ČI UŽ PRI UPLATŇOVANÍ ZMLÚV, 
PRI PREČINOCH ALEBO INÝCH ČINOCH VYPLÝVAJÚCICH, SÚVISIACICH I NESÚVISIACICH SO SOFTVÉROM 
ALEBO POUŽITÍM SOFTVÉRU ALEBO OBCHODOVANÍM SO SOFTVÉROM.
*/


// TODO ... riesit aj zapornu kondenzaciu - VYSUSOVANIE !!!

//   http://www.tobprojekt.sk/fragmenty-stavebnych-konstrukcii.html

/*# funkcia vario_difOdpor vybera podla mesacneho obdobia ... globalnej zima_leto
	(0 ... zima, 1 ... leto)
	a na zaklade tabulkovo zadanych hodnot DifuznyOdpor a DifuznyOdporLeto
	spravnu hodnotu faktoru difuzneho odporu vrstvy pre konkretny beh vypoctu
*/
function vario_difOdpor( vrstva ) {
	var fDO_z = vrstva.faktor_dif_odporu
	,	fDO_l = parseFloat(vrstva.faktor_dif_odporu_leto)
	,	fakDifOdpor = (zima_leto && !isNaN(fDO_l) && (fDO_l > 0)) ?
			fDO_l : fDO_z;	
	return fakDifOdpor;
}

function difRfnc( dfak ) {
	return dfak / 1000 / 1.8824e-10;  // *  5.312 * 1000000 / 1000;  // 1 000 000 000 / 1 000
	//    10-3 m 		
	//                   rychlost prestupu vodnej pary vo vzduchu 1 meter hrubom
}

/*# funkcia TepOdpor_Vrstva vypocitava pre jednu vrstvu
	na zaklade hrubka_materialu,  suc_tep_vod_interier, resp. suc_tep_vod_exterier
	a faktor_dif_odporu veliciny:
		vrstvy[i].tepelnyOdpor		vrstvy samotnej
		vrstvy[i].ekvivalent_hrubka	vrstvy pre mierku difuznych odporov
		vrstvy[i].difuznyOdpor		vrstvy
*/
function TepOdpor_Vrstva ( vrstva ) {
	var d = vrstva.hrubka_materialu				//	mm
	,	lambda = kalkul.vnutorna ?  vrstva.suc_tep_vod_interier : vrstva.suc_tep_vod_exterier	//	W.m-1.K-1
	,	fakDifOdpor = vario_difOdpor( vrstva );		//vrstva.faktor_dif_odporu;	
	;
	vrstva.lambda = lambda;
	vrstva.tepelnyOdpor = d / lambda / 1000;	//	m2.K.W-1
	vrstva.ekvivalent_hrubka = d * fakDifOdpor;	//	mm
//	vrstva.difuznyOdpor = (d * fakDifOdpor * 100000000) / 0.18824;
	vrstva.difuznyOdpor = difRfnc( d * fakDifOdpor );	//  * 5.312 * 1000000 / 1000;  // 1 000 000 000 / 1 000
												//	m.s-1
// doplnujeme riesenie ramovej konstrukcie
	vrstva.s_ramom = false;
	vrstva.lambda_s_ramom = lambda;
	vrstva.tepelnyOdpor_s_ramom = vrstva.tepelnyOdpor;
	if (vrstva.ramova_konstrukcia == "1") {	//(vrstva.ram_pomer > 0) {	// && < 1 ???
		vrstva.lambda_s_ramom = (1 - (vrstva.ram_pomer/100) ) * lambda + (vrstva.ram_pomer/100) * vrstva.suc_tep_vod_ram;
		vrstva.tepelnyOdpor_s_ramom = d / vrstva.lambda_s_ramom / 1000;	//	m2.K.W-1
		vrstva.s_ramom = true;
	}

	return vrstva;	// nemusi byt ! AUTOMAT
}

/*# funkcia TepOdpor_Fragment prebehne vsetky vrstvy a pre kazdu vrstvu
	zavola vypocet TepOdpor_Vrstva, pricom zaroven dopocitava pre kazdu vrstvu :
		vrstvy[i].start_x					skutocnu x-poziciu zaciatku vrstvy v skladbe fragmentu
		vrstvy[i].start_ex				x-poziciu zaciatku vrstvy v mierke difuznych odporov v skladbe fragmentu
		vrstvy[i].tepelnyOdpor_fragment	tepelny odpor od zaciatku skladby po koniec vrstvy
		vrstvy[i].difuznyOdpor_fragment	difuzny odpor od zaciatku skladby po koniec vrstvy
		vrstvy[i].tepelna_pohltivost		tepelna pohltivost vrstvy
		vrstvy[i].tepelna_inercia			tepelna inercia vrstvy
	pocas behu po vrstvach zaroven funkcia vypocitava celkove hodnoty pre cely fragment (kalkul):	
		kalkul.tepelnyOdpor_fragment
		kalkul.difuznyOdpor_fragment
		kalkul.hrubka_fragment
		kalkul.ekvivalent_hrubka_fragment
		kalkul.tepelna_inercia
		kalkul.teplotny_utlm
	a tiez
		kalkul.teplota_vonkajsieho_povrchu
		kalkul.teplota_vnutorneho_povrchu
		kalkul.fazovy_posun
*/
function TepOdpor_Fragment ( ) {
	var vrstva,	d, difOdpor
	;
	kalkul.tepelnyOdpor_fragment = 0;
	kalkul.difuznyOdpor_fragment = 0;
	kalkul.hrubka_fragment = 0;
	kalkul.ekvivalent_hrubka_fragment = 0;
	kalkul.tepelna_inercia = 0;
	kalkul.teplotny_utlm = 1;
// doplnujeme riesenie ramovej konstrukcie
	kalkul.je_ramova_konstrukcia = false;
	kalkul.tepelnyOdpor_fragment_s_ramom = 0;
	
	var tep_vod_konst = Math.sqrt(2*Math.PI/86400)	//0.00853
	
	for (var iv = 0; iv < vrstvy.length; iv++) {
		vrstva = vrstvy[iv];
		
		TepOdpor_Vrstva (vrstva);
		
// doplnujeme riesenie ramovej konstrukcie
		kalkul.je_ramova_konstrukcia |= vrstva.s_ramom;
		kalkul.tepelnyOdpor_fragment_s_ramom += vrstva.tepelnyOdpor_s_ramom;


		vrstva.start_x = kalkul.hrubka_fragment;						//	mm
		kalkul.hrubka_fragment += vrstva.hrubka_materialu;				//	mm
		
		kalkul.tepelnyOdpor_fragment += vrstva.tepelnyOdpor;			//	m2.K.W-1
		vrstva.tepelnyOdpor_fragment = kalkul.tepelnyOdpor_fragment;
		
		kalkul.difuznyOdpor_fragment += vrstva.difuznyOdpor;			//	m.s-1
		vrstva.difuznyOdpor_fragment = kalkul.difuznyOdpor_fragment;

		vrstva.start_ex = kalkul.ekvivalent_hrubka_fragment;			//	mm
		kalkul.ekvivalent_hrubka_fragment += vrstva.ekvivalent_hrubka;	//	mm
		
// tepelna pohltivost
		vrstva.tepelna_pohltivost = tep_vod_konst	//0.00853 
			* Math.sqrt( vrstva.objemova_hmotnost
				* vrstva.lambda	//.suc_tep_vod_exterier
				* vrstva.mer_tep_kap
			);
		vrstva.tepelna_inercia = vrstva.tepelnyOdpor * vrstva.tepelna_pohltivost;
		ucko = ( iv==0 ? kalkul.alfaI : vrstvy[iv-1].tepelna_pohltivost )
		vrstva.tepelna_pohltivost_vonk_povrchu = (vrstva.tepelna_inercia < 1) 
			? ( (vrstva.tepelnyOdpor * vrstva.tepelna_pohltivost * vrstva.tepelna_pohltivost + ucko)
				/ ( 1+ vrstva.tepelnyOdpor * ucko)
				)
			: vrstva.tepelna_pohltivost
		;
		kalkul.tepelna_inercia += vrstva.tepelna_inercia;
		kalkul.teplotny_utlm *= ( vrstva.tepelna_pohltivost + ucko ) 
			/ (vrstva.tepelna_pohltivost + vrstva.tepelna_pohltivost_vonk_povrchu)
		;
	}
	if (iv) {
		kalkul.teplotny_utlm *= ( (kalkul.alfaE + vrstva.tepelna_pohltivost_vonk_povrchu) / kalkul.alfaE);
		kalkul.teplotny_utlm *=  0.7 * Math.exp(kalkul.tepelna_inercia / Math.sqrt(2));
	}

	kalkul.teplota_vonkajsieho_povrchu = kalkul.vonkajsia_teplota 
		- (	(kalkul.vonkajsia_teplota - kalkul.vnutorna_teplota) 
			/ (	kalkul.rsi + kalkul.tepelnyOdpor_fragment + kalkul.rse ) 
			* kalkul.rse
		)
	;
	kalkul.teplota_vnutorneho_povrchu = kalkul.vnutorna_teplota 
		+ ( (kalkul.vonkajsia_teplota - kalkul.vnutorna_teplota) 
			/ (	kalkul.rsi + kalkul.tepelnyOdpor_fragment + kalkul.rse ) 
			* kalkul.rsi
		)
	;
	kalkul.fazovy_posun = 2.7 * kalkul.tepelna_inercia;	// v hodinach
	
	return kalkul;	// nemusi byt ! AUTOMAT
}

/*# funkcia SucinitelPrechoduTepla_fragment vypocitava na zaklade 
	kalkul.rsi, kalkul.rse, kalkul.tepelnyOdpor_fragment
hodnotu
	kalkul.sucinitelPrechoduTepla		pre cely fragment
*/
function SucinitelPrechoduTepla_fragment ( ) {
	var rsi = kalkul.rsi					//	m2.K.W-1
	,	rse = kalkul.rse					//	m2.K.W-1
	,	R = kalkul.tepelnyOdpor_fragment	//	m2.K.W-1
	,	pv = vrstvy.length > 0 ? 1: 0
	;
// premenovavam povodny sucinitelPrechoduTepla:
	kalkul.sucinitelPrechoduTepla_izolacia = pv * (1 / (rse + R + rsi));	//	W.m-2.K-1
// doplnujeme riesenie ramovej konstrukcie
	kalkul.sucinitelPrechoduTepla/*_s_ramom*/ = pv * (1 / (rse + kalkul.tepelnyOdpor_fragment_s_ramom + rsi));	//	W.m-2.K-1
	
	return kalkul.sucinitelPrechoduTepla;
}

/*# funkcia TeplotyVrstiev prebehne fragment po vrstvach a pre kazdu
	vypocita na zaklade kalkul.rsi, kalkul.rse, kalkul.tepelnyOdpor_fragment
	a na zaklade vrstvy[i].tepelnyOdpor_fragment 
	(napocet odporu od zaciatku skladby fragmentu po koniec vrstvy)
	hodnoty:
		vrstvy[i].vnutorna_teplota
		vrstvy[i].vonkajsia_teplota
*/
function TeplotyVrstiev() {
	var Te = kalkul.vonkajsia_teplota
	,	Ti = kalkul.vnutorna_teplota
	,	t =  Ti - ( kalkul.rsi
					/ (kalkul.rsi + kalkul.tepelnyOdpor_fragment + kalkul.rse) 
				) * (Ti - Te)
	;
	for (var iv = 0; iv < vrstvy.length; iv++) {
		var vrstva = vrstvy[iv];
		vrstva.vnutorna_teplota = t;
		t = vrstva.vonkajsia_teplota = 
			Ti - ( 	(kalkul.rsi +  vrstva.tepelnyOdpor_fragment )
					/ (kalkul.rsi + kalkul.tepelnyOdpor_fragment + kalkul.rse) 
				) * (Ti - Te)
		;
	}
	return vrstvy;
}

/*# funkcia calcTlakNasPar pocita podla definicnej rovnice tlak nasytenej pary pre danu teplotu
*/
function calcTlakNasPar( t ) {
	var	ex = (t < 0) 
			? ( ( 21.875 * t) / (265.5 + t) ) 
			: ( ( 17.269 * t) / (237.3 + t) ) 
	,	p = 610.5 * Math.exp(ex)
	;
	return p;
}
/*# funkcia TlakNasParVrstiev pre kazdu vrstu pocita tlak nasytenej pary podla teploty 
na interierovej a exterierovej hrane vrsty 
	vnutorny_tlakNasPar		na strane od interieru
	vonkajsi_tlakNasPar		na strane od exterieru
*/
function TlakNasParVrstiev() {
	var Te = kalkul.vonkajsia_teplota
	,	Ti = kalkul.vnutorna_teplota
	,	t =  Ti - ( kalkul.rsi
					/ (kalkul.rsi + kalkul.tepelnyOdpor_fragment + kalkul.rse) 
				) * (Ti - Te)
	;
	for (var iv = 0; iv < vrstvy.length; iv++) {
		var vrstva = vrstvy[iv];
		vrstva.vnutorny_tlakNasPar = calcTlakNasPar( t );
		t =  Ti - ( 	(kalkul.rsi +  vrstva.tepelnyOdpor_fragment )
					/ (kalkul.rsi + kalkul.tepelnyOdpor_fragment + kalkul.rse) 
				) * (Ti - Te)
		;
		vrstva.vonkajsi_tlakNasPar = calcTlakNasPar( t );
	}
	return vrstvy;
}

/*# funkcia calcTlakVlhPary pocita podla teploty(stC) a vlhkosti(percenta) skutocny tlak vodnych par
*/
function calcTlakVlhPary( t, v ) {
	return (calcTlakNasPar(t) * v)/100;
}

/*# funkcia TlakPar_Fragment pocita pre cely fragment
	kalkul.vnutorny_tlakNasPar		tlak nasytenej vodnej pary pri kalkul.vnutorna_teplota
	kalkul.pvi						skutocny tlak vodnej pary v interieri
									pre kalkul.vnutorna_teplota a kalkul.vnutorna_vlhkost
	kalkul.vonkajsi_tlakNasPar		tlak nasytenej vodnej pary pri kalkul.vonkajsia_teplota
	kalkul.pve						skutocny tlak vodnej pary v exterieri
									pre kalkul.vonkajsia_teplota a kalkul.vonkajsia_vlhkost	
*/
function TlakPar_Fragment ( ) {
	kalkul.vnutorny_tlakNasPar = calcTlakNasPar( kalkul.vnutorna_teplota );
	kalkul.vonkajsi_tlakNasPar = calcTlakNasPar( kalkul.vonkajsia_teplota );
	
	kalkul.pvi = calcTlakVlhPary( kalkul.vnutorna_teplota, kalkul.vnutorna_vlhkost );
	kalkul.pve = calcTlakVlhPary( kalkul.vonkajsia_teplota, kalkul.vonkajsia_vlhkost );
}

/* funkcia TepOdpor_x je vykreslovacou funkciou TO = fnc(x)
t.j. vypocitava hodnotu tepelneho odporu od zaciatku fragmentu po poziciu X[mm] v skutocnej mierke mm
*/
function TepOdpor_x(x) {	// x ... mm
	var iv, Rx = 0
	;
	for (iv = 0; iv < vrstvy.length; iv++) {
		var vrstva = vrstvy[iv]
		,	sx = vrstva.start_x
		,	d = vrstva.hrubka_materialu
		,	R = vrstva.tepelnyOdpor
		;
		if (x > (sx + d)) {
			Rx += R;
		} else {
			Rx += (x - sx) / vrstva.lambda / 1000;	// suc_tep_vod_exterier / 1000;
			break;
		}
	}
	return Rx;
}
/* funkcia DifOdpor_x je vykreslovacou funkciou DO = fnc(x)
t.j. vypocitava hodnotu difuzneho odporu od zaciatku fragmentu po poziciu X[mm] v skutocnej mierke mm
*/
function DifOdpor_x(x) {	// x ... mm
	var iv, Rx = 0
	;
	for (iv = 0; iv < vrstvy.length; iv++) {
		var vrstva = vrstvy[iv]
		,	sx = vrstva.start_x
		,	d = vrstva.hrubka_materialu
		,	R = vrstva.difuznyOdpor
		;
		if (x > (sx + d)) {
			Rx += R;
		} else {
			Rx += difRfnc( (x - sx) * vario_difOdpor( vrstva ) );	// * 5.312 * 1000000 / 1000 );	//(vrstva.faktor_dif_odporu * 5.312 * 1000000 / 1000);
			break;
		}
	}
	return Rx;
}

/* funkcia Teplota je vykreslovacou funkciou TE = fnc(x)
t.j. vypocitava hodnotu teploty od zaciatku fragmentu po poziciu X[mm] v skutocnej mierke mm
*/
function Teplota(x) {
	var Te = kalkul.vonkajsia_teplota
	,	Ti = kalkul.vnutorna_teplota
	,	t = Ti - ( 	(kalkul.rsi +  TepOdpor_x(x) )
					/ (kalkul.rsi + kalkul.tepelnyOdpor_fragment + kalkul.rse) 
				) * (Ti - Te)
	;
// console.log(x,t);
	return t;
}
/* prepocitavacia funkcia ekviX prepocitava poziciu dlzky v mierke difuznych odporov na skutocnu dlzku [mm]
je reverznou funkciou voci xEkvi
*/
function ekviX(ex) { // prepocita ekvivalentne difuzne dlzky na skutocne dlzky
	var iv, x = 0;
	for (iv = 0; iv < vrstvy.length; iv++) {
		var vrstva = vrstvy[iv]
		,	sx = vrstva.start_ex
		,	d = vrstva.ekvivalent_hrubka
		;
		if (ex > (sx + d)) {
			x += vrstva.hrubka_materialu;
		} else {
			x += (ex - sx) / vario_difOdpor( vrstva );		//vrstva.faktor_dif_odporu;
			break;
		}
	}
	return x;
}
/* funkcia Teplota_ekvi je vykreslovacou funkciou TEe = fnc(ex)
t.j. vypocitava hodnotu teploty od zaciatku fragmentu po poziciu EX[ekvi mm] v mierke difuznych odporov
*/
function Teplota_ekvi(x) {
	return Teplota(ekviX(x));
}

/* funkcia TlakNasPar je vykreslovacou funkciou TNP = fnc(x)
t.j. vypocitava hodnotu tlaku nasytenych vodnych par od zaciatku fragmentu po poziciu X[mm] v skutocnej mierke mm
*/
function TlakNasPar(x) {
	var Te = kalkul.vonkajsia_teplota
	,	Ti = kalkul.vnutorna_teplota
	,	t = Ti - ( 	(kalkul.rsi +  TepOdpor_x(x) )
					/ (kalkul.rsi + kalkul.tepelnyOdpor_fragment + kalkul.rse) 
				) * (Ti - Te)
//	,	ex = (t < 0) 
//			? ( ( 21.875 * t) / (265.5 + t) ) 
//			: ( ( 17.269 * t) / (237.3 + t) ) 
//	,	p = 610.5 * Math.exp(ex)
	;
// console.log(x,t,p);
	return calcTlakNasPar(t);
}
/* funkcia TlakNasPar_ekvi je vykreslovacou funkciou TNPe = fnc(ex)
t.j. vypocitava hodnotu tlaku nasytenych vodnych par od zaciatku fragmentu po poziciu EX v mierke difuznych odporov
*/
function TlakNasPar_ekvi(x) {
	return TlakNasPar(ekviX(x));
}

/*
function PriebehTeploty() {
	var vrstva,	tepl, d, difOdpor
	;
	tepl = 
	kalkul.tepelnyOdpor_fragment = 0;
	kalkul.difuznyOdpor_fragment = 0;
	kalkul.hrubka_fragment = 0;
	kalkul.ekvivalent_hrubka_fragment = 0;
	
	for (var iv = 0; iv < vrstvy.length; iv++) {
		vrstva = vrstvy[iv];
		
		TepOdpor_Vrstva (vrstva);
		
		vrstva.start_x = kalkul.hrubka_fragment;
		kalkul.hrubka_fragment += vrstva.hrubka_materialu;
		
		kalkul.tepelnyOdpor_fragment += vrstva.tepelnyOdpor;
		kalkul.difuznyOdpor_fragment += vrstva.difuznyOdpor;

		vrstva.start_ex = kalkul.ekvivalent_hrubka_fragment;
		kalkul.ekvivalent_hrubka_fragment += vrstva.ekvivalent_hrubka;
	}
	
	return kalkul;	// nemusi byt ! AUTOMAT
}
*/

/* prepocitavacia funkcia xEkvi prepocitava skutocnu poziciu [mm] na dlzku v mierke difuznych odporov
je reverznou funkciou voci ekviX
*/
function xEkvi(x) { // prepocita skutocne dlzky na ekvivalentne difuzne dlzky
	var iv, ex = 0;
	for (iv = 0; iv < vrstvy.length; iv++) {
		var vrstva = vrstvy[iv]
		,	sx = vrstva.start_x
		,	d = vrstva.hrubka_materialu
		;
		if (x > (sx + d)) {
			ex += vrstva.ekvivalent_hrubka;
		} else {
			ex += (x - sx) * vario_difOdpor( vrstva );		//vrstva.faktor_dif_odporu;
			break;
		}
	}
	return ex;
}
/* funkcia SkutTlakPar_ekvi je vykreslovacou funkciou STPe = fnc(ex)
t.j. vypocitava hodnotu skutocneho tlaku vodnych par od zaciatku fragmentu po poziciu EX v mierke difuznych odporov
*/
function SkutTlakPar_ekvi(x) {
	var p = -1, kS, kE, pS, pE, nS, nE
	,	i, le = kalkul.kond.length
	;
	for ( i=0; i<le; i++ ) {
		pS = (i == 0) ? 0 : kalkul.kond[i-1].ekviStart;
		pE = (i == 0) ? 0 : kalkul.kond[i-1].ekviEnd;
		
		kS = kalkul.kond[i].ekviStart;
		kE = kalkul.kond[i].ekviEnd;

		nS = (i == le-1) ? kalkul.ekvivalent_hrubka_fragment : kalkul.kond[i+1].ekviStart;
		nE = (i == le-1) ? kalkul.ekvivalent_hrubka_fragment : kalkul.kond[i+1].ekviEnd;
		
		if ( (x >= pE) && (x <= kS) ) {
			p = kalkul.kond[i].Start_rise + x * kalkul.kond[i].Start_slope;
		} else if ( (x >= kE) && (x <= nS) ) {
			p = kalkul.kond[i].End_rise + x * kalkul.kond[i].End_slope;
		} else if ( (x > kS) && (x < kE) ) {
			p = TlakNasPar(ekviX(x));
		}
		if (p >=0) {
			break;
		}
	}
//	var p;
//	if (x <= kalkul.kond_ekviStart) {
//		p = kalkul.kond_Start_rise + x * kalkul.kond_Start_slope;
//	} else if (x >= kalkul.kond_ekviEnd) {
//		p = kalkul.kond_End_rise + x * kalkul.kond_End_slope;
//	} else {
//		p = TlakNasPar(ekviX(x));
//	}
	return p;
}
/* funkcia SkutTlakPar je vykreslovacou funkciou STP = fnc(x)
t.j. vypocitava hodnotu skutocneho tlaku vodnych par od zaciatku fragmentu po poziciu X[mm] v skutocnej mierke mm
*/
function SkutTlakPar(x) {
	var p = -1, kS, kE, pS, pE, nS, nE
	,	i, le = kalkul.kond.length
	;
	for ( i=0; i<le; i++ ) {
		pS = (i == 0) ? 0 : kalkul.kond[i-1].Start;
		pE = (i == 0) ? 0 : kalkul.kond[i-1].End;
		
		kS = kalkul.kond[i].Start;
		kE = kalkul.kond[i].End;

		nS = (i == le-1) ? kalkul.ekvivalent_hrubka_fragment : kalkul.kond[i+1].Start;
		nE = (i == le-1) ? kalkul.ekvivalent_hrubka_fragment : kalkul.kond[i+1].End;
		
		if ( (x >= pE) && (x <= kS) ) {
			p = kalkul.kond[i].Start_rise + xEkvi(x) * kalkul.kond[i].Start_slope;
		} else if ( (x >= kE) && (x <= nS) ) {
			p = kalkul.kond[i].End_rise + xEkvi(x) * kalkul.kond[i].End_slope;
		} else if ( (x > kS) && (x < kE) ) {
			p = TlakNasPar(x);
		}
		if (p >=0) {
			break;
		}
	}
//	var p;
//	if (x <= kalkul.kond_Start) {
//		p = kalkul.kond_Start_rise + xEkvi(x) * kalkul.kond_Start_slope;
//	} else if (x >= kalkul.kond_End) {
//		p = kalkul.kond_End_rise + xEkvi(x) * kalkul.kond_End_slope;
//	} else {
//		p = TlakNasPar(x);
//	}
	return p;
}

/*# funkcia SkutTlakParVrstiev prebehne vsetky vrstvy a pre kazdu vrstvu vypocita
		vrstvy[i].vnutorny_skutTlakPar		skutocny tlak vodnych par na zaciatku vrstvy
		vrstvy[i].vonkajsi_skutTlakPar		skutocny tlak vodnych par na konci vrstvy
*/
function SkutTlakParVrstiev() {
	for (var iv = 0; iv < vrstvy.length; iv++) {
		var vrstva = vrstvy[iv];
		vrstva.vnutorny_skutTlakPar = SkutTlakPar( vrstva.start_x );
		vrstva.vonkajsi_skutTlakPar = SkutTlakPar( vrstva.start_x + vrstva.hrubka_materialu);
	}
	return vrstvy;
}

/*# spolocne parametre grafov */
var grafy = {	
	zoom_faktorX : 1.25
,	zoom_faktorY : 1.25
,	koef_rozsah_x : 0.1
,	max_teplota : 30
,	min_teplota : -25
,	append_teplota : 5
,	max_ciast_tlak : 2400
,	min_ciast_tlak : 0
,	append_ciast_tlak : 200
}
//	http://blog.adamcole.ca/2011/11/simple-javascript-rainbow-color.html
function rainbow(numOfSteps, step) {
    // This function generates vibrant, "evenly spaced" colours (i.e. no clustering). This is ideal for creating easily distinguishable vibrant markers in Google Maps and other apps.
    // Adam Cole, 2011-Sept-14
    // HSV to RBG adapted from: http://mjijackson.com/2008/02/rgb-to-hsl-and-rgb-to-hsv-color-model-conversion-algorithms-in-javascript
    var r, g, b;
    var h = step / numOfSteps;
    var i = ~~(h * 6);
    var f = h * 6 - i;
    var q = 1 - f;
    switch(i % 6){
        case 0: r = 1; g = f; b = 0; break;
        case 1: r = q; g = 1; b = 0; break;
        case 2: r = 0; g = 1; b = f; break;
        case 3: r = 0; g = q; b = 1; break;
        case 4: r = f; g = 0; b = 1; break;
        case 5: r = 1; g = 0; b = q; break;
    }
    var c = "#" + ("00" + (~ ~(r * 255)).toString(16)).slice(-2) + ("00" + (~ ~(g * 255)).toString(16)).slice(-2) + ("00" + (~ ~(b * 255)).toString(16)).slice(-2);
    return (c);
}
//	http://www.intmath.com/cg3/jsxgraph-axes-ticks-grids.php#jxgbox6
//	http://jsxgraph.uni-bayreuth.de/docs/symbols/JXG.Board.html#zoom
//	http://www.onemathematicalcat.org/JSXGraphDocs/JSXGraphDocs3.htm#P

//function redraws_graphs() {
//	draw_fragment_vrstvy();			//JXG.JSXGraph.freeBoard(board_V);
//	draw_fragment_tepl();			//JXG.JSXGraph.freeBoard(board_T);
//	draw_fragment_tlak();			//JXG.JSXGraph.freeBoard(board_P);
//	draw_fragment_tepl_ekvi();			//JXG.JSXGraph.freeBoard(board_Te);
//	draw_fragment_tlak_ekvi();			//JXG.JSXGraph.freeBoard(board_Pe);
//	draw_fragment_skut_tlak();			//JXG.JSXGraph.freeBoard(board_SP);
//}

//# vykreslenie grafu vrstiev board_V ( v skladbe fragmentu )
//# pouzite: vrstvy[i].hrubka_materialu
//# 	kalkul.hrubka_fragment
function draw_fragment_vrstvy() {
	Fproject.save();
	TepOdpor_Fragment();	SucinitelPrechoduTepla_fragment();
	document.forms.fragment.elements.vrstvy_hrubka.value = kalkul.hrubka_fragment;
	document.forms.fragment.elements.priebezne_R.value = kalkul.tepelnyOdpor_fragment.toFixed(3);
	document.forms.fragment.elements.priebezne_U.value = kalkul.sucinitelPrechoduTepla.toFixed(3);
	
	var cnt = vrstvy.length
	,	h = kalkul.hrubka_fragment
	;
	JXG.JSXGraph.freeBoard(board_V);
	board_V = JXG.JSXGraph.initBoard('jxgbox_vrstvy',{
			boundingbox:[-h*grafy.koef_rozsah_x, 100, h*(1+grafy.koef_rozsah_x), -10 ]
		,	axis: false	//true
		,	showCopyright:false
		,	zoom: {
				factorX: grafy.zoom_faktorX, //1.25,
				factorY: grafy.zoom_faktorY,  //1.25,
				wheel: true,
				needshift: true,
				eps: 0.1
			}
		}); 
	vrstvy.forEach( 
		function(v,i,a) {
			var p1 = board_V.create('point',[v.start_x, 0  ],{fixed:true, size:0.2, name:''})
			,	p2 = board_V.create('point',[v.start_x, 90 ],{fixed:true, size:0.2, name:''})
			,	p3 = board_V.create('point',[v.start_x+v.hrubka_materialu, 90],{fixed:true, size:0.2, name:''})
			,	p4 = board_V.create('point',[v.start_x+v.hrubka_materialu, 0 ],{fixed:true, size:0.2, name:''})
			;
			board_V.create('polygon',[p1,p2,p3,p4],{withLines:false,fillColor:rainbow(cnt, i) });
		}
	);
}

//# vykreslenie priebehu teploty board_T ( Priebeh teplôt vo fragmente - skutočná mierka )
//# pouzite: vrstvy[i].start_x, vrstvy[i].hrubka_materialu, vrstvy[i].vnutorna_teplota, vrstvy[i].vonkajsia_teplota
//# 	kalkul.hrubka_fragment
function draw_fragment_tepl() {
	var cnt = vrstvy.length
	,	h = kalkul.hrubka_fragment
	;
	JXG.JSXGraph.freeBoard(board_T);
	board_T = JXG.JSXGraph.initBoard('jxgbox_tepl',{
			boundingbox:[-h*grafy.koef_rozsah_x,grafy.max_teplota+grafy.append_teplota,h*(1+grafy.koef_rozsah_x),grafy.min_teplota-grafy.append_teplota] //[-h*0.1,35,h*1.1,-30]
		,	axis:true
		,	showCopyright:false
		,	zoom: {
				factorX: grafy.zoom_faktorX, //1.25,
				factorY: grafy.zoom_faktorY,  //1.25,
				wheel: true,
				needshift: true,
				eps: 0.1
			}
		}); 
	vrstvy.forEach( 
		function(v,i,a) {
			var p1 = board_T.create('point',[v.start_x,grafy.min_teplota/*-25*/],{fixed:true, size:0.2, name:''})
			,	p2 = board_T.create('point',[v.start_x,grafy.max_teplota/*+30*/],{fixed:true, size:0.2, name:''})
			,	p3 = board_T.create('point',[v.start_x+v.hrubka_materialu,grafy.max_teplota/*+30*/],{fixed:true, size:0.2, name:''})
			,	p4 = board_T.create('point',[v.start_x+v.hrubka_materialu,grafy.min_teplota/*-25*/],{fixed:true, size:0.2, name:''})
			;
		//  board_T.create('polygon',[[v.start_x, 0], [v.start_x, 80], [v.start_x+v.hrubka_materialu, 80], [v.start_x+v.hrubka_materialu, 0]]);
			board_T.create('polygon',[p1,p2,p3,p4],{withLines:false,fillColor:rainbow(cnt, i) });
			
			var l1 = board_T.create('point',[v.start_x,v.vnutorna_teplota],{fixed:true, size:0.2, name:''})
			,	l2 = board_T.create('point',[v.start_x + v.hrubka_materialu,v.vonkajsia_teplota],{fixed:true, size:0.2, name:''})
			;
			board_T.create('segment', [l1,l2], { strokeColor: 'black'} );
		}
	);
// alebo (aj)
	board_T.create('functiongraph',[Teplota, 0, kalkul.hrubka_fragment ] );
}
//# vykreslenie tabulky teplot ( Priebeh teplôt vo fragmente - skutočná mierka )
//# pouzite: vrstvy[i].vonkajsia_teplota
//# 	kalkul.vnutorna_teplota, kalkul.vonkajsia_teplota
function tabl_fragment_tepl( tbl ) {
	var tbl = tbl || document.getElementById('tblbox_tepl');
	if ( ! tbl ) {
		return;
	}
	// clean
	while( tbl.childNodes.length ) {
		tbl.removeChild(tbl.firstChild);
	}
	// fill
	var tdn = '', tdd = '';
	for (var i=0; i < vrstvy.length; i++) {
		tdn+='<td>'+(i+1)+'</td>';
		tdd+='<td>'+(vrstvy[i].vonkajsia_teplota.toFixed(2))+'</td>';
	}
	tbl.innerHTML = '<tr><td><b>vrstva</b></td><td>Interiér</td><td>Povrch</td>'+tdn+'<td>Exteriér</td></tr>'
	+	'<tr><td><b>φ</b></td><td>'
			+(kalkul.vnutorna_teplota.toFixed(2))+'</td><td>'
			+(kalkul.teplota_vnutorneho_povrchu.toFixed(2))+'</td>'
			+tdd+'<td>'
			+(kalkul.vonkajsia_teplota.toFixed(2))+'</td></tr>'
	;
}
//# vykreslenie priebehu tlaku nas.vod.par board_P ( Čiastočný tlak nasýtenej pary vo fragmente - skutočná mierka )
//# pouzite: vrstvy[i].start_x, vrstvy[i].hrubka_materialu
//# 	kalkul.hrubka_fragment a vykreslovacia funkcia TlakNasPar
function draw_fragment_tlak() {
	var cnt = vrstvy.length
	,	h = kalkul.hrubka_fragment
	;
	JXG.JSXGraph.freeBoard(board_P);
	board_P = JXG.JSXGraph.initBoard('jxgbox_tlak',{
			boundingbox:[-h*grafy.koef_rozsah_x,grafy.max_ciast_tlak+grafy.append_ciast_tlak,h*(1+grafy.koef_rozsah_x),grafy.min_ciast_tlak-grafy.append_ciast_tlak] //[-h*0.1,2500,h*1.1,-100]
		,	showCopyright:false
		,	axis:true
		,	zoom: {
				factorX: grafy.zoom_faktorX, //1.25,
				factorY: grafy.zoom_faktorY,  //1.25,
				wheel: true,
				needshift: true,
				eps: 0.1
			}
		}); 
	vrstvy.forEach( 
		function(v,i,a) {
			var p1 = board_P.create('point',[v.start_x,grafy.min_ciast_tlak/*+0*/],{fixed:true, size:0.2, name:''})
			,	p2 = board_P.create('point',[v.start_x,grafy.max_ciast_tlak/*+2400*/],{fixed:true, size:0.2, name:''})
			,	p3 = board_P.create('point',[v.start_x+v.hrubka_materialu,grafy.max_ciast_tlak/*+2400*/],{fixed:true, size:0.2, name:''})
			,	p4 = board_P.create('point',[v.start_x+v.hrubka_materialu,grafy.min_ciast_tlak/*+0*/],{fixed:true, size:0.2, name:''})
			;
		//  board_P.create('polygon',[[v.start_x, 0], [v.start_x, 80], [v.start_x+v.hrubka_materialu, 80], [v.start_x+v.hrubka_materialu, 0]]);
			board_P.create('polygon',[p1,p2,p3,p4],{withLines:false,fillColor:rainbow(cnt, i) });
		}
	);		
	board_P.create('functiongraph',[TlakNasPar, 0, kalkul.hrubka_fragment] );
}
//# vykreslenie tabulky tlakov nas.vod.par ( Čiastočný tlak nasýtenej pary vo fragmente - skutočná mierka )
//# pouzite: vrstvy[i].vonkajsi_tlakNasPar
//# 	kalkul.vnutorny_tlakNasPar, kalkul.vonkajsi_tlakNasPar
function tabl_fragment_tlak( tbl ) {
	var tbl = tbl || document.getElementById('tblbox_tlak');
	if ( ! tbl ) {
		return;
	}
	// clean
	while( tbl.childNodes.length ) {
		tbl.removeChild(tbl.firstChild);
	}
	// fill
	var tdn = '', tdd = '';
	for (var i=0; i < vrstvy.length; i++) {
		tdn+='<td>'+(i+1)+'</td>';
		tdd+='<td>'+(vrstvy[i].vonkajsi_tlakNasPar.toFixed(2))+'</td>';
	}
	tbl.innerHTML = '<tr><td><b>vrstva</b></td><td>Interiér</td>'+tdn+'<td>Exteriér</td></tr>'
	+	'<tr><td><b>PSat</b></td><td>'+(kalkul.vnutorny_tlakNasPar.toFixed(2))+'</td>'+tdd+'<td>'+(kalkul.vonkajsi_tlakNasPar.toFixed(2))+'</td></tr>'
	;
}

//# vykreslenie priebehu teploty board_Te ( NEVYKRESLOVANE Priebeh teplôt vo fragmente - mierka difúznych odporov )
//# pouzite: vrstvy[i].start_ex, vrstvy[i].ekvivalent_hrubka
//# 	kalkul.hrubka_fragment a vykreslovacia funkcia Teplota_ekvi
function draw_fragment_tepl_ekvi() {
	var cnt = vrstvy.length
	,	h = kalkul.ekvivalent_hrubka_fragment
	;
	JXG.JSXGraph.freeBoard(board_Te);
	board_Te = JXG.JSXGraph.initBoard('jxgbox_tepl_ekvi',{
			boundingbox:[-h*grafy.koef_rozsah_x,grafy.max_teplota+grafy.append_teplota,h*(1+grafy.koef_rozsah_x),grafy.min_teplota-grafy.append_teplota] //[-h*0.1,35,h*1.1,-30]
		,	showCopyright:false
		,	axis:true
		,	zoom: {
				factorX: grafy.zoom_faktorX, //1.25,
				factorY: grafy.zoom_faktorY,  //1.25,
				wheel: true,
				needshift: true,
				eps: 0.1
			}
		}); 
	vrstvy.forEach( 
		function(v,i,a) {
			var p1 = board_Te.create('point',[v.start_ex,grafy.min_teplota/*-25*/],{fixed:true, size:0.2, name:''})
			,	p2 = board_Te.create('point',[v.start_ex,grafy.max_teplota/*+30*/],{fixed:true, size:0.2, name:''})
			,	p3 = board_Te.create('point',[v.start_ex+v.ekvivalent_hrubka,grafy.max_teplota/*+30*/],{fixed:true, size:0.2, name:''})
			,	p4 = board_Te.create('point',[v.start_ex+v.ekvivalent_hrubka,grafy.min_teplota/*-25*/],{fixed:true, size:0.2, name:''})
			;
			board_Te.create('polygon',[p1,p2,p3,p4],{withLines:false,fillColor:rainbow(cnt, i) });
		}
	);		
	board_Te.create('functiongraph',[Teplota_ekvi, 0, h ] );
}

//# vykreslenie priebehu tlaku nas.vod.par board_Pe ( Výpočet kondenzácie vo fragmente - mierka difúznych odporov )
//# pouzite: vrstvy[i].start_ex
//# 	kalkul.pvi, kalkul.pve  a vykreslovacia funkcia TlakNasPar_ekvi
function draw_fragment_tlak_ekvi() {
	var cnt = vrstvy.length
	,	h = kalkul.ekvivalent_hrubka_fragment
	;
	JXG.JSXGraph.freeBoard(board_Pe);
	board_Pe = JXG.JSXGraph.initBoard('jxgbox_tlak_ekvi',{
			boundingbox:[-h*grafy.koef_rozsah_x,grafy.max_ciast_tlak+grafy.append_ciast_tlak,h*(1+grafy.koef_rozsah_x),grafy.min_ciast_tlak-grafy.append_ciast_tlak] //[-h*0.1,2500,h*1.1,-100]
		,	showCopyright:false
		,	axis:true
		,	zoom: {
				factorX: grafy.zoom_faktorX, //1.25,
				factorY: grafy.zoom_faktorY,  //1.25,
				wheel: true,
				needshift: true,
				eps: 0.1
			}
		}); 

	var p1,p2,p3,p4;
	vrstvy.forEach( 
		function(v,i,a) {
			p1 = board_Pe.create('point',[v.start_ex,grafy.min_ciast_tlak/*+0*/],{fixed:true, size:0.2, name:''});
			p2 = board_Pe.create('point',[v.start_ex,grafy.max_ciast_tlak/*+2400*/],{fixed:true, size:0.2, name:''});
			p3 = board_Pe.create('point',[v.start_ex+v.ekvivalent_hrubka,grafy.max_ciast_tlak/*+2400*/],{fixed:true, size:0.2, name:''});
			p4 = board_Pe.create('point',[v.start_ex+v.ekvivalent_hrubka,grafy.min_ciast_tlak/*+0*/],{fixed:true, size:0.2, name:''});
			
			board_Pe.create('polygon',[p1,p2,p3,p4],{withLines:false,fillColor:rainbow(cnt, i) });
		}
	);
	grafika = {
		b : board_Pe
	,	f : board_Pe.create('functiongraph',[TlakNasPar_ekvi, 0, h] )
	,	y2 : board_Pe.create('axis',[[h,0],[h,2500]], {name:'y2'} )	// druha osa
	,	pvi : board_Pe.create('point',[		0/*-h*(grafy.koef_rozsah_x/2)*/,		kalkul.pvi],{fixed:true, size:0.2, name:'pvi'})
	,	pve : board_Pe.create('point',[		h/*h*(1+grafy.koef_rozsah_x/2)*/,		kalkul.pve],{fixed:true, size:0.2, name:'pve'})
/*
//	,	p : board_Pe.create('segment', [grafika.pvi,grafika.pve], { strokeColor: 'black'} )
//	,	g1 = board_Pe.create('glider', [0, TlakNasPar_ekvi(0), f])
//	,	t1 = board_Pe.create('tangent', [g1])
//	,	g2 = board_Pe.create('glider', [h, TlakNasPar_ekvi(h), f])
//	,	t2 = board_Pe.create('tangent', [g2])
*/
	};
	grafika.p = board_Pe.create('segment', [grafika.pvi,grafika.pve], { strokeColor: 'black'} );
/*	
//	,	i1,i2
//	try {
//		i1 = board_Pe.create('intersection',[f, p,0],'inte');
//	} catch(e) {
//		console.log('intersect 0',e);
//	}
//	try {
//		i2 = board_Pe.create('intersection',[f, p,1],'exte');
//	} catch(e) {
//		console.log('intersect 1',e);
//	}
*/
		
	return grafika;
}
//# vykreslenie tabulky kondenzacnych zon ( Výpočet kondenzácie vo fragmente - mierka difúznych odporov )
//# pouzite: vrstvy[i].vonkajsi_tlakNasPar
//# 	kalkul.vnutorny_tlakNasPar, kalkul.vonkajsi_tlakNasPar, kalkul.pvi, kalkul.pve
function tabl_fragment_kond_zone( tbl ) {
	var tbl = tbl || document.getElementById('tblkond_zone');
	if ( ! tbl ) {
		return;
	}
	// clean
	while( tbl.childNodes.length ) {
		tbl.removeChild(tbl.firstChild);
	}
	// fill
	var ih = 
//	'<tr><td colspan="3"><b>Kondenzačné zóny</b></td><td colspan="4" style="text-align: center;">[10^-9 kg/(m2s)]</td></tr>'
	'<tr><td colspan="3"><b>Kondenzačné zóny</b></td><td colspan="3" style="text-align: center;">[10^-9 kg/(m2s)]</td></tr>'
+	'<tr><td><b>zona</b></td><td>zač. [mm]</td><td>kon. [mm]</td>'
+	'<td>dif.tok z Int.</td><td>dif.tok do Ext.</td><td>množ.kond.</td>'		// <td>množ.vypar.</td> 
+	'</tr>'
	;
	for (var i=0; i < kalkul.kond.length; i++) {
		ih+='<tr><td>'+(i+1)+'</td>'
		+	'<td>'+(kalkul.kond[i].Start.toFixed(2))+'</td>'
		+	'<td>'+(kalkul.kond[i].End.toFixed(2))+'</td>'
		+	'<td>'+(kalkul.kond[i].difuzny_tok_i*1e9).toFixed(9)+'</td>'
		+	'<td>'+(kalkul.kond[i].difuzny_tok_e*1e9).toFixed(9)+'</td>'
		+	'<td>'+(kalkul.kond[i].mnozstvo_kondenzujucej_pary*1e9).toFixed(9)+'</td>'
//		+	'<td>'+(kalkul.kond[i].mnozstvo_vyparitelnej_pary*1e9).toFixed(9)+'</td>'
		+	'</tr>';
	}
	tbl.innerHTML = ih;
}

//# vykreslenie skutocnych tlakov vod.par board_SP ( Rozdelenie tlakov vodných pár vo fragmente - skutočná mierka )
//# pouzite: vrstvy[i].start_x, vrstvy[i].hrubka_materialu
//# 	kalkul.hrubka_fragment a vykreslovacia funkcia TlakNasPar a SkutTlakPar
function draw_fragment_skut_tlak() {
	var cnt = vrstvy.length
	,	h = kalkul.hrubka_fragment
	;
	JXG.JSXGraph.freeBoard(board_SP);
	board_SP = JXG.JSXGraph.initBoard('jxgbox_tlaky',{
			boundingbox:[-h*grafy.koef_rozsah_x,grafy.max_ciast_tlak+grafy.append_ciast_tlak,h*(1+grafy.koef_rozsah_x),grafy.min_ciast_tlak-grafy.append_ciast_tlak] //[-h*0.1,2500,h*1.1,-100]
		,	showCopyright:false
		,	axis:true
		,	zoom: {
				factorX: grafy.zoom_faktorX, //1.25,
				factorY: grafy.zoom_faktorY,  //1.25,
				wheel: true,
				needshift: true,
				eps: 0.1
			}
		}); 
	vrstvy.forEach( 
		function(v,i,a) {
			var p1 = board_SP.create('point',[v.start_x,grafy.min_ciast_tlak/*+0*/],{fixed:true, size:0.2, name:''})
			,	p2 = board_SP.create('point',[v.start_x,grafy.max_ciast_tlak/*+2400*/],{fixed:true, size:0.2, name:''})
			,	p3 = board_SP.create('point',[v.start_x+v.hrubka_materialu,grafy.max_ciast_tlak/*+2400*/],{fixed:true, size:0.2, name:''})
			,	p4 = board_SP.create('point',[v.start_x+v.hrubka_materialu,grafy.min_ciast_tlak/*+0*/],{fixed:true, size:0.2, name:''})
			;
		//  board_SP.create('polygon',[[v.start_x, 0], [v.start_x, 80], [v.start_x+v.hrubka_materialu, 80], [v.start_x+v.hrubka_materialu, 0]]);
			board_SP.create('polygon',[p1,p2,p3,p4],{withLines:false,fillColor:rainbow(cnt, i) });
		}
	);		
	board_SP.create('functiongraph',[TlakNasPar, 0, kalkul.hrubka_fragment] );
	board_SP.create('functiongraph',[SkutTlakPar, 0, kalkul.hrubka_fragment], { strokeColor: 'green', name: 'pD'} );
}
//# vykreslenie tabulky nas./skut./delta tlakov vod.par ( Rozdelenie tlakov vodných pár vo fragmente - skutočná mierka )
//# pouzite: vrstvy[i].vonkajsi_tlakNasPar
//# 	kalkul.vnutorny_tlakNasPar, kalkul.vonkajsi_tlakNasPar, kalkul.pvi, kalkul.pve
function tabl_fragment_skut_tlak( tbl ) {
	var tbl = tbl || document.getElementById('tblbox_tlaky');
	if ( ! tbl ) {
		return;
	}
	// clean
	while( tbl.childNodes.length ) {
		tbl.removeChild(tbl.firstChild);
	}
	// fill
	var tdn = '', tdd = '', tdd1 = '', tdd2 = '';
	for (var i=0; i < vrstvy.length; i++) {
		tdn+='<td>'+(i+1)+'</td>';
		tdd+='<td>'+(vrstvy[i].vonkajsi_tlakNasPar.toFixed(2))+'</td>';
		tdd1+='<td>'+(vrstvy[i].vonkajsi_skutTlakPar.toFixed(2))+'</td>';
		tdd2+='<td>'+( (vrstvy[i].vonkajsi_tlakNasPar - vrstvy[i].vonkajsi_skutTlakPar).toFixed(2))+'</td>';
	}
	tbl.innerHTML = '<tr><td><b>vrstva</b></td><td>Interiér</td>'+tdn+'<td>Exteriér</td></tr>'
	+	'<tr><td><b>PSat</b></td><td>'+(kalkul.vnutorny_tlakNasPar.toFixed(2))
		+'</td>'+tdd+'<td>'+(kalkul.vonkajsi_tlakNasPar.toFixed(2))+'</td></tr>'
	+	'<tr><td><b>Pd</b></td><td>'+(kalkul.pvi.toFixed(2))
		+'</td>'+tdd1+'<td>'+(kalkul.pve.toFixed(2))+'</td></tr>'
	+	'<tr><td><b>PSat - Pd</b></td><td>'+( (kalkul.vnutorny_tlakNasPar - kalkul.pvi).toFixed(2))
		+'</td>'+tdd2+'<td>'+( (kalkul.vonkajsi_tlakNasPar - kalkul.pve).toFixed(2))+'</td></tr>'
	;
}

/* tato funkcia pocita intersection pomocou jsxgraf.js sem-tam chybne ! - nahradene vypoctom pomocou 2D.js kniznice !
function isekt() {

var shape1 = new Path(grafika.f.rendNode);
var shape2 = new Line(grafika.p.rendNode);
var shapes = []; shapes.push(shape1); shapes.push(shape2);
var inter = Intersection.intersectShapes( shapes[0], shapes[1] );

var c0 = new JXG.Coords(JXG.COORDS_BY_SCREEN,[inter.points[0].x,inter.points[0].y],grafika.b);
var c1 = new JXG.Coords(JXG.COORDS_BY_SCREEN,[inter.points[1].x,inter.points[1].y],grafika.b);

grafika.b.create('point',[
//                function(){ 
//                  var c = new JXG.Coords(JXG.COORDS_BY_SCREEN,[inter.points[0].x,inter.points[0].y],grafika.b);
//                  return c.usrCoords[1];
//                },
				c0.usrCoords[1]
//                function(){ 
//                  var c = new JXG.Coords(JXG.COORDS_BY_SCREEN,[inter.points[0].x,inter.points[0].y],grafika.b);
//                  return c.usrCoords[2];
//                }
			  ,	c0.usrCoords[2]
              ],{name:'BIM', withLabel:true});
grafika.b.create('point',[
//                function(){ 
//                  var c = new JXG.Coords(JXG.COORDS_BY_SCREEN,[inter.points[1].x,inter.points[1].y],grafika.b);
//                  return c.usrCoords[1];
//                },
				c1.usrCoords[1]
//                function(){ 
//                  var c = new JXG.Coords(JXG.COORDS_BY_SCREEN,[inter.points[1].x,inter.points[1].y],grafika.b);
//                  return c.usrCoords[2];
//                }
			  ,	c1.usrCoords[2]
              ],{name:'MIB', withLabel:true});
}
*/

/* blok pomocnych funkcii na riesenie kondezacnej zony */
function moveGliders(i) {
	var glider_kS = grafika.b.elementsByName['kS'+i]
	,	glider_kE = grafika.b.elementsByName['kE'+i]
	,	pos_kS = glider_kS && glider_kS.position
	,	pos_kE = glider_kE && glider_kE.position
	,	tf = function() {
			if (pos_kS && pos_kE && pos_kE > pos_kS) {
				pos_kS++;
				glider_kS.setGliderPosition(pos_kS); 
				pos_kE--;
				glider_kE.setGliderPosition(pos_kE); 
				
				JXG.Math.Geometry.distPointLine(grafika.pve.coords.usrCoords,grafika.t2.stdform);
			} else {
				clearInterval(timerX);
			}
		}
	,	timerX = setInterval( tf, 10 )
	;
}

function checkYpoint (p1,p2) {
	var y1 = p1.coords.usrCoords[2]
	,	y2 = p2.coords.usrCoords[2]
	;
//	return y1-y2;	// 0...presne sedi, >0 ... p1 je NAD p2, <0 ... p1 je POD p2
	return (y1 == y2) ? 0 : ( (y1 > y2) ? 1 : -1 ) ;
}
var MIN_Y_DISTANCE_OF_POINTS = 0.001;
function checkXminDist (x1,x2) {
	return Math.abs(x1 - x2) < MIN_Y_DISTANCE_OF_POINTS;
}
function slide_kond( range, desc ) {	
	// vypocitam stred
	range.middle = range.start - ( range.start - range.end ) / 2;
	range.glider.setGliderPosition(range.middle);
	grafika.b.update();
	
	// informacia o pozicii pohybovaneho bodu p1 voci vztaznemu p2
	// 0 ... su zhodne, 1 ... p1 nad p2, -1 ... p1 pod p2
	var dir = checkYpoint (range.mover, range.refer)
	;
	if ( (dir == 0) // ak som trafil, alebo nemam uz co delit, koncim
		|| checkXminDist (range.start , range.end)
		) {
		return 0;
	}
	if (dir < 0) {
		range.end = range.middle;
	} else {
		range.start = range.middle;
	}
/*konzola*/console.log(desc + ": dir:"+dir+",start:"+range.start+",end:"+range.end);
	return 1;
}

function set_Range_E (i) {
	var range_E = { 
			start: grafika["kE"+i].position
		,	end  : grafika["kS"+i].position
		,	glider : grafika["kE"+i]
		,	refer : grafika.pve
		,	mover : grafika["pveX"+i]
		}
	;	
	return range_E;
}
function set_Range_I (i) {
	var range_I = { 
			start: grafika["kS"+i].position
		,	end  : grafika["kE"+i].position
		,	glider : grafika["kS"+i]
		,	refer : grafika.pvi
		,	mover : grafika["pviX"+i]
		}
	;	
	return range_I;
}

//# funkcia pocita s vyssou presnostou intersekciu line-path
//# osadenim presnych (usrCoords) suradnic do virtualnej SVG path a line
function checkIntersect() {
	var point1 = grafika.p.point1.coords.usrCoords
	,	p1 = { x:point1[1], y:point1[2]	}
	,	point2 = grafika.p.point2.coords.usrCoords
	,	p2 = { x:point2[1], y:point2[2]	}
	,	aLine = (p2.y-p1.y)/(p2.x-p1.x)
	,	bLine = p1.y - aLine*p1.x
	,	pP, pT, delta
	;
	var svgNS = "http://www.w3.org/2000/svg"
	,	line = document.createElementNS(svgNS,"line")
	,	path = document.createElementNS(svgNS,"path")
	,	d=""
	;
	line.setAttributeNS(null,"x1",p1.x);
	line.setAttributeNS(null,"y1",p1.y);
	line.setAttributeNS(null,"x2",p2.x);
	line.setAttributeNS(null,"y2",p2.y);
	
	grafika.f.points.forEach( function(v,i,a) {
		pT = { x: v.usrCoords[1], y: v.usrCoords[2] };
		if (isNaN(pT.x) || isNaN(pT.y) ) {
			/*console.log*/konzola('NaN pT at grafika.f.points index:'+i);
		} else {
			pP = { x: pT.x, y: aLine*pT.x+bLine };
			delta = pT.y - pP.y;
			if (delta < 0) {
				console.log(pT.x, delta);
			}
			d+= (i?"L":"M")+pT.x+" "+pT.y+" ";
		}
	});
	path.setAttributeNS(null,"d",d);
	var inter = Intersection.intersectShapes( new Path(path), new Line(line) );
/*	vypada to tak, ze pokial sa nejedna o uplne prvy a uplne posledny bod krivky
ciara krivku presekava VZDY v dvojiciach bodov, aj v pripade presneho dotyku 
... (segment zlava do zlomu, segment zo zlomu pokracujuci).
Pokial teda vylucujem 100% vlhosti exterieru a interieru, koncove body nikdy nebudu dotykove 
*/		
	return inter;
}

povrchova_kondenzacia = false;
//# vykreslenie obsahu kondenzacie vod.par ( Výpočet kondenzácie vo fragmente - mierka difúznych odporov )
//# pouzite: vrstvy[i].start_x, vrstvy[i].hrubka_materialu
//# 	kalkul.hrubka_fragment a vykreslovacia funkcia TlakNasPar a SkutTlakPar
function solveCondensationZone( ex_inter ) {
	/* najprv rozhodneme o tom, ci treba kondenzacnu zonu vobec pocitat:
ak teoreticka priamka ciastkoveho tlaku vodnych par vypocitana pre interier a exterier
podla teploty a vlhkosti nema priesecniky s krivkou ciastkoveho tlaku nasytenych vodnych par,
ku kondenzacii nebude dochadzat.
Ak ma jediny priesecnik, jedna sa o dotycnicu, a budeme sa zaoberat kondenzaciou v zone
	*/
	var	scr_usr = (typeof ex_inter == 'undefined')
	,	inter = !scr_usr ?  ex_inter : Intersection.intersectShapes( new Path(grafika.f.rendNode), new Line(grafika.p.rendNode) )
	,	i, cnt = inter.points.length
	,	ks_x,ks_y,ke_x,ke_y
	,	force_gliding = false
	;
	if (cnt%2) {	// pokial chyba posledny bod (prosty priesek ciary funkciou)
//			var pocet_points_f = grafika.f.points.length	// dam podsledny bod grafika.f
//			,	posledny_bod_krivky_f = grafika.f.points[pocet_points_f-1].usrCoords
//			;
//			inter.points.push( new Point2D( posledny_bod_krivky_f[1], posledny_bod_krivky_f[2] ) )
//	/*console.log*/konzola('Prosty priesecnik - pridavam posledny bod krivky (pve) ???');
			povrchova_kondenzacia = true;
			var prvy_bod_krivky_f = grafika.f.points[/*0*/1].usrCoords
		// z nejakeho dovodu nechce prijat 0 bod - skoci na koniec krivky !!! je to v jsxgraphcore.js !!!
			,	priesecnik = inter.points.pop()
			;
			if (cnt > 1) {	
konzola('Nasledny prosty priesecnik - predvlozim predchadzajuci priesecnik ???');
				var predchodca = inter.points.pop();
				inter.points.push(predchodca);	// vratim naspat
				inter.points.push(predchodca);	// pridam opat
			} else {
konzola('prosty priesecnik - predvlozim prvy bod krivky f ???');
				inter.points.push( new Point2D( prvy_bod_krivky_f[1], prvy_bod_krivky_f[2] ) );	
			}
			inter.points.push(priesecnik);
			cnt = inter.points.length;
			force_gliding = true;
	}
	
	kalkul.kond = [];
	var kond_pocet_zon = cnt/2; 
	for (i=0; i < kond_pocet_zon; i++) {
		kalkul.kond.push({});
		
		if (scr_usr) {
			var c0 = new JXG.Coords(JXG.COORDS_BY_SCREEN,[inter.points[2*i+0].x,inter.points[2*i+0].y],grafika.b)
			,	c1 = new JXG.Coords(JXG.COORDS_BY_SCREEN,[inter.points[2*i+1].x,inter.points[2*i+1].y],grafika.b)
			;
			ks_x = c0.usrCoords[1];
			ks_y = c0.usrCoords[2];
			ke_x = c1.usrCoords[1];
			ke_y = c1.usrCoords[2];
		} else {
			ks_x = inter.points[2*i+0].x;
			ks_y = inter.points[2*i+0].y;
			ke_x = inter.points[2*i+1].x;	// zabezpecim aj 1 bod - dotycnicu
			ke_y = inter.points[2*i+1].y;
		}
		grafika["kS"+i] = board_Pe.create('glider', [ks_x, ks_y, grafika.f],{name:'kS'+i});
		if (force_gliding && (kond_pocet_zon == 1)) {
			grafika["kS"+i].setGliderPosition(1);	// ani tu nemozem dat 0 - jsxgraphcore.js !!!
		}		
		grafika["kE"+i] = board_Pe.create('glider', [ke_x, ke_y, grafika.f],{name:'kE'+i});
		grafika["tS"+i] = board_Pe.create('tangent', [grafika["kS"+i]], {dash:1,strokewidth:0.5} );
		grafika["tE"+i] = board_Pe.create('tangent', [grafika["kE"+i]], {dash:1,strokewidth:0.5} );

// toto treba pocitat vo vzajomnej suvislosti s predchadzajucou a nasledujucou zonou !!!			
// provizorne pocitam (nespravne) PRE KAZDU ZONU s pvi a pve 
		grafika["pviX"+i] = grafika.b.create('intersection',[board_Pe.defaultAxes.y,grafika["tS"+i]],{size:0.2, name:''});
		grafika["pveX"+i] = grafika.b.create('intersection',[grafika.y2,grafika["tE"+i]],{size:0.2, name:''});
		
		kalkul.kond[i].druh_kondenzacie = 1;
		if ( ! force_gliding && (	
				(checkYpoint(grafika["pviX"+i], grafika.pvi) < 0 ) 
			||	(checkYpoint(grafika["pveX"+i], grafika.pve) < 0 ) 
			)
		) {
			konzola('Nespravny zakladny stav dotycnic, vypada na kondenzaciu v ploche !!');
			kalkul.kond[i].druh_kondenzacie =  /*-1*/ 2;	// ... vypada na kondenzaciu v ploche
		} else {
		/* hladanie dotycnic (tangent) budeme realizovat inteligentne metodou delenia X intervalov :
		Budem si odpamatovavat a priebezne upravovat hranice intervalu.
		Najdem stred intervalu, a presuniem don glider. Automaticky sa mi upravi tangenta a priesecnik na osi.
		Podla toho, ci osovy priesecnik sadne nad, ci pod vztazny bod ('pvi','pve'), pokracujem 
		dalsim delenim intervalu vpravo, ci vlavo od aktualnej pozicie glider-a
		*/	
			/* zacneme od exterieru, posuvajuc bod 'kE', deliac interval voci bodu 'kS',
		ocakavajuc, ze sa k vysledku dostaneme rychlejsie:
		chceme aby dotycnica funkcie 'f' ... ciastkovy tlak nasystenych vosnych par
		strielala presne do bodu pve, prostrednictvom svojho priesecnika pveX
			*/
			var range_E = set_Range_E(i);
			while(slide_kond(range_E,'fromExterior'));
			/* pokracujeme interierom, posuvajuc bod 'kS', deliac interval ku bodu dotyku 'kE':
		chceme aby dotycnica funkcie 'f' ... ciastkovy tlak nasystenych vosnych par
		strielala presne do bodu pvi, prostrednictvom svojho priesecnika pviX
			*/
			var range_I = set_Range_I(i);
			while(slide_kond(range_I,'fromInterior'));
			if (grafika["kS"+i].position > grafika["kE"+i].position) {
				var inte = grafika["kS"+i].position
				,	exte = grafika["kE"+i].position
				;
				range_I.glider.setGliderPosition(exte);
				range_E.glider.setGliderPosition(inte);
				grafika.b.update();
			}
		}
	// mozeme namalovat skutocny priebeh ciastoveho tlaku vodnej pary:	
		grafika["pvi_kS"+i] = board_Pe.create('segment', [grafika.pvi,grafika["kS"+i]], { strokeColor: 'green', name: 'pvi_kS'+i} );
	//	board_Pe.create('segment', [grafika["kS"+i],grafika["kE"+i]], { strokeColor: 'green', name: 'kS_kE'+i} );
		grafika["kE_pve"+i] = board_Pe.create('segment', [grafika["kE"+i],grafika.pve], { strokeColor: 'green', name: 'kE_pve'+i} );
		
		kalkul.kond[i].ekviStart = grafika["kS"+i].coords.usrCoords[1];
		kalkul.kond[i].ekviEnd = grafika["kE"+i].coords.usrCoords[1];
		if (Math.abs(kalkul.kond[i].ekviStart - kalkul.kond[i].ekviEnd) <= MIN_Y_DISTANCE_OF_POINTS) {
			kalkul.kond[i].druh_kondenzacie = 2;	// kondenzuje plosne
		}
		kalkul.kond[i].Start = ekviX(kalkul.kond[i].ekviStart);
		kalkul.kond[i].End = ekviX(kalkul.kond[i].ekviEnd);
		
		kalkul.kond[i].Start_slope = grafika["pvi_kS"+i].getSlope();
		kalkul.kond[i].Start_rise = grafika["pvi_kS"+i].getRise();
		kalkul.kond[i].End_slope = grafika["kE_pve"+i].getSlope();
		kalkul.kond[i].End_rise = grafika["kE_pve"+i].getRise();

	// vykreslenie kondenzacnej zony v mierke difuznych odporov
		draw_fragment_konde_zone( board_Pe, kalkul.ekvivalent_hrubka_fragment, kalkul.kond[i].ekviStart, kalkul.kond[i].ekviEnd );
		
		kalkul.kond[i].Start_rd = DifOdpor_x(kalkul.kond[i].Start);
		kalkul.kond[i].End_rd = /*kalkul.difuznyOdpor_fragment - */ DifOdpor_x(kalkul.kond[i].End);	
		
	//	kalkul.kond[i].Start_psat = TlakNasPar(kalkul.kond[i].Start);
	//	kalkul.kond[i].End_psat = TlakNasPar(kalkul.kond[i].End);
	
	// odpamatame si aj vonkajsie parametre:
		kalkul.kond[i].vnutorna_teplota = kalkul.vnutorna_teplota;
		kalkul.kond[i].vnutorna_vlhkost = kalkul.vnutorna_vlhkost;
		kalkul.kond[i].vonkajsia_teplota = kalkul.vonkajsia_teplota;
		kalkul.kond[i].vonkajsia_vlhkost = kalkul.vonkajsia_vlhkost;
	}

	kalkul.pocet_zon_kondenzacie = kalkul.kond.length;
	
	prepocet_kond_zone();
	mnozstva_kondenzacie();
	
	return 0;	//retval;
}


//# prepocet kondenzacnych parametrov s predurcenymi kond.zonami
//# pre inu teplotu a vlhkost
//# 	vysledkom su difuzne toky z interieru a do exterieru
function prepocet_kond_zone() {
	if (kalkul.kond.length) {
	
		TlakPar_Fragment();	// prepocet pvi, pve
		
		kalkul.kond.unshift({
			End_psat : kalkul.pvi
		,	End_rd : 0
		});
		kalkul.kond.push({
			Start_psat : kalkul.pve
		,	Start_rd : kalkul.difuznyOdpor_fragment
		});
		for (var i=1; i < kalkul.kond.length - 1; i++) {		
			kalkul.kond[i].Start_psat = TlakNasPar(kalkul.kond[i].Start);	// prepocet tlakov nasytenych par
			kalkul.kond[i].End_psat = TlakNasPar(kalkul.kond[i].End);
		}
		for (var i=1; i < kalkul.kond.length - 1; i++) {
			kalkul.kond[i].difuzny_tok_i = ( kalkul.kond[i-1].End_psat - kalkul.kond[i].Start_psat ) 
										/ ( kalkul.kond[i].Start_rd - kalkul.kond[i-1].End_rd )
										;
if (kalkul.kond[i].difuzny_tok_i < 0) {
konzola('POZOR, kalkul.kond[i].difuzny_tok_i < 0 !');	
//	kalkul.kond[i].difuzny_tok_i = 0;
}
			kalkul.kond[i].difuzny_tok_e = ( kalkul.kond[i].End_psat - kalkul.kond[i+1].Start_psat ) 
										/ ( kalkul.kond[i+1].Start_rd - kalkul.kond[i].End_rd )
										;
if (kalkul.kond[i].difuzny_tok_e < 0) {
konzola('POZOR, kalkul.kond[i].difuzny_tok_e < 0 !');	
//	kalkul.kond[i].difuzny_tok_e = 0;
}
			var mkp = kalkul.kond[i].difuzny_tok_i - kalkul.kond[i].difuzny_tok_e;
			kalkul.kond[i].mnozstvo_kondenzujucej_pary = (mkp >= 0) ? mkp : 0;
			kalkul.kond[i].mnozstvo_vyparitelnej_pary = (mkp < 0) ? -mkp : 0;
		}
		kalkul.kond.pop();
		kalkul.kond.shift();
	}	
}
function mnozstva_kondenzacie() {
//vypocet celkovej kondenzacie  - vychadzajuc z rovnovahy difuznych tokov
// vysledne mnozstvo by malo byt rozdiel vchadzajucej vlhkosti do zaciatku prvej k.z
// minus vychadzajucej vlhkosti z poslednej zony
// TODO ... riesit aj zapornu kondenzaciu - VYSUSOVANIE !!!
	var kdt, mkp;
	if (kalkul.kond.length > 0) {
		var n = kalkul.kond.length - 1;
// difuzne toky ... kg / ( m2 x sec )
		kalkul.difuzny_tok_i = ( kalkul.pvi - kalkul.kond[0].Start_psat ) / kalkul.kond[0].Start_rd;
		kalkul.difuzny_tok_e = ( kalkul.kond[n].End_psat - kalkul.pve ) / ( kalkul.difuznyOdpor_fragment - kalkul.kond[n].End_rd );
// rychlosti kondenzovania a vyparovania ... kg / ( m2 x sec )
		mkp = kalkul.difuzny_tok_i - kalkul.difuzny_tok_e;
		kalkul.mnozstvo_kondenzujucej_pary = (mkp >= 0) ? mkp : 0;
		kalkul.mnozstvo_vyparitelnej_pary = (mkp < 0) ? -mkp : 0;
// kontrola spravnosti pomocou spocitania jednotlivych kondenzacnych zon:
		kalkul.mnozstvo_kondenzujucej_pary_fragment = 0;
		kalkul.mnozstvo_vyparitelnej_pary_fragment = 0;
		for (i=0; i < kalkul.kond.length; i++) {
			kalkul.mnozstvo_kondenzujucej_pary_fragment += kalkul.kond[i].mnozstvo_kondenzujucej_pary;
			kalkul.mnozstvo_vyparitelnej_pary_fragment += kalkul.kond[i].mnozstvo_vyparitelnej_pary;
		}		
	} else {
		kdt = ( kalkul.pvi - kalkul.pve ) / kalkul.difuznyOdpor_fragment;
// difuzne toky ... kg / ( m2 x sec )
		kalkul.difuzny_tok_i = (kdt >= 0) ? kdt : 0;
		kalkul.difuzny_tok_e = (kdt < 0) ? -kdt : 0;
// rychlosti kondenzovania a vyparovania ... kg / ( m2 x sec )
		mkp = kalkul.difuzny_tok_i - kalkul.difuzny_tok_e;
		kalkul.mnozstvo_kondenzujucej_pary_fragment = kalkul.mnozstvo_kondenzujucej_pary = (mkp >= 0) ? mkp : 0;
		kalkul.mnozstvo_vyparitelnej_pary_fragment = kalkul.mnozstvo_vyparitelnej_pary = (mkp < 0) ? -mkp : 0;
	}
	
}

//# prepocet kondenzacnych parametrov s predurcenymi kond.zonami ALE uvazujuc JADRA
//# beruc ako spranu iba END poziciu
//# pre inu teplotu a vlhkost
//# 	vysledkom su difuzne toky z interieru a do exterieru
function prepocet_kond_zone_jadro( jadra ) {
	if (jadra.length) {
	
		TlakPar_Fragment();	// prepocet pvi, pve
		
		jadra.unshift({
			End_psat : kalkul.pvi
		,	End_rd : 0
		});
		jadra.push({
			End_psat : kalkul.pve	//	!!!
		,	End_rd : kalkul.difuznyOdpor_fragment	// !!!
		,	Start_psat : kalkul.pve
		,	Start_rd : kalkul.difuznyOdpor_fragment
		});
		for (var i=1; i < jadra.length - 1; i++) {		
			jadra[i].Start_psat = TlakNasPar(jadra[i].Start);	// prepocet tlakov nasytenych par
			jadra[i].End_psat = TlakNasPar(jadra[i].End);
		}
		for (var i=1; i < jadra.length - 1; i++) {
			jadra[i].difuzny_tok_i = ( jadra[i-1].End_psat - jadra[i].End_psat/*Start_psat*/ ) 
										/ ( jadra[i].End_rd/*Start_rd*/ - jadra[i-1].End_rd )
										;
if (jadra[i].difuzny_tok_i < 0) {
konzola('POZOR, jadra[i].difuzny_tok_i < 0 !');	
//	jadra[i].difuzny_tok_i = 0;
}
			jadra[i].difuzny_tok_e = ( jadra[i].End_psat - jadra[i+1].End_psat/*Start_psat*/ ) 
										/ ( jadra[i+1].End_rd/*Start_rd*/ - jadra[i].End_rd )
										;
if (jadra[i].difuzny_tok_e < 0) {
konzola('POZOR, jadra[i].difuzny_tok_e < 0 !');	
//	jadra[i].difuzny_tok_e = 0;
}
			var mkp = jadra[i].difuzny_tok_i - jadra[i].difuzny_tok_e;
			jadra[i].mnozstvo_kondenzujucej_pary = (mkp >= 0) ? mkp : 0;
			jadra[i].mnozstvo_vyparitelnej_pary = (mkp < 0) ? -mkp : 0;
		}
		jadra.pop();
		jadra.shift();
	}	
}
function mnozstva_kondenzacie_jadro( jadra ) {
//vypocet celkovej kondenzacie  - vychadzajuc z rovnovahy difuznych tokov
// vysledne mnozstvo by malo byt rozdiel vchadzajucej vlhkosti do zaciatku prvej k.z
// minus vychadzajucej vlhkosti z poslednej zony
// TODO ... riesit aj zapornu kondenzaciu - VYSUSOVANIE !!!
	var kdt, mkp;
	if (jadra.length > 0) {
		var n = jadra.length - 1;
// difuzne toky ... kg / ( m2 x sec )
		kalkul.difuzny_tok_i = ( kalkul.pvi - jadra[0].End_psat/*Start_psat*/ ) / jadra[0].End_rd/*Start_rd*/;
		kalkul.difuzny_tok_e = ( jadra[n].End_psat - kalkul.pve ) / ( kalkul.difuznyOdpor_fragment - jadra[n].End_rd );
// rychlosti kondenzovania a vyparovania ... kg / ( m2 x sec )
		mkp = kalkul.difuzny_tok_i - kalkul.difuzny_tok_e;
		kalkul.mnozstvo_kondenzujucej_pary = (mkp >= 0) ? mkp : 0;
		kalkul.mnozstvo_vyparitelnej_pary = (mkp < 0) ? -mkp : 0;
// kontrola spravnosti pomocou spocitania jednotlivych kondenzacnych zon:
		kalkul.mnozstvo_kondenzujucej_pary_fragment = 0;
		kalkul.mnozstvo_vyparitelnej_pary_fragment = 0;
		for (i=0; i < jadra.length; i++) {
			kalkul.mnozstvo_kondenzujucej_pary_fragment += jadra[i].mnozstvo_kondenzujucej_pary;
			kalkul.mnozstvo_vyparitelnej_pary_fragment += jadra[i].mnozstvo_vyparitelnej_pary;
		}		
	} else {
		kdt = ( kalkul.pvi - kalkul.pve ) / kalkul.difuznyOdpor_fragment;
// difuzne toky ... kg / ( m2 x sec )
		kalkul.difuzny_tok_i = (kdt >= 0) ? kdt : 0;
		kalkul.difuzny_tok_e = (kdt < 0) ? -kdt : 0;
// rychlosti kondenzovania a vyparovania ... kg / ( m2 x sec )
		mkp = kalkul.difuzny_tok_i - kalkul.difuzny_tok_e;
		kalkul.mnozstvo_kondenzujucej_pary_fragment = kalkul.mnozstvo_kondenzujucej_pary = (mkp >= 0) ? mkp : 0;
		kalkul.mnozstvo_vyparitelnej_pary_fragment = kalkul.mnozstvo_vyparitelnej_pary = (mkp < 0) ? -mkp : 0;
	}
	
}


//# vykreslenie zony kondenzacie vod.par board_Pe ( Výpočet kondenzácie vo fragmente - mierka difúznych odporov )
function draw_fragment_konde_zone( board, h, x1, x2, pattId, pattBody ) {	
	pattId = pattId || 'lightstripe';
	pattBody = pattBody || 
	'<pattern xmlns="http://www.w3.org/2000/svg" width="5" height="5" patternUnits="userSpaceOnUse" id="'+pattId+'">'
+	'  <rect width="5" height="5" fill="transparent"/>'
+	'  <path d="M0 5L5 0ZM6 4L4 6ZM-1 1L1 -1Z" stroke="#888" stroke-width="1"/>'
+	'</pattern>'
	;
	var svg = board.renderer.svgRoot 	
	,	ns = svg.namespaceURI
	,	defs = svg.querySelector('defs')
	,	patt = svg.querySelectorAll('defs pattern#'+pattId)
	;
	if (! defs) {
		defs = svg.insertBefore(
			svg.ownerDocument.createElementNS(ns,'defs')
		,	svg.firstElementChild
		);
	}
	if ( ! patt.length ) {
		defs.innerHTML +=  pattBody;
	}
	var p1 = board.create('point',[x1,grafy.min_ciast_tlak-100/*+0*/],{fixed:true, size:0.2, name:''})
	,	p2 = board.create('point',[x1,grafy.max_ciast_tlak*1.050/*+2400*/],{fixed:true, size:0.2, name:''})
	,	p3 = board.create('point',[x2,grafy.max_ciast_tlak*1.050/*+2400*/],{fixed:true, size:0.2, name:''})
	,	p4 = board.create('point',[x2,grafy.min_ciast_tlak-100/*+0*/],{fixed:true, size:0.2, name:''})
	,	poly = board.create('polygon',[p1,p2,p3,p4],{
			highlight:false,	withLines:true,	strokeColor:'black',
			fillColor:'url(#'+pattId+')', fillOpacity: 0.7,	name:'kondZone' }
		)
	;
//	poly.rendNode.setAttribute('fill','url(#'+pattId+')');
}
//  draw_fragment_konde_zone( board_SP, kalkul.hrubka_fragment, kalkul.kond_Start, kalkul.kond_End );
//  draw_fragment_konde_zone( board_Pe, kalkul.ekvivalent_hrubka_fragment, kalkul.kond_ekviStart, kalkul.kond_ekviEnd );


/*# funkcia Prepocet je totalny kombajn spracujuci vsetko od zaciatku do konca jednym vrzom
so standartne kompletnym nacitanim udajov vo formularoch a generovanim vysledneho reportu.
Zadanim nenuloveho parametra 'prep' ma moznost vykonat iba prepocet velicin
za ucelom vypocitavania napr. mesacnych hodnot s im priradenymi teplotami
*/
// ovplyvnuju ju globaly: zima_leto
function Prepocet( dry ) {	// komplet vypocet pre jednu konkretnu sadu teplotyExt, vlhkostiExt a teplotyInt, vlhkostiInt
	TepOdpor_Fragment();
	SucinitelPrechoduTepla_fragment();
	TeplotyVrstiev();
	TlakPar_Fragment();
	TlakNasParVrstiev();
	
	draw_fragment_tepl();	tabl_fragment_tepl();
	draw_fragment_tlak();	tabl_fragment_tlak();
	
	draw_fragment_tepl_ekvi();
	draw_fragment_tlak_ekvi();
	
	var zobraz_kond = true;
	kalkul.vnutorna = db_isover.druh_konstrukcie[document.forms.fragment.elements.druh_konstrukcie.value-1].vnutorna;
	kalkul.pocitat_kondenzaciu = document.forms.fragment.elements.pocitat_kondenzaciu.checked;
	if ( (kalkul.vnutorna > 0) && !kalkul.pocitat_kondenzaciu) {
		kalkul.pocet_zon_kondenzacie = -1;	// kondenzacia sa neposudzuje
		kalkul.kond = [];
		zobraz_kond = false;
	} else {
		solveCondensationZone( checkIntersect() );
		tabl_fragment_kond_zone();
	}

	var blokatory_tlakov_a_kondenzacie = document.querySelectorAll('div.blokator_tlakov_a_kondenzacie');
	for (var i=0; i<blokatory_tlakov_a_kondenzacie.length; i++) {
		blokatory_tlakov_a_kondenzacie[i].style.display = (zobraz_kond ? '' : 'none');
	}
		
	if ( kalkul.pocet_zon_kondenzacie <= 0 ) {
// pokial nie je kondenzacia, osadime IBA hodnoty potrebne pre vykreslenie ciary skutocneho parcialneho tlaku
		kalkul.kond.push({
			ekviStart : kalkul.ekvivalent_hrubka_fragment
		,	Start : kalkul.hrubka_fragment
		,	Start_slope : grafika.p.getSlope()
		,	Start_rise : grafika.p.getRise()
		});
	}
	SkutTlakParVrstiev();
	draw_fragment_skut_tlak();	tabl_fragment_skut_tlak();
	if ( kalkul.pocet_zon_kondenzacie > 0 ) {
		for (var i=0; i<kalkul.kond.length; i++) {
			draw_fragment_konde_zone( board_SP, kalkul.hrubka_fragment, kalkul.kond[i].Start, kalkul.kond[i].End );
		}
	} else {
		kalkul.kond = [];	// odstranime IBA hodnoty
	}
}

/*global*/var last_forms_content = {};
function primarVypocet() {
	zima_leto = 0;	// zakladny vypocet prebieha VZDY pre ZIMA u vsetkych VARIO
// akceptacia vyplnenych formularovych zadani
	last_forms_content = {}; Fproject.getForms(last_forms_content);
	Fproject.save();
	if (Fproject.fragment_project.vrstvy.length == 0) {
alert('Nie sú zadané žiadne vrstvy, nie je čo počítať !');		
		return false;
	}
// primarny vypocet, zistujuci hlavne, ci bude kondenzacia (kalkul.pocet_zon_kondenzacie > 0)
konzola(' primárny výpočet načítaním formulárov tve:'+kalkul.vonkajsia_teplota);
	Prepocet();
}
/*# funkcia Vypocet je totalny kombajn spracujuci vsetko od zaciatku do konca jednym vrzom
so standartne kompletnym nacitanim udajov vo formularoch a generovanim vysledneho reportu.
*/

function KontrolaZadania() {
	var  fp = Fproject.fragment_project;
	if (!fp) {
alert('Žiadny projekt nie je vypracovaný, niet s čím pracovať !');		
		return null;
	}
	if (Fproject.fragment_project.vrstvy.length == 0) {
alert('Nie sú zadané žiadne vrstvy, nie je čo počítať !');		
		return null;
	}
	var	ok = false
	,	pz = document.forms.popis_zakazky.elements	//fp.popis_zakazky['']
	;
	if (!pz.adresa.value || !pz.firma.value || !pz.investor.value || !pz.meno_projektanta.value 
		|| !pz.nazov_konstrukcie.value || !pz.nazov_stavby.value
	) {
		ok = confirm("Niektoré identifikačné údaje sú nevyplnené \n\
Stlačte 'OK' a vráťte sa na doplnenie do Menu - Popis zákazky \n\
ak chcete pokračovať aj tak, stlačte tlačítko 'Zrušiť'('Cancel')");
	}
	return !ok;
}
function AskVypocet( callback ) {
	if ( ! KontrolaZadania() ) {
		return false;
	}
	var actual_forms_content = {}; Fproject.getForms(actual_forms_content);
	if (JSON.stringify(actual_forms_content) != JSON.stringify(last_forms_content)) {
		Vypocet(callback);
/*
	} else if ( confirm(" ZÁVEREČNÁ KONTROLA : \n\
-------------------------------------\n\
Je potrebné vykonať opätovne Výpočet ?\n \
Ak nenastala žiadna zmena v zadavacích formulároch, \n\
stlačte tlačítko 'Zrušiť'('Cancel') a nebudeme sa zdržiavať výpočtom \n\
V opačnom prípade stlačte 'OK' a výpočet sa vykoná. \n\
POZOR, prebehnutie výpočtu je potrebné aj pre správne vyplnenie \n\
Výsledkovej zostavy prípadne doplnenými identifikačnými údajmi \n\
"
	)) {
		Vypocet(callback);
*/
	} else {
		if (typeof callback == 'function') {
			callback();
		}
	}
	return true;
}
/* AskerVypocet = {
	callback : null
,	favDialog : null
,	show : function () {
		AskerVypocet.favDialog = document.querySelector('dialog#askerVypocet');
		AskerVypocet.favDialog.showModal();
	}
,	Ok : function() {
		AskerVypocet.favDialog.close();
		var clbk = AskerVypocet.callback;
		AskerVypocet.callback = null;
		Vypocet(clbk);
	}
,	Cancel : function() {
		AskerVypocet.favDialog.close();
		var clbk = AskerVypocet.callback;
		AskerVypocet.callback = null;
		if (typeof clbk == 'function') {
			clbk();
		}
	}
} */

function Vypocet( callback ) {	// komplet vypocet
	var dkonzola = document.querySelector('div#konzola')
	,	resultator = function() {
	
//	vyhodnotenie_Umax
		kalkul.vyhovuje_Umax = (kalkul.sucinitelPrechoduTepla <= kalkul.uanew) ? '' : 'NE';
		
//	vyhodnotenie_kondenzacie
		kalkul.kondenzacia_bilancna = kondenzacia_bilancna;		// pole kondenzacnych parametrov pre kazdu bilancnu teplotu
		kalkul.b_mnozstvo_skondenzovanej_pary = b_mnozstvo_skondenzovanej_pary;							// vysledovka bilancie
		kalkul.b_mnozstvo_odparenej_pary = b_mnozstvo_odparenej_pary;									// vysledovka bilancie
		kalkul.bilancia_vodnej_pary = b_mnozstvo_skondenzovanej_pary - b_mnozstvo_odparenej_pary;		// vysledovka bilancie
		kalkul.kondenzacna_teplota = kondenzacna_teplota;												// vysledovka bilancie
		kalkul.kondenzacne_jadra_bilancia = kondenzacne_jadra_bilancia;	// pole najmensich kondenzacnych zon bilancie

		kalkul.vyhovuje_rocnej_bilancii_kond_pary = (kalkul.bilancia_vodnej_pary <= 0) ? '' : 'NE';
		if (kalkul.bilancia_vodnej_pary) {
			kalkul.vyhovuje_obmedzenej_bilancii_kond_pary = (kalkul.bilancia_vodnej_pary < kalkul.max_kondenz) ? '' : 'NE';
		}
	
		kalkul.kondenzacia_rocna = kondenzacia_rocna;		// pole kondenzacnych parametrov pre kazdy mesiac roka
		kalkul.m_mnozstvo_skondenzovanej_pary = m_mnozstvo_skondenzovanej_pary;								// vysledovka roka
		kalkul.m_mnozstvo_odparenej_pary = m_mnozstvo_odparenej_pary;										// vysledovka roka
		kalkul.mesacna_bilancia_vodnej_pary = m_mnozstvo_skondenzovanej_pary - m_mnozstvo_odparenej_pary;	// vysledovka roka
		kalkul.prvy_vysusujuci = prvy_vysusujuci;															// vysledovka roka
		kalkul.prvy_kondenzujuci = prvy_kondenzujuci;														// vysledovka roka
		kalkul.kond_rocna = kond_rocna;		// pole akumulacie a mesiac maxima pre kazdu kondenzacnu zonu
		kalkul.kondenzacne_jadra_mesiace = kondenzacne_jadra_mesiace;	// pole najmensich kondenzacnych zon roka
		
		kalkul.povrchova_kondenzacia = povrchova_kondenzacia;

		Vysledok();	// auto fill vystupov

		dkonzola.style.display='none';
		
		if (typeof callback == 'function') {
			callback();
		}
	}
	
	kondenzacia_bilancna = [];
	b_mnozstvo_skondenzovanej_pary = 0;
	b_mnozstvo_odparenej_pary = 0;
	kondenzacia_rocna = [];
	m_mnozstvo_skondenzovanej_pary = 0;
	m_mnozstvo_odparenej_pary = 0;
	
	dkonzola.style.display='';
	
	setTimeout( function() {
		primarVypocet();

		if (kalkul && (kalkul.vnutorna == 0/* len vonkajsie ! */) && (kalkul.pocet_zon_kondenzacie > 0)) {	// ?????

			var kuk = document.querySelector('table#tblbox_tlak');
			kuk && (kuk.scrollIntoView());

			bilancia_run( function() {
				cleanMesiace();
				month_run( function() {
					// vratenie zakladneho stavu
					primarVypocet();
					resultator();
				});
			});
		} else {
			resultator();
		}
	}, 1);
}

/*# funkcia bilancia_run prebehne vypocty pre teploty na zaklade DB tabulky pocetnost_teplot
*/
kondenzacia_bilancna = [];
kondenzacna_teplota = 0;
kondenzacne_jadra_bilancia = [];
function bilancia_run( callback ) {
	b_mnozstvo_skondenzovanej_pary = 0;
	b_mnozstvo_odparenej_pary = 0;
	t_max = 0;
	zima_leto = 0;	// zakladny vypocet prebieha VZDY pre ZIMA u vsetkych VARIO
	
	var pocetnosti = db_isover.pocetnost_teplot
	,	vypoctova_teplota = kalkul.vonkajsia_teplota	// pre rozhodnutie o nad/pod -15
	,	m = 0, ok = 1
	,	kondenzacny_beh = true
	,	tf = function() {
			if (! ok) {
				return;	// cakaj na dokoncenie predch. vypoctu
			}
			ok = 0;
			if (m >= pocetnosti.length) {
				clearInterval(timerX);
				kalkul.kondenzacia_bilancna = kondenzacia_bilancna;
				kalkul.b_mnozstvo_skondenzovanej_pary = b_mnozstvo_skondenzovanej_pary;
				kalkul.b_mnozstvo_odparenej_pary = b_mnozstvo_odparenej_pary;
				
			// vyhladame najnizsiu teplotu, kde este nekondenzuje
				kondenzacna_teplota = kondenzacia_bilancna[kondenzacia_bilancna.length-1].vonkajsia_teplota;
				for (var i=kondenzacia_bilancna.length-1; i>=0; i--) {
					if (kondenzacia_bilancna[i] && (typeof kondenzacia_bilancna[i].vonkajsia_teplota != 'undefined')) {
						if (kondenzacia_bilancna[i].mnozstvo_skondenzovanej_pary > 0) {
							break;
						}
						kondenzacna_teplota = kondenzacia_bilancna[i].vonkajsia_teplota;
					}
				}
				
				if (typeof callback == 'function') {
					callback();
				}
			} else {
				kalkul.kondenzacne_jadra_bilancia = kondenzacne_jadra_bilancia;
				
				kalkul.vonkajsia_teplota = parseFloat(pocetnosti[m].teplota);
				kalkul.vonkajsia_vlhkost = parseFloat(pocetnosti[m].vlhkost);
konzola(' vypocet kondenzacie pre teplotu '+kalkul.vonkajsia_teplota);
				var pp15 = parseFloat(pocetnosti[m].vyskyt_pod15_spolu)
				,	pn15 = parseFloat(pocetnosti[m].vyskyt_vr15_spolu)
				,	pocetnost_vyskytu_teplot = ((vypoctova_teplota < -15) ? pp15 : pn15) * 1000 
				;
				if ( ! isNaN(pocetnost_vyskytu_teplot)) {

					if (kondenzacny_beh) {
						Prepocet();
						if (kalkul.kond.length) {
	//	ak nemam este kondenzacne jadra ( m = 0 ), vyrobim ich
							if (! kondenzacne_jadra_bilancia.length) {	
								for (var i=0; i<kalkul.kond.length; i++) {
									kondenzacne_jadra_bilancia.push( Object.assign({}, kalkul.kond[i]) );
								}
	// ale ak ich ma, musim ich spravne priradit (postupujuc od najnizsej teploty nahor sa zony postupne eliminuju)
							} else {
								for (var i=0; i<kalkul.kond.length; i++) {
									var KKsx = kalkul.kond[i].Start, KKex = kalkul.kond[i].End
									,	EKsx = kalkul.kond[i].ekviStart, EKex = kalkul.kond[i].ekviEnd
									, idx = -1
									;
									for (var j = 0; j<kondenzacne_jadra_bilancia.length; j++) {
										var KJsx = kondenzacne_jadra_bilancia[j].Start, KJex = kondenzacne_jadra_bilancia[j].End
										,	EJsx = kondenzacne_jadra_bilancia[j].ekviStart, EJex = kondenzacne_jadra_bilancia[j].ekviEnd
										;
									//	if ( (KKsx >= KJsx) && (KKex <= KJex) ) {	KKex moze byt za KJex
									//	if ( (KKsx >= KJsx) && (KKsx <= KJex) ) {	ale aj KKsx moze byt pred KJsx
					// ako teda spravne identifikovat o pozostatok ktorej predchadzajucej zony sa jedna ???
										if ( (kondenzacne_jadra_bilancia.length == 1) 
											|| (EKsx >= EJsx - 2*MIN_Y_DISTANCE_OF_POINTS) && (EKex <= EJex + 2*MIN_Y_DISTANCE_OF_POINTS) 
										) {	
											idx = j; break;
										}
									}
									if (idx > -1) {
										kondenzacne_jadra_bilancia[idx] = Object.assign({}, kalkul.kond[i]);
									} else {
alert('Nedokazem priradit kondenzacnu zonu v bilancii pre teplotu '+kalkul.vonkajsia_teplota+', SORRY !');
									}
								}
							}
						} else {
							kondenzacny_beh = false;
							m-=1;	// zabezpecime prepocet aktualneho nekondenzujuceho 
						}
					} else {
						prepocet_kond_zone_jadro(kondenzacne_jadra_bilancia);
						mnozstva_kondenzacie_jadro(kondenzacne_jadra_bilancia);
					}						
					kalkul.teplota_vnutorneho_povrchu = kalkul.vnutorna_teplota 
						+ ( (kalkul.vonkajsia_teplota - kalkul.vnutorna_teplota) 
							/ (	kalkul.rsi + kalkul.tepelnyOdpor_fragment + kalkul.rse ) 
							* kalkul.rsi
						)
					;					
			// vcul treba odlozit pre bilancne spracovanie zaujimave hodnoty		
					kondenzacia_bilancna[m] = {
						vnutorna_teplota : kalkul.vnutorna_teplota
					,	vnutorna_vlhkost : kalkul.vnutorna_vlhkost	// ?? ako sa meni v mesiacoch ? 
					,	pvi	: kalkul.pvi
					,	vonkajsia_teplota : kalkul.vonkajsia_teplota
					,	vonkajsia_vlhkost : kalkul.vonkajsia_vlhkost
					,	pve	: kalkul.pve
					,	teplota_vnutorneho_povrchu : kalkul.teplota_vnutorneho_povrchu
					,	difuzny_tok_i : kalkul.difuzny_tok_i	
					,	difuzny_tok_e : kalkul.difuzny_tok_e
					,	mnozstvo_kondenzujucej_pary : kalkul.mnozstvo_kondenzujucej_pary
					,	mnozstvo_vyparitelnej_pary : kalkul.mnozstvo_vyparitelnej_pary
				,	mnozstvo_kondenzujucej_pary_fragment : kalkul.mnozstvo_kondenzujucej_pary_fragment
				,	mnozstvo_vyparitelnej_pary_fragment : kalkul.mnozstvo_vyparitelnej_pary_fragment
					,	pocetnost_vyskytu_teplot : pocetnost_vyskytu_teplot
					
					,	mnozstvo_skondenzovanej_pary : kalkul.mnozstvo_kondenzujucej_pary * pocetnost_vyskytu_teplot
					,	mnozstvo_odparenej_pary : kalkul.mnozstvo_vyparitelnej_pary * pocetnost_vyskytu_teplot
					};
					var kond = kondenzacny_beh ? kalkul.kond : kalkul.kondenzacne_jadra_bilancia;
					for (var i=0; i<kond.length; i++) {
						var kondznak = 'kond_'+(i+1)+'_';
						kondenzacia_bilancna[m][kondznak+'kondenzacny_beh'] = kondenzacny_beh;
						kondenzacia_bilancna[m][kondznak+'Start_psat'] = kond[i].Start_psat;
						kondenzacia_bilancna[m][kondznak+'Start_rd'] = kond[i].Start_rd;
						kondenzacia_bilancna[m][kondznak+'End_psat'] = kond[i].End_psat;
						kondenzacia_bilancna[m][kondznak+'End_rd'] = kond[i].End_rd;
						kondenzacia_bilancna[m][kondznak+'difuzny_tok_e'] = kond[i].difuzny_tok_e;
						kondenzacia_bilancna[m][kondznak+'difuzny_tok_i'] = kond[i].difuzny_tok_i;
						kondenzacia_bilancna[m][kondznak+'mnozstvo_kondenzujucej_pary'] = kond[i].mnozstvo_kondenzujucej_pary;
						kondenzacia_bilancna[m][kondznak+'mnozstvo_vyparitelnej_pary'] = kond[i].mnozstvo_vyparitelnej_pary;
						kondenzacia_bilancna[m][kondznak+'mnozstvo_skondenzovanej_pary'] = kond[i].mnozstvo_kondenzujucej_pary * pocetnost_vyskytu_teplot;
						kondenzacia_bilancna[m][kondznak+'mnozstvo_odparenej_pary'] = kond[i].mnozstvo_vyparitelnej_pary  * pocetnost_vyskytu_teplot;
					}
					
					b_mnozstvo_skondenzovanej_pary += kondenzacia_bilancna[m].mnozstvo_skondenzovanej_pary;
					b_mnozstvo_odparenej_pary += kondenzacia_bilancna[m].mnozstvo_odparenej_pary;
	console.log(kondenzacia_bilancna[m]);
				}
				m++;
			}
			ok = 1;
		}
	,	timerX = setInterval( tf, 1 )
	;
}

/*# funkcia month_run prebehne vypocty pre mesacne hodnoty priemernych teplot
na zaklade DB tabulky valaly
	Pre urychlenie vypoctov by bolo vhodne zistit, ci vobec dojde ku kondenzacii 
pri mesacnych vypoctoch ... prvy vypocet pre najnizsiu priemernu teplotu
(aj tak bude najskor vyssia, ako normovana hodnota pre zakladny vypocet)
*/
kondenzacia_rocna = [];
mesiace = ['január','febuár','marec','apríl','máj','jún','júl','august','september','október','november','december',]
mesiace_zima_leto = [0,0,0,1,1,1,1,1,1,0,0,0]	// 0...zima, 1...leto 
zima_leto = 0;	// default je zima !
m_mnozstvo_kondenzujucej_pary = 0;
m_max = 0, m_min = 0;
prvy_vysusujuci = 0;
prvy_kondenzujuci = 0;
kond_rocna = [];
kondenzacne_jadra_mesiace = [];
function month_run( callback ) {

	m_mnozstvo_kondenzujucej_pary = 0;
	m_max = 0; m_min = 0;	

	var id_valal = Fproject.fragment_project.vonk_okraj_podmienky[""].valal.value.split('/')[0]
	,	tento_valal = db_isover.valaly.find( function(valal) { return valal.id == id_valal; } )
	;
	
// najprv potrebujem najst kondenzacnu zonu pre najnizsiu teplotu valala
	kalkul.vonkajsia_teplota = 100;
	for (var m=0; m<12; m++) {
		var t = parseFloat(tento_valal["VonkTep_"+(m+1)].replace(/,/g,'.').replace('--','-'));
		kalkul.vonkajsia_teplota = (kalkul.vonkajsia_teplota > t) ? t : kalkul.vonkajsia_teplota;
	}
	prepocet_vypoctovej_vlhkosti(kalkul.vonkajsia_teplota);
	
	Prepocet();	// tym ziskam kondenzacne zony pre najnizsiu priemernu teplotu roka
	
	if (kalkul.kond.length == 0) {	// nekondenyujeme v roku !!!
		if (typeof callback == 'function') {
			callback();
		}
		return;
	}
	
	kond_rocna = [];
	kalkul.kond.forEach( function(v) {
		var obj = {	
			mesiac_maximum_akumulacie : 0
		,	maximum_akumulacie : -1000
		}
		kond_rocna.push( Object.assign(obj,v) );
	});
	kalkul.kond_rocna = kond_rocna;
	
	var	p_rok = (new Date).getFullYear() % 4
	,	dni = [31,p_rok ? 28:29,31,30,31,30,31,31,30,31,30,31]
	,	pocet_dni_roka = p_rok ? 366 : 365
	,	m = 0, ok = 1
	,	kondenzacny_beh = true
	,	tf = function() {
			if (! ok) {
				return;	// cakaj na dokoncenie predch. vypoctu
			}
			ok = 0;
			if (m >= 12) {
				clearInterval(timerX);
				kalkul.kondenzacia_rocna = kondenzacia_rocna;
				kalkul.m_mnozstvo_kondenzujucej_pary = m_mnozstvo_kondenzujucej_pary;
// treba zoradit mesacne hodnoty od prveho kondenzujuceho mesiaca	- lenze treba zistit kondenzaciu kazdej kondenzacnej zony !
				var rgxp = /kond_(\d+)_mnozstvo_skondenzovanej_pary/
				;
				for (prvy_vysusujuci = 0;prvy_vysusujuci < 12;prvy_vysusujuci++) {	
				//	if (kondenzacia_rocna[prvy_vysusujuci]./*prikondenzovanie*/mnozstvo_kondenzujucej_pary <= 0) {
				//		break;
				//	}
					var nekondenzuje = true
					,	props = Object.keys(kondenzacia_rocna[prvy_vysusujuci])
					;
					props.forEach( function(v) {
						if (v.match(rgxp) && (kondenzacia_rocna[prvy_vysusujuci][v] > 0)) {
							nekondenzuje = false;
						}
					})
					if (nekondenzuje) {
						break;
					}
				}
				if (prvy_vysusujuci == 12) {	
konzola(' V konštrukcii KONDENZUJE po celý rok !!!');
					prvy_kondenzujuci = prvy_vysusujuci = 0;
				} else {
					prvy_kondenzujuci = prvy_vysusujuci;
					do {
					//	if (kondenzacia_rocna[prvy_kondenzujuci]./*prikondenzovanie*/mnozstvo_kondenzujucej_pary > 0) {
					//		break;
					//	}
						var nekondenzuje = true
						,	props = Object.keys(kondenzacia_rocna[prvy_kondenzujuci])
						;
						props.forEach( function(v) {
							if (v.match(rgxp) && (kondenzacia_rocna[prvy_kondenzujuci][v] > 0)) {
								nekondenzuje = false;
							}
						})
						if ( ! nekondenzuje) {
							break;
						}
						prvy_kondenzujuci = ( prvy_kondenzujuci + 1 ) % 12;
					} while( prvy_kondenzujuci != prvy_vysusujuci );
				}
		kalkul.prvy_vysusujuci = prvy_vysusujuci;
		kalkul.prvy_kondenzujuci = prvy_kondenzujuci;
				if (prvy_vysusujuci == prvy_kondenzujuci) {
	// bud nekondenzuje vobec, alebo kondenzuje stale ???				
				}
/*
				if ( prvy_kondenzujuci == prvy_vysusujuci ) { // vobec nic nekondenzuje !!!
					// debugger;
					m_mnozstvo_kondenzujucej_pary = 0;
				} else {
					do {
						if (kondenzacia_rocna[prvy_kondenzujuci].prikondenzovanie > 0) {
							break;
						}
						prvy_kondenzujuci = ( prvy_kondenzujuci + 1 ) % 12;
					} while( prvy_kondenzujuci != prvy_vysusujuci );
				}
*/				
//	teraz je potrebne pebehnut vsetky mesiace a :
//	spocitavat mnozstvo pridaneho a vysuseneho kondenzu
//	na zaklade znalosti difuznych tokov
				m_mnozstvo_skondenzovanej_pary = 0;
				m_mnozstvo_odparenej_pary = 0;
				var mes = prvy_kondenzujuci;
				do {
					var	props = Object.keys(kondenzacia_rocna[mes])
					,	matches
					;
					props.forEach( function(v) {
						if (matches = rgxp.exec(v)) {
							var idx = matches[1], ak;
							ak = kondenzacia_rocna[mes]['kond_'+idx+'_akumulovana_vlhkost'] = (mes == prvy_kondenzujuci) 
								? 0 : kondenzacia_rocna[(mes+12-1)%12]['kond_'+idx+'_akumulovana_vlhkost'];
			m_max = (ak > m_max) ? ak : m_max;
			m_min = (ak < m_min) ? ak : m_min;
							kondenzacia_rocna[mes]['kond_'+idx+'_akumulovana_vlhkost'] += kondenzacia_rocna[mes][v];
							m_mnozstvo_skondenzovanej_pary += kondenzacia_rocna[mes][v];
							kondenzacia_rocna[mes]['kond_'+idx+'_akumulovana_vlhkost'] -= kondenzacia_rocna[mes]['kond_'+idx+'_mnozstvo_odparenej_pary'];
							m_mnozstvo_odparenej_pary += kondenzacia_rocna[mes]['kond_'+idx+'_mnozstvo_odparenej_pary'];
			if (kondenzacia_rocna[mes]['kond_'+idx+'_akumulovana_vlhkost'] > kalkul.kond_rocna[idx-1].maximum_akumulacie) {
				kalkul.kond_rocna[idx-1].maximum_akumulacie = kondenzacia_rocna[mes]['kond_'+idx+'_akumulovana_vlhkost'];
				kalkul.kond_rocna[idx-1].mesiac_maximum_akumulacie = mes;
			}
						}
					})
			//		m_mnozstvo_skondenzovanej_pary += kondenzacia_rocna[mes].mnozstvo_skondenzovanej_pary;
			//		m_mnozstvo_odparenej_pary += kondenzacia_rocna[mes].mnozstvo_odparenej_pary;
					mes = ( mes + 1 ) % 12;
				} while( mes != prvy_kondenzujuci );
				
				cleanMesiace(); 
				if (m_mnozstvo_skondenzovanej_pary) {	// zobrazenie len ak rocne kondenzuje
					draw_mesiace(); table_mesiace_zony();	//	table_mesiace();
					document.getElementById('mesacny_blok').style.display='';
				}
				
				if (typeof callback == 'function') {
					callback();
				}
			} else {
				kalkul.kondenzacne_jadra_mesiace = kondenzacne_jadra_mesiace;
				
				kalkul.vonkajsia_teplota = parseFloat(tento_valal["VonkTep_"+(m+1)].replace(/,/g,'.').replace('--','-'));
				kalkul.vonkajsia_vlhkost = prepocet_vypoctovej_vlhkosti(kalkul.vonkajsia_teplota);
				zima_leto = mesiace_zima_leto[ m ];
konzola(' vypocet mesiaca '+mesiace[m]+' '+(zima_leto ? 'leto':'zima'));
				
					if (kondenzacny_beh) {
						Prepocet();
						if (kalkul.kond.length) {
	//	ak nemam este kondenzacne jadra ( m = 0 ), vyrobim ich
							if (! kondenzacne_jadra_mesiace.length) {	
								for (var i=0; i<kalkul.kond.length; i++) {
									kondenzacne_jadra_mesiace.push( Object.assign({}, kalkul.kond[i]) );
								}
	// ale ak ich ma, musim ich spravne priradit (postupujuc od najnizsej teploty nahor sa zony postupne eliminuju)
							} else {
								for (var i=0; i<kalkul.kond.length; i++) {
									var KKsx = kalkul.kond[i].Start, KKex = kalkul.kond[i].End
									,	EKsx = kalkul.kond[i].ekviStart, EKex = kalkul.kond[i].ekviEnd
									, idx = -1
									;
									for (var j = 0; j<kondenzacne_jadra_mesiace.length; j++) {
										var KJsx = kondenzacne_jadra_mesiace[j].Start, KJex = kondenzacne_jadra_mesiace[j].End
										,	EJsx = kondenzacne_jadra_mesiace[j].ekviStart, EJex = kondenzacne_jadra_mesiace[j].ekviEnd
										;
									//	if ( (KKsx >= KJsx) && (KKex <= KJex) ) {	KKex moze byt za KJex
									//	if ( (KKsx >= KJsx) && (KKsx <= KJex) ) {	ale aj KKsx moze byt pred KJsx
					// ako teda spravne identifikovat o pozostatok ktorej predchadzajucej zony sa jedna ???
										if ( (kondenzacne_jadra_bilancia.length == 1) 
											|| (EKsx >= EJsx - 2*MIN_Y_DISTANCE_OF_POINTS) && (EKex <= EJex + 2*MIN_Y_DISTANCE_OF_POINTS) 
										) {	
											idx = j; break;
										}
									}
									if (idx > -1) {
										kondenzacne_jadra_mesiace[idx] = Object.assign({}, kalkul.kond[i]);
									} else {
alert('Nedokazem priradit kondenzacnu zonu v mesiaci '+mesiace[m]+', SORRY !');
									}
								}
							}
						} else {
							kondenzacny_beh = false;
							m-=1;	// zabezpecime prepocet aktualneho nekondenzujuceho 
						}
					} else {
						prepocet_kond_zone_jadro(kondenzacne_jadra_mesiace);
						mnozstva_kondenzacie_jadro(kondenzacne_jadra_mesiace);
					}						
				kalkul.teplota_vnutorneho_povrchu = kalkul.vnutorna_teplota 
					+ ( (kalkul.vonkajsia_teplota - kalkul.vnutorna_teplota) 
						/ (	kalkul.rsi + kalkul.tepelnyOdpor_fragment + kalkul.rse ) 
						* kalkul.rsi
					)
				;

		// vcul treba odlozit pre mesacne spracovanie zaujimave hodnoty		
				kondenzacia_rocna[m] = {
					mesiac : mesiace[m]
				,	dni : dni[m]
				,	vnutorna_teplota : kalkul.vnutorna_teplota
				,	vnutorna_vlhkost : kalkul.vnutorna_vlhkost	// ?? ako sa meni v mesiacoch ? 
				,	pvi	: kalkul.pvi
				,	vonkajsia_teplota : kalkul.vonkajsia_teplota
				,	vonkajsia_vlhkost : kalkul.vonkajsia_vlhkost
				,	pve	: kalkul.pve
				,	teplota_vnutorneho_povrchu : kalkul.teplota_vnutorneho_povrchu
			//	,	teplotny_faktor 		// f,Rsi,m   ??? co to v Teplo2014 je  ???
			//	,	min_pozad_hodn_teplota_vnutorneho_povrchu : ???
			//	,	min_pozad_hodn_teplotny_faktor : ???
			//	,	vlhkost_vnutorneho_povrchu 		// f,RHsi   ??? co to v Teplo2014 je  ???
					// zatial zbytocne, nuluje sa pri nekondenzacii - nepocitane VYSUSOVANIE !
				,	difuzny_tok_i : kalkul.difuzny_tok_i	
				,	difuzny_tok_e : kalkul.difuzny_tok_e
				,	mnozstvo_kondenzujucej_pary : kalkul.mnozstvo_kondenzujucej_pary
				,	mnozstvo_vyparitelnej_pary : kalkul.mnozstvo_vyparitelnej_pary
			,	mnozstvo_kondenzujucej_pary_fragment : kalkul.mnozstvo_kondenzujucej_pary_fragment
			,	mnozstvo_vyparitelnej_pary_fragment : kalkul.mnozstvo_vyparitelnej_pary_fragment
				
				,	mnozstvo_skondenzovanej_pary : kalkul.mnozstvo_kondenzujucej_pary * dni[m] * 46*3600
				,	mnozstvo_odparenej_pary : kalkul.mnozstvo_vyparitelnej_pary * dni[m] * 46*3600
				};
				var kond = kondenzacny_beh ? kalkul.kond : kalkul.kondenzacne_jadra_mesiace;
				for (var i=0; i<kond.length; i++) {
					var kondznak = 'kond_'+(i+1)+'_';
					kondenzacia_rocna[m][kondznak+'kondenzacny_beh'] = kondenzacny_beh;
					kondenzacia_rocna[m][kondznak+'Start_psat'] = kond[i].Start_psat;
					kondenzacia_rocna[m][kondznak+'Start_rd'] = kond[i].Start_rd;
					kondenzacia_rocna[m][kondznak+'End_psat'] = kond[i].End_psat;
					kondenzacia_rocna[m][kondznak+'End_rd'] = kond[i].End_rd;
					kondenzacia_rocna[m][kondznak+'difuzny_tok_e'] = kond[i].difuzny_tok_e;
					kondenzacia_rocna[m][kondznak+'difuzny_tok_i'] = kond[i].difuzny_tok_i;
					kondenzacia_rocna[m][kondznak+'mnozstvo_kondenzujucej_pary'] = kond[i].mnozstvo_kondenzujucej_pary;
					kondenzacia_rocna[m][kondznak+'mnozstvo_vyparitelnej_pary'] = kond[i].mnozstvo_vyparitelnej_pary;
					kondenzacia_rocna[m][kondznak+'mnozstvo_skondenzovanej_pary'] = kond[i].mnozstvo_kondenzujucej_pary * dni[m] * 46*3600;
					kondenzacia_rocna[m][kondznak+'mnozstvo_odparenej_pary'] = kond[i].mnozstvo_vyparitelnej_pary * dni[m] * 46*3600;
				}
					
				m_mnozstvo_skondenzovanej_pary += kondenzacia_rocna[m].mnozstvo_skondenzovanej_pary;
				m_mnozstvo_odparenej_pary += kondenzacia_rocna[m].mnozstvo_odparenej_pary;
console.log(kondenzacia_rocna[m]);
				m++;
			}
			ok = 1;
		}
	,	timerX = setInterval( tf, 1 )
	;
}

function cleanMesiace() {
	var div_mesiace = document.querySelector('div#mesacny_blok')
//	,	inp_monther = document.querySelector('input#monther')
	;
//	inp_monther && (inp_monther.style.backgroundColor = '');
	div_mesiace.querySelector('table#tblbox_mesiace').innerHTML = '';
//	div_mesiace.querySelector('div#jxgbox_mesiace').innerHTML = '';
	JXG.JSXGraph.freeBoard(board_ME);
	board_ME = JXG.JSXGraph.initBoard('jxgbox_mesiace',{boundingbox:[-10,100,100,-10], axis:true });
	div_mesiace && (div_mesiace.style.display = 'none');	
}

/* funkcia draw_mesiace vykresluje mesacny priebeh kondenzacie
vo forme 12 sektorov s hodnotami 
	stlpce mnozstvo_kondenzujucej_pary
	ciara vonkajsia_teplota
Object
	dni:31
	mnozstvo_kondenzujucej_pary:1.9076784531528147e-9
	pve:390.74982449068636
	pvi:1168.4755719011712
	teplota_vnutorneho_povrchu:19.41695006357049
	vnutorna_teplota:20
	vnutorna_vlhkost:50
	vonkajsia_teplota:-2.1
	vonkajsia_vlhkost:76.2
*/
function draw_mesiace() {
	JXG.JSXGraph.freeBoard(board_ME);
	board_ME = JXG.JSXGraph.initBoard('jxgbox_mesiace',{
		//	boundingbox:[0, m_max*1e9*1.1, 120, 0 ]
			boundingbox:[0, m_max*1.1, 120, m_min*1.1 ]
		,	showCopyright:false
		,	axis:true
		,	zoom: {
				factorX: grafy.zoom_faktorX, //1.25,
				factorY: grafy.zoom_faktorY,  //1.25,
				wheel: true,
				needshift: true,
				eps: 0.1
			}
		}); 
//	kalkul.kondenzacia_rocna.forEach( 
//		function(v,i,a) {
		m = kalkul.prvy_kondenzujuci, i=0;
		do {
			var v = kalkul.kondenzacia_rocna[m]
			,	posun = (10-2) / kalkul.kond_rocna.length
			,	colors = ['darkgray','darkblue','darkgreen','darkred']
			;
			for(var z = 0; z < kalkul.kond_rocna.length; z++) {
				var p1 = board_ME.create('point',[10*i+2+z*posun, 0  ],{fixed:true, size:0.2, name:''})
				,	p2 = board_ME.create('point',[10*i+2+z*posun, v['kond_'+(z+1)+'_akumulovana_vlhkost'] ],{fixed:true, size:0.2, name:''})
				,	p3 = board_ME.create('point',[10*i+2+(z+1)*posun, v['kond_'+(z+1)+'_akumulovana_vlhkost'] ],{fixed:true, size:0.2, name:''})
				,	p4 = board_ME.create('point',[10*i+2+(z+1)*posun, 0 ],{fixed:true, size:0.2, name:''})
				;
				board_ME.create('polygon',[p1,p2,p3,p4],{withLines:false,fillColor:colors[z%4] });
				board_ME.create('text',[10*i+2+z*posun, v['kond_'+(z+1)+'_akumulovana_vlhkost']
					, ((z == 0) ? (mesiace[m]+'<br/>'+ " t:"+v.vonkajsia_teplota+'<br/>') : '')
						+ v['kond_'+(z+1)+'_akumulovana_vlhkost'].toFixed(6) 
	//					+Math.ceil( v.mnozstvo_kondenzujucej_pary*1000000 ) / 1000000
					],{anchorY:'bottom'});
			}
			m = ( m + 1 ) % 12; i++;
		} while(m != kalkul.prvy_kondenzujuci);
//	});
		
//	board_SP.create('functiongraph',[TlakNasPar, 0, kalkul.hrubka_fragment] );
//	board_SP.create('functiongraph',[SkutTlakPar, 0, kalkul.hrubka_fragment], { strokeColor: 'green', name: 'pD'} );
}

function table_mesiace_zony() {
	var tbl = document.getElementById('tblbox_mesiace')
	,	z, ih = '', la,  m
	;
	for (z = 0;z < kalkul.kond_rocna.length; z++) {
		ih+= '<thead><tr><th colspan="5">Kondenzačná zóna č.'+(z+1)+'</th><th>x 10^9</th></tr>'
			+'<tr><th>mesiac</th><th>zač[mm]</th><th>kon[mm]</th><th>teplota</th><th>vlhkosť</th><th>kond./vypar.</th><th>Akum.vlhkosť</th></tr></thead><tbody>'
		;
		m = kalkul.prvy_kondenzujuci;
		do {
			var v = kalkul.kondenzacia_rocna[m];
			ih+='<tr><td>'+mesiace[m]+'</td><td>'+kalkul.kond_rocna[z].Start.toFixed(3)+'</td><td>'+kalkul.kond_rocna[z].End.toFixed(3)+'</td>'
				+'<td>'+v.vonkajsia_teplota+'</td><td>'+(Math.ceil(v.vonkajsia_vlhkost*100)/100)+'</td>'
//			+	'<td>'+(Math.ceil(v.pve*100)/100)+'</td><td>'+(Math.ceil(v.teplota_vnutorneho_povrchu*100)/100)+'</td><td>'+v.mnozstvo_kondenzujucej_pary+'</td></tr>'
				+'<td>'+((v['kond_'+(z+1)+'_mnozstvo_kondenzujucej_pary'] - v['kond_'+(z+1)+'_mnozstvo_vyparitelnej_pary'])*1e9).toFixed(3)+'</td>'
				+'<td>'+v['kond_'+(z+1)+'_akumulovana_vlhkost'].toFixed(6)+'</td>'
				+'</tr>'
			;
			la = v['kond_'+(z+1)+'_akumulovana_vlhkost'];
			m = ( m + 1 ) % 12;
		} while(m != kalkul.prvy_kondenzujuci);
		
		ih+='</tbody><tfoot><tr><th colspan="7">'
			+'maximum akumulácie vlhkosti: <b>'+kalkul.kond_rocna[z].maximum_akumulacie.toFixed(6)
			+'</b> v mesiaci: <b>'+mesiace[kalkul.kond_rocna[z].mesiac_maximum_akumulacie]+'</b>'
			+'</th></tr><tr><th  colspan="7">v letných mesiacoch sa '+(la > 0 ? '<b>NE</b>':'')+'stihne odpariť</th></tr></tfoot>';
	}
	tbl.innerHTML = ih;
}


function table_mesiace() {
	var tbl = document.getElementById('tblbox_mesiace')
	,	ih ='<thead><tr><th>mesiac</th><th>vonkT</th><th>vonkH</th><th>pve</th><th>Tpovrch</th><th>kondenz</th></tr></thead><tbody>'
	;
	kalkul.kondenzacia_rocna.forEach( function(v,i,a) {
		ih+='<tr><td>'+mesiace[i]+'</td><td>'+v.vonkajsia_teplota+'</td><td>'+(Math.ceil(v.vonkajsia_vlhkost*100)/100)+'</td>'
		+	'<td>'+(Math.ceil(v.pve*100)/100)+'</td><td>'+(Math.ceil(v.teplota_vnutorneho_povrchu*100)/100)+'</td><td>'+v.mnozstvo_kondenzujucej_pary+'</td></tr>'
	});
	ih+='</tbody>';
	tbl.innerHTML = ih;
}

/*# funkcia Vysledok osadzuje zadane, spracovane a vypocitane hodnoty, grafy a tabulky
do vysledkovej zostavy
*/
function Vysledok() {	// plnenie vysledku
	var fields = document.querySelectorAll('#vysledok *[data-hide]');
	for (var i=0; i < fields.length; i++) {
		var nod = fields[i] 
		,	ar = nod.dataset.hide
		,	condit
		;
		try{
			condit = eval(ar);
			nod.style.display = condit ? ''/*'initial'*/ : 'none'
		} catch(e) {}
	}
	var fields = document.querySelectorAll('#vysledok *[data-form]');
	for (var i=0; i < fields.length; i++) {
		var nod = fields[i] 
		,	ar = nod.dataset.form.split('.')
		;
		if (ar.length > 1) {
			var v = document.forms[ar[0]].elements[ar[1]]
			,	nv = v.nodeName.toLowerCase()
			;
			switch (nv) {
				case 'select' : {
					nod.textContent = v.options[v.selectedIndex].textContent;
					break;
				}
				default: {
					nod.textContent = v.value;
					break;
				}
			}
		}
	}
	var fields = document.querySelectorAll('#vysledok *[data-math]');
	for (var i=0; i < fields.length; i++) {
		var nod = fields[i] 
		,	ar = nod.dataset.math
		,	val
		;
		try{
			val = eval(ar);
			if (_isNaN(val) || (typeof val == 'undefined')) {
				nod.textContent = '--';
			} else {
				nod.textContent = val;
			}
		} catch(e) {}
	}
	var fields = document.querySelectorAll('#vysledok *[data-kalkul]');
	for (var i=0; i < fields.length; i++) {
		var nod = fields[i] 
		,	ar = nod.dataset.kalkul
		,	val
		;
		try{
			val = eval("kalkul."+ar);
			if (_isNaN(val) || (typeof val == 'undefined')) {
				nod.textContent = '--';
			} else {
				nod.textContent = isNaN(parseFloat(val)) ? val : val.toFixed(3);	//Math.ceil( val*100 ) / 100;
			}
		} catch(e) {}
	}
	var fields = document.querySelectorAll('#vysledok *[data-sel]');
	for (var i=0; i < fields.length; i++) {
		var nod = fields[i] 
		,	ar = nod.dataset.sel
		;
		var v = document.querySelector(ar);
		nod.textContent = v.textContent;
	}
	var fields = document.querySelectorAll('#vysledok *[data-copy]');
	for (var i=0; i < fields.length; i++) {
		var nod = fields[i] 
		,	ar = nod.dataset.copy.split(';')
		;
		if (ar.length > 1) {
			var v = document.querySelector(ar[0]);
			nod[ar[1]] = v[ar[1]];
		}
	}
	var fields = document.querySelectorAll('#vysledok *[data-replace]');
	for (var i=0; i < fields.length; i++) {
		var nod = fields[i] 
		,	ar = nod.dataset.replace
		;
		var v = document.querySelector(ar)
		,	rNod = v.cloneNode(true)
		;
//		rNod.id = '';
		rNod.dataset.replace = ar;
		nod.parentNode.replaceChild(rNod,nod);
	}

// zaverecne vycistenie:
	var tblv = document.querySelectorAll('#vysledok table.vrstvy_table tbody tr');
	for (var i=0; i < tblv.length; i++) {
		tblv[i].removeAttribute('onclick');
		tblv[i].classList.remove('selected');
	// odstranenie tlacitok manipulatorov - surovo
		tblv[i].firstElementChild.innerHTML = i;
	// prevod zadavacich tlacitok na texty:
		var inps = tblv[i].querySelectorAll('input');
		for (var j=0; j<inps.length; j++) {
			var val = inps[j].value
			,	nt = document.createTextNode(val)
			;
			inps[j].parentNode.replaceChild(nt,inps[j]);
		}
	}
	var tdbw = document.querySelectorAll('#vysledok td.bwhite')
	,	oram = kalkul.je_ramova_konstrukcia
	;
	for (var i=0; i < tdbw.length; i++) {
		tdbw[i].style.borderColor = oram ? 'grey' : '';
	}
}

function ukazDetailyVypoctov() {
	var dvv = document.getElementById('detailyVypoctov');
	if (dvv && (typeof kalkul !=  'undefined') 
		&& (typeof vrstvy !=  'undefined') && (vrstvy.length)
	) {
//		alert('TODO');
		dvv.innerHTML = 
	'<h2 style="background-color:lightgray;">'
+	'Detailné výsledky výpočtov'
//+	'<input type="button" value="X" onclick="this.parentNode.parentNode.style.display=\'none\'" title="klik sem zavrie detaily" style="background-color:lightgray;float:right;"/>'
+	'</h2>'
+	'<h3>Vrstvy</h3><div id="detaily_vrstvy"><table border="1" style="white-space:nowrap;"><tbody></tbody></table></div>'
+	'<h3>Fragment (pri výpočtovej teplote)</h3><div id="detaily_kalkul"><table border="1" style="white-space:nowrap;"><tbody></tbody></table></div>'
+	'<h3>Kondenzácia (pri výpočtovej teplote)</h3><div id="detaily_kondenzacia"><table border="1" style="white-space:nowrap;"><tbody></tbody></table></div>'
+	'<h3>Kondenzacne jadrá pre bilanciu</h3><div id="detaily_kondenzacne_jadra_bilancia"><table border="1" style="white-space:nowrap;"><tbody></tbody></table></div>'
+	'<h3>Bilancia (STN 730540-2)</h3><div id="detaily_bilancia"><table border="1" style="white-space:nowrap;"><tbody></tbody></table></div>'
+	'<h3>Kondenzacne jadrá pre mesiace</h3><div id="detaily_kondenzacne_jadra_mesiace"><table border="1" style="white-space:nowrap;"><tbody></tbody></table></div>'
+	'<h3>Mesiace (STN EN ISO 13788)</h3><div id="detaily_mesiace"><table border="1" style="white-space:nowrap;"><tbody></tbody></table></div>'
+	'<h3>Akumulácia kondenzácie </h3><div id="detaily_kondenzacia_mesacna"><table border="1" style="white-space:nowrap;"><tbody></tbody></table></div>'
		;
		var detaily_vrstvy = dvv.querySelector('div#detaily_vrstvy table tbody')
		,	detaily_kalkul = dvv.querySelector('div#detaily_kalkul table tbody')
		,	detaily_kondenzacia = dvv.querySelector('div#detaily_kondenzacia table tbody')
		,	detaily_kondenzacne_jadra_bilancia = dvv.querySelector('div#detaily_kondenzacne_jadra_bilancia table tbody')
		,	detaily_bilancia = dvv.querySelector('div#detaily_bilancia table tbody')
		,	detaily_kondenzacia_mesacna = dvv.querySelector('div#detaily_kondenzacia_mesacna table tbody')
		,	detaily_kondenzacne_jadra_mesiace = dvv.querySelector('div#detaily_kondenzacne_jadra_mesiace table tbody')
		,	detaily_mesiace = dvv.querySelector('div#detaily_mesiace table tbody')
		,	ih
		;
		ih = '';
		Object.keys(vrstvy[0]).forEach( function(v) {
			ih+= '<tr><td>'+v+'</td>';
			vrstvy.forEach( function(vv) {
				ih+='<td>'+vv[v]+'</td>';
			});
			ih+= '</tr>';
		});
		detaily_vrstvy.innerHTML = ih;

		ih = '';
		Object.keys(kalkul).forEach( function(v) {
			if (typeof kalkul[v] != 'object') {
				ih+= '<tr><td>'+v+'</td><td>'+kalkul[v]+'</td></tr>';
			}
		});
		detaily_kalkul.innerHTML = ih;
		
	if (kalkul.kond && kalkul.kond.length) {
		ih = '';
		Object.keys(kalkul.kond[0]).forEach( function(v) {
			ih+= '<tr><td>'+v+'</td>';
			kalkul.kond.forEach( function(vv) {
				ih+='<td>'+vv[v]+'</td>';
			});
			ih+= '</tr>';
		});
		detaily_kondenzacia.innerHTML = ih;
	}		
	if (kalkul.kondenzacne_jadra_bilancia && kalkul.kondenzacne_jadra_bilancia.length) {
		ih = '';
		Object.keys(kalkul.kondenzacne_jadra_bilancia[0]).forEach( function(v) {
			ih+= '<tr><td>'+v+'</td>';
			kalkul.kondenzacne_jadra_bilancia.forEach( function(vv) {
				ih+='<td>'+vv[v]+'</td>';
			});
			ih+= '</tr>';
		});
		detaily_kondenzacne_jadra_bilancia.innerHTML = ih;
	}
	
	if (kalkul.kondenzacia_bilancna && kalkul.kondenzacia_bilancna.length) {
		ih = '';
			// 0-ta polozka neexistuje, predpoklad existencie januar-a VZDY
		Object.keys(kalkul.kondenzacia_bilancna[1]).forEach( function(v) {
// ??? chyba ???			if (typeof kalkul.kondenzacia_rocna[0][v] != 'object') {
			if (typeof kalkul.kondenzacia_bilancna[1][v] != 'object') {
				ih+= '<tr><td>'+v+'</td>';
				kalkul.kondenzacia_bilancna.forEach( function(vv) {
					ih+='<td>'+vv[v]+'</td>';
				});
				ih+= '</tr>';
			}
		});
		detaily_bilancia.innerHTML = ih;
	}

	if (kalkul.kondenzacne_jadra_mesiace && kalkul.kondenzacne_jadra_mesiace.length) {
		ih = '';
		Object.keys(kalkul.kondenzacne_jadra_mesiace[0]).forEach( function(v) {
			ih+= '<tr><td>'+v+'</td>';
			kalkul.kondenzacne_jadra_mesiace.forEach( function(vv) {
				ih+='<td>'+vv[v]+'</td>';
			});
			ih+= '</tr>';
		});
		detaily_kondenzacne_jadra_mesiace.innerHTML = ih;
	}
	if (kalkul.kondenzacia_rocna && kalkul.kondenzacia_rocna.length) {
		ih = '';
		Object.keys(kalkul.kondenzacia_rocna[0]).forEach( function(v) {
			if (typeof kalkul.kondenzacia_rocna[0][v] != 'object') {
				ih+= '<tr><td>'+v+'</td>';
				kalkul.kondenzacia_rocna.forEach( function(vv) {
					ih+='<td>'+vv[v]+'</td>';
				});
				ih+= '</tr>';
			}
		});
		detaily_mesiace.innerHTML = ih;
	}
	if (kalkul.kond_rocna && kalkul.kond_rocna.length) {
		ih = '';
		Object.keys(kalkul.kond_rocna[0]).forEach( function(v) {
			ih+= '<tr><td>'+v+'</td>';
			kalkul.kond_rocna.forEach( function(vv) {
				ih+='<td>'+vv[v]+'</td>';
			});
			ih+= '</tr>';
		});
		detaily_kondenzacia_mesacna.innerHTML = ih;
	}		
		
		dvv.style.display = 'block';
	//	dvv.scrollIntoView();
	
	
	var wnd = window.open("ISOVER Fragment Detaily", "ISOVER Fragment Detaily");	//, "scrollbars=1,resizable=1,width=1000,height=580,left=0, top=0");
	wnd.document.title="ISOVER Fragment Detaily"
	var html = ''
+	'<!DOCTYPE html>'
+	'<html xmlns="http://www.w3.org/1999/xhtml" xmlns:svg="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:kres="http://www.sbmintegral.sk/docdefs/kres" xml:lang="sk">'
+	'<head>'
+	'    <meta http-equiv="Pragma" content="no-cache" />'
+	'    <meta http-equiv="Expires" content="-1" />'
+	'    <meta http-equiv="Content-type" content="text/html; charset=utf-8"/>'
+	'    <title>ISOVER fragment Detaily</title>'
+	'<style type="text/css">'
+	'body {'
+	'	max-width: 595px;'
+	'}'
+	'	</style>'
+	'</head>'
+	'<body>'
+	dvv.outerHTML
+	'</body>'
+	'</html>'
;
	wnd.document.write(html);
	wnd.document.close(); //missing code

    wnd.focus();
	
		dvv.style.display = 'none';
	}
}
