/*
Komukoľvek, kto získa kópiu tohto softvéru a súvisiacich súborov dokumentácie („Softvér“), 
sa týmto udeľuje bezplatné povolenie obchodovať so Softvérom bez obmedzení, 
ako aj neobmedzené právo na použitie, kopírovanie, úpravu, spojenie, zverejnenie, 
distribuovanie, ďalšie udelenie licencie a/alebo predaj kópií Softvéru a umožnenie osobám, 
ktorým sa Softvér poskytuje, aby tak učinili, a to za nasledovných podmienok:
Hore uvedené oznámenie o autorských právach a toto oznámenie o povolení budú súčasťou 
všetkých kópií alebo zásadných častí Softvéru. 
 
TENTO SOFTVÉR SA POSKYTUJE „TAK, AKO JE“, BEZ AKÝCHKOĽVEK ZÁRUK, VYJADRENÝCH PRIAMO ČI NEPRIAMO, 
VRÁTANE (NIE VŠAK VÝLUČNE) ZÁRUKY PREDAJNOSTI, VHODNOSTI NA KONKRÉTNY ÚČEL A NEPORUŠENIA PRAVIDIEL. 
AUTORI ALEBO DRŽITELIA AUTORSKÝCH PRÁV V NIJAKOM PRÍPADE NEMÔŽU BRAŤ ZODPOVEDNOSŤ 
ZA AKÉKOĽVEK REKLAMÁCIE, ŠKODY ALEBO BYŤ INAK ZODPOVEDNÍ, ČI UŽ PRI UPLATŇOVANÍ ZMLÚV, 
PRI PREČINOCH ALEBO INÝCH ČINOCH VYPLÝVAJÚCICH, SÚVISIACICH I NESÚVISIACICH SO SOFTVÉROM 
ALEBO POUŽITÍM SOFTVÉRU ALEBO OBCHODOVANÍM SO SOFTVÉROM.
*/

//	calcul_forms


///<section name="commons_calculs">
function e(form_name, fieldset_name) {
	return document.forms[form_name].elements[fieldset_name].elements;
}

var now_calculated_CalculForms = null;
// core function to solve values of inputs
// with checking calculs priorities
function V(inp, forceType) {
	// if needed value is calcul-ated, check if already computed
	if (inp.dataset.calcul) {	
		var form = inp.form
		,	fieldset = inp.queryXpath('./ancestor::a:fieldset',__,1)
		,	computed =  now_calculated_CalculForms.funcs[form.name][fieldset.name][inp.name].ac
		;
		if (! computed) {
now_calculated_CalculForms.need_recompute = true;
			return;
		}
	}
	var inps = ['input','select','button']
	,	nn = inp.nodeName.toLowerCase()
	,	val = (inps.indexOf(nn) > -1) ? inp.value : inp.textContent
	;
	switch (forceType || inp.type) {
		case 'checkbox':
			return inp.checked;
			break;
		case 'radio':
			return inp.form.elements[inp.name].value;
			break;
		case 'tel':
			val = (val == '') ? 0 : val; 
		case 'number':
			return parseFloat(val);
			break;
		case 'text':
			return (nn == 'select') ? inp.options[inp.selectedIndex].text : textContent
			break;
		default: 
			return val;
			break;
	}
}
function SUM(fe, rgxp) {
	var sum = 0;
	Object.keys(fe).forEach( function(v,i) {
		if (v.match(rgxp)) {
			sum+= V(fe[v],'tel');	//'number');
		}
	});
	return sum;
}
function compBy( val, compArr) {
	var rgxp = /^(([<>=≥≤]*)\s*(\d[\d\.]*))*\s*(-)*\s*(\d[\d\.]*)*$/gm	//; rgxp.exec('-2223'.trim())
	,	matches, res
	;
	for(var i=0; i < compArr.length; i++) {
		res = null;
		rgxp.lastIndex = -1;
		matches = rgxp.exec(compArr[i]);
		if (matches) {
			if (matches[2]) {	//	< X, <= X, > X, >= X
				switch(matches[2]) {
					case '<':	res = (val < matches[3]); break;
					case '≤':
					case '=<':
					case '<=':	res = (val <= matches[3]); break;
					case '>':	res = (val > matches[3]); break;
					case '≥':
					case '>=':
					case '=>':	res = (val >= matches[3]); break;
				}
				if (res == true) {	break;	}
			}
			if (matches[4]=='-') {	//	X - Y
				if ( (matches[3] <= val) && (val <= matches[5]) ) {
					break;
				}
			}
		}
	}
	return i;
}
function markInTable( tableId, val, rowVal/*, markStyle*/ ) {
	//	markStyle = markStyle || 'outline: 2px solid red;' 	CLASS IT

	val = Math.round(parseFloat(val));	// WARNING ... special TODO universal
//	 Zistené hodnoty sa na účel zatriedenia budovy do
//	energetickej triedy podľa § 3 ods. 7 zákona zaokrúhľujú
//	na najbližšie celé číslo podľa pravidiel matematického
//	zaokrúhľovania.	

	var tbl = document.getElementById(tableId)
	,	ms = tbl && tbl.querySelectorAll('.tblMarked') || []
	,	tdsR = tbl && tbl.querySelectorAll('tbody>tr>td:first-child') || []
	,	i, idx = -1
	;
	for(i=0; i<ms.length; i++) {
		ms[i].classList.remove('tblMarked')
	}
	for(i=0; i<tdsR.length; i++) {
		tdsR[i].parentNode.style.display = ''; 
	}
	if (rowVal && isNbr(val)) {
		for(i=0; i<tdsR.length; i++) {
			if (tdsR[i].textContent.trim().toLowerCase() == rowVal.trim().toLowerCase()) {
				idx = i;
			} else {
				tdsR[i].parentNode.style.display = 'none';
			}
		}
		if (idx > -1) {
			var rgxp = /^(([<>=≥≤]*)\s*(\d[\d\.]*))*\s*(-)*\s*(\d[\d\.]*)*$/gm	//; rgxp.exec('-2223'.trim())
			,	matches, res
			,	datas = tdsR[idx].parentNode.querySelectorAll('td')
			;
			for(i=1/*skip first*/; i< datas.length; i++) {
				res = null;
				rgxp.lastIndex = -1;
				matches = rgxp.exec( datas[i].textContent );
				if (matches) {
					if (matches[2]) {	//	< X, <= X, > X, >= X
						switch(matches[2]) {
							case '<':	res = (val < matches[3]); break;
							case '≤':
							case '=<':
							case '<=':	res = (val <= matches[3]); break;
							case '>':	res = (val > matches[3]); break;
							case '≥':
							case '>=':
							case '=>':	res = (val >= matches[3]); break;
						}
						if (res == true) {	break;	}
					}
					if (matches[4]=='-') {	//	X - Y
						if ( (matches[3] <= val) && (val <= matches[5]) ) {
							break;
						}
					}
				}
			}
			if (i < datas.length) {	// if finded relevant value or range, mark it
				datas[i].classList.add('tblMarked');
				tbl.querySelector('thead tr:last-child th:nth-child('+i+')').classList.add('tblMarked');
			}
		}
	}
}

DECS_M = 1000;
function rounder( num, decs_m ) {
	decs_m = isDef(decs_m) ? decs_m : DECS_M; 
	var val = parseFloat(num);
	return isNbr(val) ? Math.round( val * decs_m ) / decs_m : val; 
}
function SV(inp, val, decs_m, fncobj) {
	var inps = ['input','select','button']
	,	nn = inp.nodeName.toLowerCase()
	;
	if (inps.indexOf(nn) > -1) {
		switch(inp.type) {
			case 'checkbox':
				inp.checked = !!val;
				break;
			case 'number':
			case 'tel':
				var num = rounder(val, decs_m);
				inp.value = isNaN(num) ? '' : num;
				break;
			default : 
				inp.value = val;
				break;
		}
	} else {
		inp.textContent = val;
	}
	if (inp.onchange) {
		aFireEvent(inp,'change');	// WARNING change event must be CANCELED
			// otherwise infinity loop throug central calcul - ONCHANGE
	}
	fncobj.ac = true;
}

///</section>

///<object name="CalculForms">
CalculForms = function( ls_forms ) {
	if (!(this instanceof CalculForms)) {
		return new CalculForms( ls_forms );
	}
	this.init(ls_forms);
	return this;
}
///<instance>
//	funcs : {}
//	goFuncs : []
///</instance>

CalculForms.prototype = {
		project : null
	,	ls_forms : [/*'fragment','vonk_okraj_podmienky','vnut_okraj_podmienky','popis_zakazky'*/]
	,	init( ls_forms ) {
			if (getType(ls_forms) == '[object Array]' ) {
				this.ls_forms = ls_forms;
			} else if ( this.ls_forms.length ) {	
				// already assigned, do noting ?!
			} else {	// simple get al forms with fieldsets	//if (ls_forms) {
				var fss = document.querySelectorAll('fieldset')
				,	forms = {}
				;
				for (var i=0; i< fss.length; i++) {
					var fs = fss[i]
					,	fn = fs.form.name
					;
					forms[fn] = forms[fn] || [];
					forms[fn].push(fs.name);
				}
				this.ls_forms = Object.keys(forms);
			}
			this.readFuncs();
		}

	,	load : function ( txt ) {
			konzola('Project Loaded: '+ (txt ? 'OK' : 'error !') );
			document.getElementById('project_content').value = txt;
			try {
				this.project = JSON.parse( txt );
				konzola('Project Decode: OK !');
				this.fillForms();
			} catch(e) {
				konzola('Project Decode: error ! ' + e.toString() );
			}
		}
	,	cleanForms : function () {
			var me = this;
			this.ls_forms.forEach( function(f,i,a) {
				var frm = document.forms[f]
				,	i, fs = frm.getElementsByTagName('fieldset')
				;
				for ( i = 0; i < fs.length; i++ ) {
					var j, els = fs[i].elements || fs[i].querySelectorAll('*[name]')	// for IE
					;
					for (j = 0; j < els.length; j++ ) {
						var el = els[j];
						switch(el.type) {
							case 'select-one': 
								el.selectedIndex = 0;
								break;
							case 'checkbox':
								el.checked = false;
								break;
							case 'radio':
		setCheckedValue( fs[i].querySelectorAll('input[name="'+el.name+'"]')  ); // withou value ... defaults
								break;
							case 'text':
							case 'number':
							case 'tel':
							case 'textarea':
								el.value = '';
								break;
							case 'button':
							case 'progress':
							case 'select-multiple':
							default : 
								break;
						}
					}
				}
			});
		}
	,	fillForms : function ( callback ) {
			var me = this;
			this.cleanForms();
			this.ls_forms.forEach( function(f,i,a) {
				var frm = document.forms[f]
				,	fp_f = me.project[f]
				,	i, fs = frm.getElementsByTagName('fieldset')
				;
				for ( i = 0; i < fs.length; i++ ) {
					if (typeof fp_f[ fs[i].name ] != 'undefined') {
						var fp_fs = fp_f[ fs[i].name ]
						,	j, els = fs[i].elements || fs[i].querySelectorAll('*[name]')	// for IE
						;
						for (j = 0; j < els.length; j++ ) {
							var el = els[j];
	// vsetko, co obsahuje data-proforma-name NEuvazujeme !!!
							if (el.dataset.proformaName) {
								continue;
							}
							if ( typeof fp_fs[ el.name ] != 'undefined') {
								switch(el.type) {
									case 'select-one': 
										el.selectedIndex = fp_fs[ el.name ].index;
										if (el.onchange) {
											el.onchange();
										}
										break;
									case 'checkbox':
										el.checked = fp_fs[ el.name ].checked
										break;
									case 'radio':
/* skurvili radio : fieldset.elements nereaguje na radio tak, ako form.elements
//	document.forms.resultForm.elements.Zadanie.elements.TepelneMosty_ExaktPausal
//		<input type=​"radio" name=​"TepelneMosty_ExaktPausal" value=​"exaktne" checked=​"checked">​</input>​
//	document.forms.resultForm.elements.TepelneMosty_ExaktPausal
//		RadioNodeList(2) [input, input, value: "exaktne"]
//	document.forms.resultForm.elements.Zadanie.querySelectorAll('input[name=TepelneMosty_ExaktPausal]')
//		NodeList(2) [input, input]
// Ak teda chcem mat moznost pod roznymi fieldset-mi v ramci jedneho velkeho formularu
// rovnako nazvane radio grupy, musim hladat hlboko
*/								
		setCheckedValue( fs[i].querySelectorAll('input[name="'+el.name+'"]'), fp_fs[ el.name ].value ); 
										break;
									case 'text':
									case 'number':
									case 'tel':
									case 'textarea':
										el.value = fp_fs[ el.name ].value
										break;
									case 'button':
									case 'progress':
									case 'select-multiple':
									default : 
										break;
								}
							}
						}
					}
				}
			});
			
			if (typeof callback == 'function') {
				callback();
			}
		}
	,	getForms : function () {
			var me = this;
			this.project = {};
			this.ls_forms.forEach( function(f,i,a) {
				var frm = document.forms[f]
				,	fp_f = (me.project[f] = {})
				,	i, fs = frm.getElementsByTagName('fieldset')
				;
				for ( i = 0; i < fs.length; i++ ) {
					var fp_fs = fp_f[ fs[i].name ] = {}
					,	j, els = fs[i].elements || fs[i].querySelectorAll('*[name]')	// for IE
					;
// POZOR, cita vsetky *[name] elementy, ale zapisuje LEN input/select ...
// nie napr. span[name] ... = calcul konstanty  					
					for (j = 0; j < els.length; j++ ) {
						var el = els[j];
	// vsetko, co obsahuje data-proforma-name NEuvazujeme !!!
						if (el.dataset.proformaName) {
							continue;
						}
						switch(el.type) {
							case 'select-one': 
								fp_fs[ el.name ] = {
									type :  el.type
								,	text : el.options[el.selectedIndex]	//selectedOptions[0].text
								,	index : el.selectedIndex
								,	value : el.value
								}								
								break;
							case 'checkbox':
								fp_fs[ el.name ] = {
									type :  el.type
								,	checked : el.checked
								,	value : el.value
								}								
								break;
							case 'radio':
/* skurvili radio : fieldset.elements nereaguje na radio tak, ako form.elements
//	document.forms.resultForm.elements.Zadanie.elements.TepelneMosty_ExaktPausal
//		<input type=​"radio" name=​"TepelneMosty_ExaktPausal" value=​"exaktne" checked=​"checked">​</input>​
//	document.forms.resultForm.elements.TepelneMosty_ExaktPausal
//		RadioNodeList(2) [input, input, value: "exaktne"]
//	document.forms.resultForm.elements.Zadanie.querySelectorAll('input[name=TepelneMosty_ExaktPausal]')
//		NodeList(2) [input, input]
// Ak teda chcem mat moznost pod roznymi fieldset-mi v ramci jedneho velkeho formularu
// rovnako nazvane radio grupy, musim hladat hlboko
*/								
								if (! fp_fs[ el.name ]) {	// one item for radio group
									fp_fs[ el.name ] = {
										type :  el.type
									,	value : getCheckedValue( fs[i].querySelectorAll('input[name="'+el.name+'"]') )
									}								
								}
								break;
							case 'text':
							case 'number':
							case 'tel':
							case 'textarea':
								fp_fs[ el.name ] = {
									type :  el.type
								,	value : el.value
								}								
								break;
							case 'button':
							case 'progress':
							case 'select-multiple':
							default : 
								break;
						}
					}
				}
			});
		}
	,	save : function ( callback ) {
			this.getForms();
			if (typeof callback == 'function' ) {
				callback();	
			}
			return JSON.stringify(this.project);
		}

/* Teoria formularoveho kalkulatora:
	Dokument rozdeleny na POMENOVANE formulare, nutne obsahujuce 
	POMENOVANE fieldsety, obsahujuce elementy (najlepsie pomenovane)
	s atributom data-calcul a pripadne data-calc-idx 
Lepsie by bolo zadanie vo forme JSONfn objektu napr.:
	data-calcul="{idx:15,fnc=function(fe) { return
		  v(fe.VonkajsiaStena_A)
		+ v(fe.VonkajsieDvere_A)
		+ v(fe.Okna_A)
		+ v(fe.PodlahaNaTerene_A)
		+ v(fe.StrechaPlocha_A)
		+ v(fe.StropNadNevykur_A) 
	}}"
	Ponechavam aj zjednodusenu moznost zadania funkcie ekvivalentnou formou:
	data-calc-idx="12"
	data-calcul="v(fe.VonkajsiaStena_A)
				+ v(fe.VonkajsieDvere_A)
				+ v(fe.Okna_A)
				+ v(fe.PodlahaNaTerene_A)
				+ v(fe.StrechaPlocha_A)
				+ v(fe.StropNadNevykur_A) 
	"
	
Argument fe, automaticky dodavany pri volani kalkulacnej funkcie predstavuje
elementy aktualneho fieldsetu (t.j. toho, v ktorom je kalkulovany element osadeny).
Volat je samozrejme mozne aj elementy inych fieldsetov pomocou konvencie
	v(e(meno_form,meno_fieldset).meno_element)
*/
	,	funcs : {}
	,	readFuncs : function( ls_forms ) {
			ls_forms = ls_forms || this.ls_forms;
			this.funcs = {};	// clean always when setting by read
			for (var i=0; i < ls_forms.length; i++) {
				var fname = ls_forms[i]
				,	frm = document.forms[fname]
				,	fs = frm.getElementsByTagName('fieldset')
				;
				this.funcs[fname] = this.funcs[fname] || {};
				for (var f=0; f < fs.length; f++) {
					var fse = fs[f]
					,	fsname = fse.name
					,	calculs = fse.querySelectorAll('*[data-calcul]')
				//	,	calculs = frm.queryXpath('.//*[@data-calcul][not(contains(ancestor::a:tr[1]/@class,"proforma"))]')
					;
					this.funcs[fname][fsname] = this.funcs[fname][fsname] || {};
					for (var j=0; j<calculs.length; j++) {
						var clc = calculs[j]
						,	ename = clc.name //	|| clc.getAttribute('name')
						,	calcul = clc.dataset.calcul
						,	calc = JSONfn.parseOr(calcul)	//,__,{})
						,	idx = calc && calc.idx || parseFloat(clc.dataset.calcIdx)
						,	fnc = calc && calc.fnc || new Function('fe','return '+calcul)
						;
						if (fnc) {
							this.funcs[fname][fsname][ename] = {
								e : clc 
							,	idx : (isDef(idx) && isNbr(idx)) ? idx : j	// index maybe to order calculations
							,	f : fnc
							,	ac : false	// flag actually calculated
							};
						} else {
		console.log('Chyba calcul '+fname+'.'+fsname+'.'+ename);					
						}
					}
				}
			}
	//		this.goFuncs = gopn(this.funcs,'funcs');
		}
	,	calculate : function( ls_forms, debugElem, noclean ) {
now_calculated_CalculForms = this;
			if (!noclean) {
//				var funcs = this.funcs;
//				Object.keys(funcs).forEach( function(v) {
//					Object.keys(funcs[v]).forEach( function(vv) {
//						Object.keys(funcs[v][vv]).forEach( function(vvv) {
//							if (funcs[v][vv][vvv] && isDef(funcs[v][vv][vvv].ac)) {
//								funcs[v][vv][vvv].ac = false;
//							}
//						})
//					})
//				})
				gopn(Actual_CalculForms.funcs,'funcs',__,  function(o) {
					if (o && (typeof o.ac != 'undefined')) {
						o.e.value = '';	// vadne hodnoty default ??
						o.ac = false;
					}
					return o;
				})
			}
now_calculated_CalculForms.need_recompute = false;
			ls_forms = ls_forms || this.ls_forms;
			for (var i=0; i < ls_forms.length; i++) {
				var fname = ls_forms[i]
				,	frme = document.forms[fname].elements
				,	fncs = this.funcs[fname]
				,	fsnames = fncs && Object.keys(fncs) || []
				;
//	document.forms[fname].queryXpath('.//*[@data-calcul]', function(o) {
//		o.value = '';
//	});
				fsnames.sort( function(a,b) {	// order by caculation order
					if (fncs[a].idx < fncs[b].idx) { return -1; }
					if (fncs[a].idx > fncs[b].idx) { return 1; }
					return 0;
				})
				for (var f=0; f < fsnames.length; f++) {
					var fsname = fsnames[f]
					,	enames = fncs[fsname] && Object.keys(fncs[fsname]) || []
					,	efncs = this.funcs[fname][fsname]
					,	frfsmeA = frme[fsname] && frme[fsname].querySelectorAll('*[name]') || []
					,	frfsme = {}	//	,	frfsme = frme[fsname].elements
// POZOR, cita vsetky *[name] elementy, a tym pouziva 
// napr. span[name] ako calcul konstanty (nezapisovane do SAVE)
// a teda VZDY zavisle na priamom obsahu HTML 
					;
					for(var j=0; j < frfsmeA.length; j++) {
						frfsme[frfsmeA[j].getAttribute('name')] = frfsmeA[j];
					}
					enames.sort( function(a,b) {	// order by caculation order
						if (efncs[a].idx < efncs[b].idx) { return -1; }
						if (efncs[a].idx > efncs[b].idx) { return 1; }
						return 0;
					})
					for (var j=0; j < enames.length; j++) {
						var ename = enames[j]
						,	elfnc = efncs[ename]
						,	result
						;
if ( (debugElem instanceof HTMLElement)	&& (debugElem === elfnc.e) ) {
	debugger;
}
						if (elfnc && elfnc.f) {
							try {
								result = elfnc.f(frfsme);
							} catch(e) {
								result = null;
		console.log('Chyba vypoctu '+fname+'.'+fsname+'.'+ename);					
							}
						}
					//	if ( (result !== null) && (! isNbr(result) ) ) {
							SV(elfnc.e, result, __, elfnc);
					//	}
					}
				}
			}
			if (now_calculated_CalculForms.need_recompute) {
				this.calculate(ls_forms, debugElem, true);
			}
		}
}
///</object>

