/*
Komukoľvek, kto získa kópiu tohto softvéru a súvisiacich súborov dokumentácie („Softvér“), 
sa týmto udeľuje bezplatné povolenie obchodovať so Softvérom bez obmedzení, 
ako aj neobmedzené právo na použitie, kopírovanie, úpravu, spojenie, zverejnenie, 
distribuovanie, ďalšie udelenie licencie a/alebo predaj kópií Softvéru a umožnenie osobám, 
ktorým sa Softvér poskytuje, aby tak učinili, a to za nasledovných podmienok:
Hore uvedené oznámenie o autorských právach a toto oznámenie o povolení budú súčasťou 
všetkých kópií alebo zásadných častí Softvéru. 
 
TENTO SOFTVÉR SA POSKYTUJE „TAK, AKO JE“, BEZ AKÝCHKOĽVEK ZÁRUK, VYJADRENÝCH PRIAMO ČI NEPRIAMO, 
VRÁTANE (NIE VŠAK VÝLUČNE) ZÁRUKY PREDAJNOSTI, VHODNOSTI NA KONKRÉTNY ÚČEL A NEPORUŠENIA PRAVIDIEL. 
AUTORI ALEBO DRŽITELIA AUTORSKÝCH PRÁV V NIJAKOM PRÍPADE NEMÔŽU BRAŤ ZODPOVEDNOSŤ 
ZA AKÉKOĽVEK REKLAMÁCIE, ŠKODY ALEBO BYŤ INAK ZODPOVEDNÍ, ČI UŽ PRI UPLATŇOVANÍ ZMLÚV, 
PRI PREČINOCH ALEBO INÝCH ČINOCH VYPLÝVAJÚCICH, SÚVISIACICH I NESÚVISIACICH SO SOFTVÉROM 
ALEBO POUŽITÍM SOFTVÉRU ALEBO OBCHODOVANÍM SO SOFTVÉROM.
*/

	_isNaN  = function(obj) { return obj !== obj; }

///<section name="helpers">
///<function name="escapeLTGT">
/// from helpers.js
	escapeLTGT = function (str) {
  return str
    .replace(/[\&]/g, "&amp;")
    .replace(/[<]/g, "&lt;")
    .replace(/[>]/g, "&gt;")
	;
};
///</function>


function cancelEvent(event, cancelProp) {
 if (cancelProp) {
  event.cancelBubble = true;
  if (event.stopPropagation) event.stopPropagation();
 }
 if (event.preventDefault) event.preventDefault();
 event.returnValue = false;
 return false;
};
function preventEventDefault(event) {
	if(event.preventDefault)
		event.preventDefault();
	event.returnValue = false;
//=======================	
//	prebublaj(evt);
//=======================
	return false;
}
/* Ctrl-A, onselectstart:  CHROME
	default   :	enableDocSelection() 
pomocou Ctrl-A je mozne vybrat text, pokial sa jedna o INPUT,TEXTAREA, tak ich cely, inak cela stranka
	off		: disableDocSelection() 
stale je mozne oznacit pomocou mysi IBA v INPUT,TEXTAREA a FUNGUJE dragAndDrop do inej TEXAREA (aj do CodeMirror)
*/
function disableDocSelection() {
	document.onselectstart	=	preventEventDefault;
//	cPC.document.selectstart = false;
}
function enableDocSelection() {
	document.onselectstart	=	null;
//	cPC.document.selectstart = true;
}
function disableDocDragAndDrop() {
	document.body.ondragstart = function(){return false;}; 
	document.body.ondrop = function(){return false;};
//	cPC.document.body.dragAndDrop = false;
}
function enableDocDragAndDrop() {
	document.body.ondragstart=null;
	document.body.ondrop=null;
//	cPC.document.body.dragAndDrop = true;
}

function checksum(s) {
	s = s || '';
  var chk = 0x12345678;
  var len = s.length;
  for (var i = 0; i < len; i++) {
      chk += (s.charCodeAt(i) * (i + 1));
  }

  return (chk & 0xffffffff).toString(16);
}

///</section>

__MOBI = navigator.userAgent.match(/Android|BlackBerry|iPhone|iPad|iPod|Opera Mini|IEMobile/i); 

///<section name="Files Handling">
/// from UI_forms.js
///<function name="saveTextAsFile">
///<param name="textToWrite" type="String"> zapisovany text </param>
///<param name="fileNameToSaveAs" type="String"> meno zapisovaneho suboru </param>
function saveTextAsFile( textToWrite, fileNameToSaveAs, link ) {
	if (__MOBI) {
		fileNameToSaveAs = prompt('meno súboru',fileNameToSaveAs);
	}
	if (!fileNameToSaveAs) {
		return;
	}
//	var textToWrite = document.getElementById("inputTextToSave").value;
	var textFileAsBlob = new Blob([textToWrite], {type:'text/plain'});
//	var fileNameToSaveAs = document.getElementById("inputFileNameToSaveAs").value;

	var downloadLink = document.createElement("a");
	downloadLink.download = fileNameToSaveAs;
	downloadLink.innerHTML = "Download File";
//	if (window.webkitURL != null) {
//		// Chrome allows the link to be clicked
//		// without actually adding it to the DOM.
//		downloadLink.href = window.webkitURL.createObjectURL(textFileAsBlob);
//	} else {
		// Firefox requires the link to be added to the DOM
		// before it can be clicked.
		downloadLink.href = window.URL.createObjectURL(textFileAsBlob);
//		downloadLink.onclick = function(){ window.URL.revokeObjectURL(this.href); }	//destroyClickedElement;
		downloadLink.style.display = "none";
		document.body.appendChild(downloadLink);
//	}
	downloadLink.click();
	if ( ! link) {
		setTimeout( function(){ window.URL.revokeObjectURL(downloadLink.href); }, 10 );
	}
	return downloadLink;
}
///</function>
///<function name="readFileAsText">
///<param name="readFileAsText" type="String"> meno citaneho suboru </param>
///<param name="callback" type="Function"> funkcia, spracuvajuca vysledok po nacitani </param>
/// funkcia readFileAsText pracuje s HTML5 FileReader API a ocakava FILES
/// od vyberoveho tlacitka suboru v konstrukcii:
/// input type="file" id="..." name="file"  
/// napr. v ramci change event-u
/// vysledok nacitania (text, alebo Null) sa posle do callback funkcie  
function readFileAsText( files, callback ) {
//    var files = document.getElementById('files').files;
    if (!files.length) {
//      alert('Please select a file!');
		konzola('Project file unassigned !');
		return;
    }
    var file = files[0]
    ,	reader = new FileReader()
	;
    // If we use onloadend, we need to check the readyState.
    reader.onloadend = function(evt) {
		if (evt.target.readyState == FileReader.DONE) { // DONE == 2
			if (getType(callback) == '[object Function]' ) {
				callback( evt.target.result );
			}
			if (getType(callback) == '[object String]' ) {
				var el = document.getElementById(callback)
				,	ctx = el 
					&& ( (typeof el.value == 'undefined') ? 'textContent' : 'value' )
				;
				if (ctx) {
					el[ctx] = evt.target.result;
				}
			}
		}
    }
    reader.readAsText(file);
}
///</function>
///</section>


///<section name="getset">
// return the value of the radio button that is checked
// return an empty string if none are checked, or
// there are no radio buttons
function getCheckedValue(radioObj) {
	if(!radioObj)
		return "";
	var radioLength = radioObj.length;
	if(radioLength == undefined)
		if(radioObj.checked)
			return radioObj.value;
		else
			return "";
	for(var i = 0; i < radioLength; i++) {
		if(radioObj[i].checked) {
			return radioObj[i].value;
		}
	}
	return "";
}

// set the radio button with the given value as being checked
// do nothing if there are no radio buttons
// if the given value does not exist, all the radio buttons
// are reset to unchecked
function setCheckedValue(radioObj, newValue) {
	if(!radioObj)
		return;
	var radioLength = radioObj.length;
	if(radioLength == undefined) {
		radioObj.checked = (radioObj.value == newValue.toString())
			|| !!radioObj.getAttribute('checked');
		return;
	}
	var tuse = false;
	for(var i = 0; i < radioLength; i++) {
		radioObj[i].checked = false;
		if(	newValue && (radioObj[i].value == newValue.toString()) ) {
			radioObj[i].checked = true;
			tuse = true;
		}
	}
	if (! tuse) {	// not finded correct value, set defaults
		for(var i = 0; i < radioLength; i++) {
			if(	radioObj[i].getAttribute('checked') ) {
				radioObj[i].checked = true;
				tuse = true;
				break;
			}
		}
	}
	if (! tuse) {	// not finded checked, set first SOMETHING MUST BE !
		radioObj[0].checked = true;
	}
}
/* test:

<form name="radioExampleForm" method="get" action="" onsubmit="return false;">
<p><label for="number0"><input type="radio" value="0" name="number" id="number0"> Zero</label>
&#160;<label for="number1"><input type="radio" value="1" name="number" id="number1"> One</label>
&#160;<label for="number2"><input type="radio" value="2" name="number" id="number2"> Two</label>
&#160;<label for="number3"><input type="radio" value="3" name="number" id="number3"> Three</label>
&#160;<label for="number4"><input type="radio" value="4" name="number" id="number4"> Four</label>
<p><input type="button" onclick="alert('Checked value is: '+getCheckedValue(document.forms['radioExampleForm'].elements['number']));" value="Show Checked Value">
&#160;<input type="button" onclick="setCheckedValue(document.forms['radioExampleForm'].elements['number'], '2');" value="Set Checked to Two">
&#160;<input type="button" onclick="setCheckedValue(document.forms['radioExampleForm'].elements['number'], '4');" value="Set Checked to Four">
&#160;<input type="button" onclick="setCheckedValue(document.forms['radioExampleForm'].elements['number'], '');" value="Uncheck All">
</form>

*/
///</section>

///<section name="Array_functionbs">

	fill_assoc_arr = function( arr_cols, arr_vals, result_arr) {
		arr_vals.forEach( function(v,i,a) {
			var obj = {};
			arr_cols.forEach( function(vv,ii,aa) {
				if (vv[1].match(/int|float|decimal/i)) {
					obj[vv[0]] =  parseFloat(v[ii]);
				} else {
					obj[vv[0]] =  v[ii];
				}
			})
			result_arr.push(obj);
		});
	}
	selectArr = function ( arr, orderFnc, filterFnc ) {
		orderFnc = orderFnc || function(){ return 0;};
		filterFnc = filterFnc || function(){ return true;};
		arr.sort(orderFnc);
		return arr.filter(filterFnc);
	}
	set_combo = function ( combo, arr, itemV, itemT, callback ) {
		while(combo.options.length) {
			combo.options.remove(0);
		}
		arr.forEach( function(v,i,a) {
			o = document.createElement('option');
			o.value = itemV ? ( (typeof itemV == 'function') ? itemV(v) : v[itemV]) : i; 
			o.text = itemT ? ( (typeof itemT == 'function') ? itemT(v) : v[itemT]) : i;
			if (typeof callback == 'function') {
				callback(o, v, i, a);
			}
			combo.add(o);
		})
	}
	

///</section>

function nearestParent(el, tag) {
	var par = el
	,	tn = tag.toLowerCase()
	;
	while(par) {
		if (par.nodeName.toLowerCase() == tn) {
			break;
		}
		par = par.parentNode;
	}
	return par;
}
	
function selectedSelect( sel ) {
	var si = sel.selectedIndex;
	for(var i=0; i<sel.options.length; i++) {
		sel.options[i][(i == si) ? 'setAttribute' :  'removeAttribute']('selected','selected')
	}
}
	
// prepinacky a ovladacky:
	divtoggle = function(evt, el, onState, offState) {
// arrow down	&#9660;
// arrow up		&#9650; 
		var arrow = evt && evt.currentTarget.querySelector('.arrow')
		,	dir 
		;
		if (getComputedStyle(el).display == 'none') {
			el.style.display =  onState || 'block';
			dir = 1;
		} else {
			el.style.display = offState || '';	//null;
			dir = 0;
		}
		if (arrow) {
			arrow.innerHTML = dir ? '&#9650;' : '&#9660;';
		}
		return dir;
	}
	toggledivs = function( evt, holderID, selector, onState, offState ) {
		var els = document.getElementById(holderID).querySelectorAll(selector);
		for (var i=0; i < els.length; i++) {
			if (getComputedStyle(els[i]).display == 'none') {
				els[i].style.display =  onState || 'block';
				dir = 1;
			} else {
				els[i].style.display = offState || '';	//null;
				dir = 0;
			}
		}
		evt.stopPropagation();
	}
	divoutclose = function(evt) {
//		evt.currentTarget.parentNode.parentNode.style.display=null; 
		var el = evt.currentTarget;
		while (el) {
			if (el.classList.contains('form_div')) {
				el.style.display='';	//null; 
				break;
			}
			el = el.parentNode;
		}
		evt.stopPropagation();
	}
	zoomtoggle = function(evt, el, minZ) {
// arrow down	&#9660;
// arrow up		&#9650; 
		var arrow = evt.currentTarget.querySelector('.arrow')
		,	dir 
		;
// struktura zmenena z 
//  <div style="zoom:0.5"></div>
//		if (getComputedStyle(el).zoom < 1) {
//			el.style.zoom =  1;
//			dir = 1;
//		} else {
//			el.style.zoom = minZ || 0.33;
//			dir = 0;
//		}
// na 
//  <div>
//		<div style="transform-origin:0px 0px; transform:scale(0.5)"></div>
//  </div>
		var fel = el.firstElementChild;
		if (getComputedStyle(fel).transform.match(/matrix\(0.5/)) {
			fel.style.transform="scale(1)";
			el.style.height = (parseFloat(el.style.height) * 2) +'px';
			dir = 1;
		} else {
			fel.style.transform="scale(0.5)";
			el.style.height = (parseFloat(el.style.height) / 2) +'px';
			dir = 0;
		}
		if (arrow) {
			arrow.innerHTML = dir ? '&#9650;' : '&#9660;';
		}
		return dir;
	}
	
	MAX_KONZOLA_LINES = 100;	// 9
	konzola = function(txt, no_preamb) {
		no_preamb = no_preamb || false;
console.log(txt);
		var konzolaTxt = document.querySelector('#konzola textarea');
		if (konzolaTxt) {
			var lines = konzolaTxt.value.split('\n');
			lines = lines.slice(0,MAX_KONZOLA_LINES);
			konzolaTxt.value = lines.join('\n');
			konzolaTxt.value = (no_preamb ? '' : 'FRAGMENT WEB : ')+txt+"\n"+konzolaTxt.value;
		}
	}
	
	Object.defineProperty(console, '_commandLineAPI',
   { get : function() { throw 'Nooo!' } })
   
   	
// Create a JSON object only if it does not already exist. 
//var JSONfn = {};
if (typeof JSONfn == 'undefined') {
    JSONfn = {};
}

(function () {

	JSONfn.stringify = function(obj, ufnc, space) {
		return JSON.stringify(obj,function(key, value){
// POZOR ! arrayASobject (associative array) NOTICE:		
//	obj: Array[1]
//		0: Object
//			element: "#allowRawView"
//			prop: "checked"
//			value: null
//			__proto__: Object
//		/xhtml:html/xhtml:body/xhtml:div[1]/xhtml:div[2]/xhtml:input[1]: Object
//		length: 1
//		__proto__: Array[0]
//-----------------------  jsonTxt: 	[{"element":"#allowRawView","prop":"checked","value":null}]
// no stringified (array not native) object properties !!! 
//all is OK, it is impossible literally write associative array !!!

				var preVal = ( typeof ufnc == "function") ? ufnc(key,value) : value;
				return (typeof preVal === 'function' ) ? preVal.toString() : preVal;
			}, space);
	}

	JSONfn.parseOr = function(str, ufnc, reviver_or_default, toLog) {
		var output = (typeof reviver_or_default == 'function') ? undefined : reviver_or_default;
		try { 
			output = JSON5.parse(str, function(key, value){
				var val = (typeof value != 'string') ?  value 
					: ( value.substring(0,8) == 'function') ? eval('('+value+')') : value;
				return ( typeof ufnc == "function") ? ufnc(key,value, val) : val;
			}); 
		} catch(e) { 
			if (toLog) {
				console.log('JSONfn parse error !'); 
			}
			if (typeof reviver_or_default != 'undefined') {
				output = reviver_or_default;
			}
		}
		return output;
	}
	JSONfn.parse = function(str, ufnc) {
		return JSON.parse(str,function(key, value){
			var val = (typeof value != 'string') ?  value 
				: ( value.substring(0,8) == 'function') ? eval('('+value+')') : value;
			return ( typeof ufnc == "function") ? ufnc(key,value, val) : val;
		});
	}
/*	ina moznost spracovania funkcii:			TRY IT !!!		
http://blogs.realdolmen.com/experts/2012/07/06/json-serialize-and-deserialize-functions-in-javascript/

		== zodpoveda mojej
	JSON.stringify(filters, function (key, value) {
        if (typeof value === "function") {
            return value.toString();
        }
        return value;
    });
		== PEKNEEEEEEEEEEEEEE
	JSON.parse(filtersString, function (key, value) {
       if (value 
           && typeof value === "string" 
           && value.substr(0,8) == "function") {
           var startBody = value.indexOf("{") + 1;
           var endBody = value.lastIndexOf("}");
           var startArgs = value.indexOf("(") + 1;
           var endArgs = value.indexOf(")");
    
           return new Function(value.substring(startArgs, endArgs)
                            , value.substring(startBody, endBody));
       }	
*/

	JSONfn.toScript = function /*stringify*/(data, prefix) {
//http://stackoverflow.com/questions/6583330/javascript-object-get-code-as-string
        function unicode_escape(c) {
            var s = c.charCodeAt(0).toString(16);
            while (s.length < 4) s = "0" + s;
            return "\\u" + s;
        }
        if (!prefix) prefix = "";
        switch (typeof data) {
            case "object":  // object, array or null
                if (data == null) return "null";
                var i, pieces = [], before, after;
                var indent = prefix + "    ";
                if (data instanceof Array) {
                    for (i = 0; i < data.length; i++)
                        pieces.push(this.toScript/*stringify*/(data[i], indent));
                    before = "[\n";
                    after = "]";
                }
                else {
                    for (i in data)
                        pieces.push(i + ": " + this.toScript/*stringify*/(data[i], indent));
                    before = "{\n";
                    after = "}";
                }
                return before + indent
                       + pieces.join(",\n" + indent)
                       + "\n" + prefix + after;
            case "string":
                data = data.replace(/\\/g, "\\\\").replace(/"/g, '\\"')
                           .replace(/\n/g, "\\n").replace(/\r/g, "\\r")
                           .replace(/\t/g, "\\t")
                           .replace(/[\x00-\x19]/g, unicode_escape);
                return '"' + data + '"';
            default:
                return String(data).replace(/\n/g, "\n" + prefix);
        }
    }
}());

function blinker( sel ) {
    $(sel).fadeOut(500);
    $(sel).fadeIn(500);
}
function colorBackgrounder( sel, colorStart, colorEnd ) {
	var colorAct = getComputedStyle(sel).backgroundColor;
	colorStart = colorStart || colorAct; 
	colorEnd = colorEnd || 'salmon';
	sel.style.backgroundColor = colorStart;
	setTimeout(function(){
		sel.style.backgroundColor = colorEnd;
		setTimeout(function(){
			sel.style.backgroundColor = colorAct;			
		},500);
	},500);
}
function rollover(evt, dir) {
	var divs = evt.currentTarget.parentNode.querySelectorAll('div.roller div')
	,	cnt = divs.length
	;
	for (var i=0; i<cnt; i++) {
		if (divs[i].style.display != 'none') {
			divs[i].style.display = 'none';
			if (dir == 1) {	// next
				divs[(i==cnt-1)?0:i+1].style.display = '';
			} else {
				divs[(i==0)?cnt-1:i-1].style.display = '';
			}
			break;
		}
	}
}


///<from file="/LIBRARY/HELPERS/globalFnc.js">
		cssPath = function (el, fullPath, useNthChild, relativeEl) {
			fullPath = (fullPath !== undefined) ? fullPath : false;
			useNthChild = (useNthChild !== undefined) ? useNthChild : true;
			relativeEl = relativeEl || document;
			var cssPathStr = ''
			,	testPath = ''
			,	parents = []
			,	parentSelectors = []
			,	tagName
			,	cssId
			,	cssClass
			,	tagSelector
			,	vagueMatch
			,	nth
			,	i
			,	c
	//		,	doc = document
			,	rET
			;
			
			// Go up the list of parent nodes and build unique identifier for each:
			while ( el ) {
				vagueMatch = 0;

				if (el === window) {
					return 'window';
				}
				// Get the node's HTML tag name in lowercase:
				tagName = el.nodeName.toLowerCase();
				
				// Get node's ID attribute, adding a '#':
				cssId = ( el.id ) ? ( '#' + el.id.trim() ) : false;
				
				// Get node's CSS classes, replacing spaces with '.':
	//			cssClass = ( el.className ) ? ( '.' + el.className.replace(/\s+/g,".") ) : '';
	// ! SVG elements
				var c = el.className, elClass = (typeof c === "object" && "baseVal" in c ? c.baseVal : c);			
				cssClass = ( elClass ) ? ( '.' + elClass.trim().replace(/\s+/g,".") ) : '';

				// Build a unique identifier for this parent node:
				if ( cssId ) {
					// Matched by ID:
					tagSelector = tagName + cssId + cssClass;
				} else if ( cssClass ) {
					// Matched by class (will be checked for multiples afterwards):
					tagSelector = tagName + cssClass;
				} else {
					// Couldn't match by ID or class, so use ":nth-child()" instead:
					vagueMatch = 1;
					tagSelector = tagName;
				}
				
				// Add this full tag selector to the parentSelectors array:
				parentSelectors.unshift( { tag:tagSelector, element:el} )

				// If doing short/optimised CSS paths and this element has an ID, stop here:
				if ( cssId && !fullPath )
					break;
				
				// Go up to the next parent node:
				el = el.parentNode !== relativeEl/*doc*/ ? el.parentNode : false;
				
			} // endwhile
			
			
			// Build the CSS path string from the parent tag selectors:
			for ( i = 0; i < parentSelectors.length; i++ ) {
				cssPathStr += '>' + parentSelectors[i].tag;		// + ' ' + cssPathStr;
				
				// If using ":nth-child()" selectors and this selector has no ID / isn't the html or body tag:
				if ( useNthChild && !parentSelectors[i].tag.match(/#/) && !parentSelectors[i].tag.match(/^(html|body)$/) ) {
					
					// If there's no CSS class, or if the semi-complete CSS selector path matches multiple elements:
	//				if ( !parentSelectors[i].match(/\./) || $( cssPathStr ).length > 1 ) {
					if ( !parentSelectors[i].tag.match(/\./) || relativeEl/*doc*/.querySelectorAll( cssPathStr.substr(1) ).length > 1 ) {
	//a kde ma priradenie el ????
	el = parentSelectors[i].element;	
						// Count element's previous siblings for ":nth-child" pseudo-selector:
						for ( nth = 1, c = el; c.previousElementSibling; c = c.previousElementSibling, nth++ );
						
						// Append ":nth-child()" to CSS path:
						cssPathStr += ":nth-child(" + nth + ")";
					}
				}
				
			}
			
			// Return trimmed full CSS path:
			return cssPathStr.substr(1).replace(/^[ \t]+|[ \t]+$/, '');
		}
///</from>

///<from file="/LIBRARY/AJAX/SendToXHR.js">
	function SenDFormular(form, url, oOutput, callback, addData) {
		var elems = form && form.elements || []
		,	disables = []
		;
		for (var i=0; i<elems.length; i++) {
			if (elems[i].disabled) {
				elems[i].disabled = false;
				disables.push(elems[i]);
			}
		}		
		var formData = new FormData( form );
		if (addData) {
			Object.keys(addData).forEach( function(v) {
				formData.append(v,addData[v]);
			});
		}
		if (typeof XDEBUG != 'undefined') {
			formData.append('XDEBUG_SESSION_START','ja');
		}
	//	formData.append("serialnumber", serialNumber++);
		var request = new XMLHttpRequest();
		request.onload = function(oEvent) {
			var retval = request.response
			,	ok = false
			;
			if (request.status == 200) {
				try{	retval = JSON.parse(request.response); ok = true;
				} catch(e) {}
				if (oOutput) {
					if (ok) {
						oOutput.innerHTML = "result:"+retval.result + "<br/>\n" + retval.statusPole;	//"Uploaded!";
					} else {
						oOutput.innerHTML = '';
						oOutput.textContent = request.response;
					}
				}
			} else {
				if (oOutput) {
					oOutput.innerHTML = "Error " + request.status + " occurred when trying to upload your file.<br \/>";
				}
			}
			callback && callback(retval);
		};
		request.open("POST", url);
		request.send(formData);	
		for (var i=0; i<disables.length; i++) {
			disables[i].disabled = true;
		}
	}
///</from>


/*	show_titles = function() {
	var ttts = document.querySelectorAll('*[title]')
	,	platno = document.querySelector('div#titles_platno')
	;
	if (!platno) {
		platno = document.body.appendChild(document.createElement('div'));
		platno.setAttribute('id','titles_platno'); 
		platno.setAttribute('style','position:absolute;top:0px;left:0px;color:blue;background-color:yellow;z-index:1000;'); 
	}
	platno.innerHTML='';
	for(var i=0;i<ttts.length; i++) {
//		console.log(ttts[i].getBoundingClientRect());
		var el = ttts[i]
		,	bcr = el.getBoundingClientRect()
		,	vis = bcr.width * bcr.height > 0
		;
		if (vis) {
			var d = platno.appendChild(document.createElement('div'));
			d.textContent=el.title;
			d.setAttribute('style','position:absolute;top:'+(bcr.y+5)+'px;left:'+(bcr.x+15)+'px;'); 
		}
	}
}	*/


///<function name="loadman_location_search">
/// funkcia zabezpecuje nacitanie JSON definicie z volacieho riadku
function locationSearchToObject( srch ) {
	srch = srch || window.location.search.substring(1);
	var pairs = srch.split("&")		// window.location.search.substring(1).split("&")
	,	obj = {},	pair,	i
	;
//	for ( i in pairs ) {
//		if ( pairs[i] === "" ) continue;
//		pair = pairs[i].split("=");
//		obj[ decodeURIComponent( pair[0] ) ] = decodeURIComponent( pair[1] );
//	}
	pairs.forEach(function(v) {
		if ( v !== "" ) {
			pair = v.split("=");
			obj[ decodeURIComponent( pair[0] ) ] = decodeURIComponent( pair[1] );
		}
	});
	return obj;
}


function title_displayer(evt,tel) {
	var et = tel || evt.target;
	if (et.hasAttribute('title')) {
		var tel = document.getElementById('faketitle');
		if (tel) {
			tel.style.display='block';
			tel.style.left=evt.clientX+'px';
			tel.style.top=evt.clientY+'px';
			tel.lastElementChild.textContent = et.title;
/*			tel.lastElementChild.__hbp = {e:et};
			et.style.outline = '2px solid red';	*/
		}
	}
	cancelEvent(event,true);
}

WINDOW_ONERROR_BLOCK = 0;
window.onerror = function(error, url, line) {
	var msg = {acc:'error', data:'ERR:'+error+' URL:'+url+' L:'+line}
	,	okonz = false
	;
	if (WINDOW_ONERROR_BLOCK > 0) {
		WINDOW_ONERROR_BLOCK--;
	} else {
/*		WINDOW_ONERROR_BLOCK = parseFloat(prompt( 
"\n\n Nastala neošetrená chyba javascriptu, \n\
nech vás netrápi : (špecialisti môžu omrknúť DevTools)\n\n\
 [Zadanie počtu preskočení nasledujúcich chybových hlášok]"
		,10));	*/
		okonz = confirm(
"\n Nastala neošetrená chyba javascriptu ! \n\
Nakoľko našou snahou je kompletne ošetrený chod aplikácie, \n\
ide o nečakanú situáciu, a radi by sme o nej boli informovaní,\n\
POKIAĽ nejde o problém neaktuálnej CACHE prehliadača samotného.\n\
Vylúčiť to je možné opätovným Reload-om po vymazaní histórie.\n\
Opakujúcu sa chybu je možné kopírovať z konzole aplikácie.\n\n\
Otvoriť konzolu aplikácie ?"
		);
	}
	/*errorConsole.log*/konzola( (new Date) + '\n APP_JAVASCIRPT_ERROR : '+JSON.stringify(msg,__,' '),true );
	if (okonz) {
		divtoggle(null,document.getElementById('konzola'),'block','none');	
	}
};
function error_test() {
	setTimeout( function() {
		return a/0;
	},4000);
}

// TODO otestovat !
var doubletapDeltaTime_ = 700;
var doubletap1Function_ = null;
var doubletap2Function_ = null;
var doubletapTimer = null;

function tap(singleTapFunc, doubleTapFunc) {
    if (doubletapTimer==null) {
    // First tap, we wait X ms to the second tap
        doubletapTimer_ = setTimeout(doubletapTimeout_, doubletapDeltaTime_);
        doubletap1Function_ = singleTapFunc;
        doubletap2Function_ = doubleTapFunc;
    } else {
    // Second tap
        clearTimeout(doubletapTimer);
        doubletapTimer_ = null;
        doubletap2Function_();
    }
}

function doubletapTimeout() {
// Wait for second tap timeout
    doubletap1Function_();
    doubleTapTimer_ = null;
}
