
(function(glob) {

/* ___________________________________________________________________________
 *		native D O M
 * ___________________________________________________________________________
 */
xmlParse = function( xmltxt , pure) {
	pure = pure || false;
	var xmlDoc = (new DOMParser).parseFromString(xmltxt, "application/xml");
/*  HOW TO REMOVE UNNEEDED TEXT NODES ????  un-beautify

	if (pure) {
		(function output(node, filter) {
			var child;
			var children = node.childNodes.length;
//			if (filter === "") {
//				$('#div_clients').append(node.nodeType + " : " + node.nodeName + "<br>");
//			} else {
//				filter = node.nodeName === filter ? "" : filter;
//			}
			for (child = 0; child < children; child += 1) {
				var nestIt = true;
				if (typeof filter == "function") {
					nestIt = filter(node.childNodes[child]);
				}
				if (nestIt) {
					output(node.childNodes[child], filter);
				}
			}
//		}(xmlDoc,filter);	
		}(xmlDoc,  function(el) {
				if ( (el.nodeType == Node.TEXT_NODE) || (el.nodeType == Node.COMMENT_NODE)) {
					return true;
				}
				if ( (el.nodeType == Node.TEXT_NODE) || (el.nodeType == Node.COMMENT_NODE)) {
					el.parentNode.removeChild(el);
				}
				return false;
			}
		 ));	
	}
*/
	return xmlDoc;
}

Node.prototype.toStringFull = function() {
	var attrs ="";
	if (this.attributes) {
		for (var i=0; i < this.attributes.length; i++) {
			attrs+= this.attributes[i].name+"="+this.attributes[i].nodeValue + " ";
		}
	}
  return this.nodeName + " " + NODE_TYPES[this.nodeType] + " " + this.nodeValue + " "+ attrs ;
}

Node.prototype.typeNames = [
	""								//0
,	"ELEMENT_NODE"					//1
,	"ATTRIBUTE_NODE" 				//2
,	"TEXT_NODE"						//3
,	"CDATA_SECTION_NODE" 			//4
,	"ENTITY_REFERENCE_NODE" 		//5
,	"ENTITY_NODE" 					//6
,	"PROCESSING_INSTRUCTION_NODE"	//7
,	"COMMENT_NODE"					//8
,	"DOCUMENT_NODE"					//9
,	"DOCUMENT_TYPE_NODE"			//10
,	"DOCUMENT_FRAGMENT_NODE"		//11
,	"NOTATION_NODE" 				//12
];

/* ___________________________________________________________________________
 *		native X P A T H
 * ___________________________________________________________________________
 */
/* MDN:
// Evaluate an XPath expression aExpression against a given DOM node
// or Document object (aNode), returning the results as an array
// thanks wanderingstan at morethanwarm dot mail dot com for the
// initial work.
function evaluateXPath(aNode, aExpr) {
  var xpe = new XPathEvaluator();
  var nsResolver = xpe.createNSResolver(aNode.ownerDocument == null ?
    aNode.documentElement : aNode.ownerDocument.documentElement);
  var result = xpe.evaluate(aExpr, aNode, nsResolver, 0, null);
  var found = [];
  var res;
  while (res = result.iterateNext())
    found.push(res);
  return found;
}

PROBLEMY v google CHROME:
oznacim v inspektore element:
CSS:   html xml#XSLT_bojanbjelic_xml2json xsl:stylesheet xsl:template xsl:text
	$0
			<xsl:text xmlns:xsl="http://www.w3.org/1999/XSL/Transform">{</xsl:text>
skusim 
	document.querySelector("html xml#XSLT_bojanbjelic_xml2json xsl:stylesheet xsl:template xsl:text")
			Error: SyntaxError: DOM Exception 12
(funguje iba document.querySelector("html xml#XSLT_bojanbjelic_xml2json")	)
idem XPath-ovat:
Copy XPath:		//*[@id="XSLT_bojanbjelic_xml2json"]/stylesheet/template[1]/text[1]
		(vracia resultType = 4 ... UNORDERED_ITERATOR_TYPE)
	document.evaluate('//*[@id="XSLT_bojanbjelic_xml2json"]/stylesheet/template[1]/text[1]',document).iterateNext()
			null
pokial vlastne funguje:
	document.evaluate('//*[@id="XSLT_bojanbjelic_xml2json"]',document).iterateNext()
			<xml xmlns="http://www.w3.org/1999/xhtml" id="XSLT_bojanbjelic_xml2json" style="display:none" version="1.0" encoding="UTF-8">...</xml>
	document.evaluate('//*[@id="XSLT_bojanbjelic_xml2json/stylesheet"]',document).iterateNext()
			null
	document.evaluate('//*[@id="XSLT_bojanbjelic_xml2json/xsl:stylesheet"]',document).iterateNext()
			null
	document.evaluate('//*[@id="XSLT_bojanbjelic_xml2json"]/xsl:stylesheet/xsl:template[1]/xsl:text[1]',document).iterateNext()
			null
skusim pouzit nsResolver:
	xpe = new XPathEvaluator();
	nsResolver = xpe.createNSResolver($0.ownerDocument);
	document.evaluate('//*[@id="XSLT_bojanbjelic_xml2json"]/stylesheet/template[1]/text[1]',document, nsResolver).iterateNext()
		null
	document.evaluate('//*[@id="XSLT_bojanbjelic_xml2json"]/xsl:stylesheet/xsl:template[1]/xsl:text[1]',document, nsResolver).iterateNext()
		Error: NamespaceError: DOM Exception 14
pouzijem moj vlastny resolver:
	document.evaluate('//*[@id="XSLT_bojanbjelic_xml2json"]/stylesheet/template[1]/text[1]',document, nsResolverFnc).iterateNext()
		null
	document.evaluate('//*[@id="XSLT_bojanbjelic_xml2json"]/xsl:stylesheet/xsl:template[1]/xsl:text[1]',document, nsResolverFnc).iterateNext()
		<xsl:text>{</xsl:text>
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
dtto FIREFOX !!!!!
ale vracia Copy XPath:		/html/xml[6]/xsl:stylesheet/xsl:template/xsl:text
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


	document.evaluate('/a:html/a:xml[6]/xsl:stylesheet/xsl:template/xsl:text',document, nsResolverFnc, XPathResult.ANY_TYPE,null).iterateNext()
	
	
*/
function LocationExpr(expr) {
	this.expression = expr;
}
LocationExpr.prototype.evaluate = function(ctx) {
  var xpe = new XPathEvaluator();
  var nsResolver = xpe.createNSResolver( ctx.node );
  var rtO = null;
  X.doXPathQuery(ctx.node.ownerDocument || ctx.node, 
		{	contextNode 		: ctx.node
		,	namespaceResolver	: nsResolver
		,	resultType			: XPathResult.ANY_TYPE
		,	xpathExpression 	: this.expression
		}
		,0
		, function(obj, index, doc, xquery, count, resultType) {
			switch (resultType) {
				case XPathResult.BOOLEAN_TYPE :
					rtO = new BooleanValue(obj); break;
				case XPathResult.NUMBER_TYPE :
					rtO = new NumberValue(obj); break;
				case XPathResult.STRING_TYPE :
					rtO = new StringValue(obj); break;
				default:
					rtO = rtO || new NodeSetValue([]);
					rtO.value.push(obj);	break;
			}
		}
	);
	rtO = rtO || new NodeSetValue([]);
xpathLogEval('eval ... ' + rtO.toString() );
  return rtO;
};
LocationExpr.prototype.toString = function() {
  return this.expression;
}
LocationExpr.prototype.parseTree = function(indent) {
  return "hidden tree";
}

xpathParse = function(expr) {
/* maybe faster due to prepared thing ... TODO
//	var xpe = new XPathEvaluator();
//	var nsResolver = xpe.createNSResolver( context.node );
//	return {
//		xpathEvaluator	: xpe
//	,	nsResolver 		: nsResolver
//	,	xpathExpression	: xpe.createExpression(expr, nsResolver)
//	,	evaluate		: function( node ) {
//			
//		}
//	}
*/
	return new LocationExpr(expr);
}
xpathEval = function(select, context) {
	var le = new LocationExpr(select);
	return le.evaluate(context);
}
xpathSort = function(input, sort) {
// .... TODO
}

/* ___________________________________________________________________________
 *		native X S L T
 * ___________________________________________________________________________
 */
 
/* W3Schools:

<html>
<head>
<script>
function loadXMLDoc(dname)
{
if (window.ActiveXObject)
  {
  xhttp=new ActiveXObject("Msxml2.XMLHTTP.3.0");
  }
else
  {
  xhttp=new XMLHttpRequest();
  }
xhttp.open("GET",dname,false);
xhttp.send("");
return xhttp.responseXML;
}

function displayResult()
{
xml=loadXMLDoc("cdcatalog.xml");
xsl=loadXMLDoc("cdcatalog.xsl");
// code for IE
if (window.ActiveXObject)
  {
  ex=xml.transformNode(xsl);
  document.getElementById("example").innerHTML=ex;
  }
// code for Mozilla, Firefox, Opera, etc.
else if (document.implementation && document.implementation.createDocument)
  {
  xsltProcessor=new XSLTProcessor();
  xsltProcessor.importStylesheet(xsl);
  resultDocument = xsltProcessor.transformToFragment(xml,document);
  document.getElementById("example").appendChild(resultDocument);
  }
}
</script>
</head>
<body onload="displayResult()">
<div id="example" />
</body>
</html>
*/
 

///<function name="hv_pending_xslt_loader"> 
///<param name="onoff" type="Boolean" > zap/vyp </param>
///				<param name="red" type="Boolean" > signal XHR or AJAX </param>
//# funkcia rozsvecuje / zhasina animated GIF aktivity loader-ov
var is_pending_xslt_loader = false
,	timer_pending_xslt_loader = null
;
function hv_pending_xslt_loader(onoff, red) {
//	window.requestAnimationFrame(function() {
		var el = document.getElementById('pending_xslt_trafo')	//(red ? "pending_xhr_loader" : "pending_ajax_loader")
		,	cs = el && getComputedStyle(el)
		;
		is_pending_xslt_loader = onoff;
		if (onoff) {
			if (el) { el.style.display = ''; }
			if (timer_pending_xslt_loader) {
				clearInterval(timer_pending_xslt_loader);
			}
			timer_pending_xslt_loader = setInterval( function() {
				if (!is_pending_xslt_loader && el) { el.style.display = 'none'; }
			},250)
		}
//	});
}
///</function> 

function xsltProcess(xmlDoc, stylesheet, textORdoc, paramObj) {
	hv_pending_xslt_loader(true,false);
/* nerobi mi dobrotu, pokial je exaktne urcene default namespace 
*/
	if (typeof xmlDoc == 'string') {
//		vardoc = (new DOMParser()).parseFromString(gID('xmlview').value, 'text/xml');
		xmlDoc = xmlParse(xmlDoc);
	}
/*
	//var processor = new XSLTProcessor;
	if((window.ActiveXObject || "ActiveXObject" in window)){
		var xslt = new ActiveXObject("Msxml2.XSLTemplate");
		
//		var xmlDoc = new ActiveXObject("Msxml2.DOMDocument");
//		xmlDoc.loadXML(xmlDoc_txt);
		try {
			xslt.stylesheet = stylesheet;
		} catch(e) {
			var xslDoc = new ActiveXObject("Msxml2.FreeThreadedDOMDocument");
			xslDoc.loadXML((new XMLSerializer()).serializeToString(stylesheet));
			xslt.stylesheet = stylesheet = xslDoc;
		}

		var xslProc = xslt.createProcessor();
		xslProc.input = xmlDoc;
		for (var p in paramObj) {
			xslProc.addParameter(p,paramObj[p]);
		}
		xslProc.transform();	
//		callback.call(null, xslProc.output);
//		return true;
		var outtxt = xslProc.output	// vyprodukuje TEXT !!!
		,	outdoc = new ActiveXObject("Msxml2.DOMDocument")
		;
		outdoc.loadXML(outtxt);
	} else { 
*/
		var processor = new XSLTProcessor();
		processor.importStylesheet(stylesheet);
		for (var p in paramObj) {
			processor.setParameter(null,p,paramObj[p]);
		}
		var outdoc = processor.transformToDocument(xmlDoc)
		;
/*
	}
*/
	var outDocEl = outdoc.documentElement
	,	retval
	;
	if (paramObj && paramObj.stripNamespaces) {
		for (var i=outDocEl.attributes.length-1; i > 0; i--) {
			var an = outDocEl.attributes[i];
			if (an.nodeName.match(/xmlns:\w+/)) {
				outDocEl.removeAttribute(an.nodeName);
			}
		}
	}
	if (textORdoc === true) {	// true ... return TEXTCONTENT
		retval = outdoc.documentElement.textContent;
	} else if (textORdoc) {	// if not (null undefined, "", 0)
		if (textORdoc.ownerDocument) {	// if NODE, append
			//retval =  textORdoc.appendChild(outdoc.documentElement);
			retval = loadDomSet( outdoc.documentElement, textORdoc );
		} else { // otherwise (f.e  textORdoc="doc" )
			retval = outdoc.documentElement; 
		}
	} else {
		var serializer = new XMLSerializer;
		retval = serializer.serializeToString(outdoc);
	}
/* IE
if(window.ActiveXObject) {      
   var xslt = new ActiveXObject("Msxml2.XSLTemplate");
   var xmlDoc = new ActiveXObject("Msxml2.DOMDocument");
   var xslDoc = new ActiveXObject("Msxml2.FreeThreadedDOMDocument");
   xmlDoc.loadXML(xml);
   xslDoc.loadXML(xsl);
   xslt.stylesheet = xslDoc;
   var xslProc = xslt.createProcessor();
   xslProc.input = xmlDoc;
   xslProc.transform();
   callback.call(null, xslProc.output);
   return true;
}
*/
	hv_pending_xslt_loader(false,false);
	return retval;
}

 
	//exports:
	if (typeof glob.jsX == "undefined")	{
		glob.jsX = {};
	}
	
	glob.jsX.nativeX = {
		activate : function( what, obj ) {
			obj = obj || glob.jsX;
			switch(what) {
				case "dom":
					obj.XNode 					= Node;		// native DOM Node
					obj.XDocument 				= Document;	// native DOM Document
					obj.xmlParse 				= xmlParse;
					break;
				case "xpath":
					obj.xpathParse 				= xpathParse;
					obj.xpathEval 				= xpathEval;
					obj.xpathSort 				= xpathSort;
					break;
				case "xslt":
					obj.xsltProcess 			= xsltProcess;
					break;
			}
			return true;
		}
	,	dom: {
			XNode				: Node
		,	XDocument			: Document
				// functions
		,	parse 				: xmlParse				//( xmltxt , pure)
		}
	,	xpath: {
		//	FunctionCallExpr		: no possible extend ... undefined
		//	extension possibility must be checked by if (jsX.xpath.FunctionCallExpr) ...
			reset					: function (){}
		,	parse					: xpathParse		//(expr)
		,	eval					: xpathEval			//(select, context) 
		,	sort					: xpathSort			//(input, sort)
		}
	,	xslt : {
			process					: xsltProcess		//(xmlDoc, stylesheet, doc)
		}
	}
	
		// defaults ... I want be dom main !
	glob.jsX.nativeX.activate("dom");
	glob.jsX.nativeX.activate("xpath");
	glob.jsX.nativeX.activate("xslt");

})(
	(typeof window != "undefined") ? window : ((typeof global != "undefined") ? global : this)
   );



