/*
Komukoľvek, kto získa kópiu tohto softvéru a súvisiacich súborov dokumentácie („Softvér“), 
sa týmto udeľuje bezplatné povolenie obchodovať so Softvérom bez obmedzení, 
ako aj neobmedzené právo na použitie, kopírovanie, úpravu, spojenie, zverejnenie, 
distribuovanie, ďalšie udelenie licencie a/alebo predaj kópií Softvéru a umožnenie osobám, 
ktorým sa Softvér poskytuje, aby tak učinili, a to za nasledovných podmienok:
Hore uvedené oznámenie o autorských právach a toto oznámenie o povolení budú súčasťou 
všetkých kópií alebo zásadných častí Softvéru. 
 
TENTO SOFTVÉR SA POSKYTUJE „TAK, AKO JE“, BEZ AKÝCHKOĽVEK ZÁRUK, VYJADRENÝCH PRIAMO ČI NEPRIAMO, 
VRÁTANE (NIE VŠAK VÝLUČNE) ZÁRUKY PREDAJNOSTI, VHODNOSTI NA KONKRÉTNY ÚČEL A NEPORUŠENIA PRAVIDIEL. 
AUTORI ALEBO DRŽITELIA AUTORSKÝCH PRÁV V NIJAKOM PRÍPADE NEMÔŽU BRAŤ ZODPOVEDNOSŤ 
ZA AKÉKOĽVEK REKLAMÁCIE, ŠKODY ALEBO BYŤ INAK ZODPOVEDNÍ, ČI UŽ PRI UPLATŇOVANÍ ZMLÚV, 
PRI PREČINOCH ALEBO INÝCH ČINOCH VYPLÝVAJÚCICH, SÚVISIACICH I NESÚVISIACICH SO SOFTVÉROM 
ALEBO POUŽITÍM SOFTVÉRU ALEBO OBCHODOVANÍM SO SOFTVÉROM.
*/
	
	
// globalky pre uzivatelsku tvorbu funkcii
	kalkul = {};
	vrstvy = [];
	
	Fproject = {
		fragment_project : null
//	,	ls_forms : ['fragment','vonk_okraj_podmienky','vnut_okraj_podmienky','druh_stavby','popis_zakazky']	//,'vypocet']
	,	ls_forms : ['fragment','vonk_okraj_podmienky','vnut_okraj_podmienky','popis_zakazky']
	,	load : function ( txt ) {
			konzola('Project Loaded: '+ (txt ? 'OK' : 'error !') );
			document.getElementById('project_content').value = txt;
			try {
				this.fragment_project = JSON.parse( txt );
				konzola('Project Decode: OK !');
				this.fillForms();
			} catch(e) {
				konzola('Project Decode: error !');
			}
		}
	,	cleanForms : function () {
			var me = this;
			this.ls_forms.forEach( function(f,i,a) {
				var frm = document.forms[f]
				,	i, fs = frm.getElementsByTagName('fieldset')
				;
				for ( i = 0; i < fs.length; i++ ) {
					var j, els = fs[i].elements || fs[i].querySelectorAll('*[name]')	// for IE
					;
					for (j = 0; j < els.length; j++ ) {
						var el = els[j];
						switch(el.type) {
							case 'select-one': 
								el.selectedIndex = 0;
								break;
							case 'checkbox':
								el.checked = false;
								break;
							case 'radio':
								var radioel = (fs[i].elements && fs[i].elements[el.name]) || frm.elements[el.name]	// for IE
								// osetrenie inaksieho Firefox : 
								if (radioel.length) {
									radioel[0].checked = true;
								} else {
									radioel.checked = true;
								}
								break;
							case 'text':
							case 'number':
							case 'textarea':
								el.value = '';
								break;
							case 'button':
							case 'progress':
							case 'select-multiple':
							default : 
								break;
						}
					}
				}
			});
		}
	,	fillForms : function () {
			advisor.blocked = true;	// nechcem radit pri nacitavani projektu
			var me = this;
			this.cleanForms();
			this.ls_forms.forEach( function(f,i,a) {
				var frm = document.forms[f]
				,	fp_f = me.fragment_project[f]
				,	i, fs = frm.getElementsByTagName('fieldset')
				;
				for ( i = 0; i < fs.length; i++ ) {
					if (typeof fp_f[ fs[i].name ] != 'undefined') {
						var fp_fs = fp_f[ fs[i].name ]
						,	j, els = fs[i].elements || fs[i].querySelectorAll('*[name]')	// for IE
						;
						for (j = 0; j < els.length; j++ ) {
							var el = els[j];
							if ( typeof fp_fs[ el.name ] != 'undefined') {
								switch(el.type) {
									case 'select-one': 
										el.selectedIndex = fp_fs[ el.name ].index;
										if (el.onchange) {
											el.onchange();
										}
										break;
									case 'checkbox':
										el.checked = fp_fs[ el.name ].checked
										break;
									case 'radio':
									case 'text':
									case 'number':
									case 'textarea':
										el.value = fp_fs[ el.name ].value
										break;
									case 'button':
									case 'progress':
									case 'select-multiple':
									default : 
										break;
								}
							}
						}
					}
				}
			});
			vrstvyTab.write( this.fragment_project.vrstvy );
			advisor.blocked = false;	// mozes radit
		}
	,	getForms : function ( proj ) {
			//var me = this;
			//this.fragment_project = {};
			this.ls_forms.forEach( function(f,i,a) {
				var frm = document.forms[f]
				,	fp_f = (/*me.fragment_project*/proj[f] = {})
				,	i, fs = frm.getElementsByTagName('fieldset')
				;
				for ( i = 0; i < fs.length; i++ ) {
					var fp_fs = fp_f[ fs[i].name ] = {}
					,	j, els = fs[i].elements || fs[i].querySelectorAll('*[name]')	// for IE
					;
					for (j = 0; j < els.length; j++ ) {
						var el = els[j];
						switch(el.type) {
							case 'select-one': 
								fp_fs[ el.name ] = {
									type :  el.type
								,	text : el.options[el.selectedIndex]	//selectedOptions[0].text
								,	index : el.selectedIndex
								,	value : el.value
								}								
								break;
							case 'checkbox':
								fp_fs[ el.name ] = {
									type :  el.type
								,	checked : el.checked
								,	value : el.value
								}								
								break;
							case 'radio':
							case 'text':
							case 'number':
							case 'textarea':
								fp_fs[ el.name ] = {
									type :  el.type
								,	value : el.value
								}								
								break;
							case 'button':
							case 'progress':
							case 'select-multiple':
							default : 
								break;
						}
					}
				}
			});
		}
	,	save : function () {
			this.fragment_project = {};
			this.getForms( this.fragment_project );
			var tbl = document.forms.fragment.querySelector('#params_table');
			var p = this.fragment_project;
			p.vrstvy = vrstvyTab.read();
			p.kalkul = {
				vnutorna_teplota : parseFloat( p.vnut_okraj_podmienky[''].nestand_teplota.value )
			,	vnutorna_vlhkost : parseFloat( p.vnut_okraj_podmienky[''].nestand_vlhkost.value )
			,	nadmorska_vyska : parseFloat( p.vonk_okraj_podmienky[''].nadmorska_vyska.value )
			,	vonkajsia_teplota : parseFloat( p.vonk_okraj_podmienky[''].vonk_teplota.value )
			,	vonkajsia_vlhkost : parseFloat( p.vonk_okraj_podmienky[''].vonk_vlhkost.value )
			,	rsi : parseFloat( tbl.querySelector('td.t_rsi').textContent )
			,	rse : parseFloat( tbl.querySelector('td.t_rse').textContent )
			,	uanew : parseFloat( tbl.querySelector('td.t_uanew').textContent )
			,	uaold : parseFloat( tbl.querySelector('td.t_uaold').textContent )
			,	un : parseFloat( tbl.querySelector('td.t_un').textContent )
			,	ur2 : parseFloat( tbl.querySelector('td.t_ur2').textContent )
			,	max_kondenz : parseFloat( 
					db_isover.druh_konstrukcie[document.forms.fragment.elements.druh_konstrukcie.value-1]
					.max_kondenz )	// -1 ... nazov druhu konstrukcie
			,	vnutorna : db_isover.druh_konstrukcie[document.forms.fragment.elements.druh_konstrukcie.value-1]
					.vnutorna						// +1 ... nazov druhu konstrukcie
			};
			p.kalkul.alfaI = 1 / p.kalkul.rsi;
			p.kalkul.alfaE = 1 / p.kalkul.rse;
			
/*global*/	vrstvy = p.vrstvy;
/*global*/	kalkul = p.kalkul
			
			return this.saveJSON();	//return this.saveJSON.stringify(this.fragment_project);
		}
	,	saveJSON : function() {
			return JSON.stringify(this.fragment_project);
		}
	
	,	init_clear : function() {
// fake funkcia na vycistenie priestoru
// (akoby nestacil RELOAD stranky !??)
			//this.cleanForms();
			vrstvyTab.clear();
			this.fragment_project = null;
			kalkul = {};
			vrstvy = [];
	// doplnkove prenastavenie zakladnych stavov prepinacov ? KASLAT NA TO, co ak chce rovnake ?
			
			draw_fragment_vrstvy();	//	redraws_graphs();
			Vypocet();
			Vysledok();
		}
	}

function SetupProjectFile( txt ) {
	var frm = document.forms.vyber_projektu
	,	contentEl = frm.elements.project_content
	;
	if (contentEl) {
		contentEl.value = txt;
	}
	Fproject.load(txt);
	Vypocet( function() {
		 document.getElementById('vysledok').style.display = 'block';
	});
}
	function LoadProjectFile( evt ) {	// automat
		var el = evt.currentTarget
		,	files = el.files
		,	filename = files.length ? files[0].name : ''
		,	form = el.form
		,	filenameEl = form && form.elements.filename
//		,	contentEl = form && form.elements.project_content
		;
		if (filenameEl) {
			filenameEl.value = filename;
		}
		readFileAsText( files, SetupProjectFile );
	}

	
// funkcionalita tabulky materialov:
	vrstvyTab = {
		tbl : null
	,	form : null			
	,	defAssign : [ // f...meno vo formulari, t...selector np...no parse float, ex...no check empty
			{ f: 'ident_material', t: '.ident_mat', np:true }	//, wc: IdentifyMaterial}
		,	{ f: 'fyz_material', t: '.t_nazov', np:true }
		,	{ f: 'objemova_hmotnost', t: '.t_hustota' }
		,	{ f: 'suc_tep_vod_exterier', t: '.t_lambda_ext' }
		,	{ f: 'suc_tep_vod_interier', t: '.t_lambda_int' }
		,	{ f: 'mer_tep_kap', t: '.t_tepkap' }
		,	{ f: 'faktor_dif_odporu', t: '.t_difuz' }
		,	{ f: 'faktor_dif_odporu_leto', t: '.t_difuz_leto', ex: true }
		,	{ f: 'hrubka_materialu', t: '.t_hrubka input[name=edit_hrubka]', v: 'value' }
		,	{ f: 'hrubka_materialu_fix', t: '.t_hrubka_fix', ex: true }
		
		,	{ f: 'ramova_konstrukcia', t: '.t_ramova_konstrukcia', np:true, ex: true }
		,	{ f: 'ident_material_ram', t: '.ident_ram', np:true, ex: true }
		,	{ f: 'fyz_material_ram', t: '.t_ram_nazov', np:true, ex: true }
		,	{ f: 'suc_tep_vod_ram', t: '.t_suc_tep_vod_ram', ex: true }
		,	{ f: 'ram_pomer', t: '.t_ram_pomer input[name=edit_ram_pomer]', v: 'value', ex: true }
		]
	,	init : function() {
			this.tbl = document.querySelector('div#fragment table.vrstvy_table');	//('div#fragment div.material_table table');
			this.form = document.forms.fragment;
			this.tbl_row_content = this.tbl.querySelector('.proforma')
				.innerHTML.replace(/\s?xmlns="http:\/\/www.w3.org\/1999\/xhtml"/gmi,'')
			;
		}
	,	tbl_row_content : ''	// init ... copy from HTML
	,	clear : function() {
			var tbody = this.tbl.querySelector('tbody');
			tbody.innerHTML = ''
+	'<tr onclick="vrstvyTab.select(event);" class="proforma">	'
+	this.tbl_row_content
+	'</tr>	'
;			
			//document.forms.fragment.querySelector('.in_ramova_konstrukcia.ram').style.backgroundColor = '';
			this.ramcer(document.forms.fragment.querySelector('.in_ramova_konstrukcia.ram'));
		}
	,	deselect : function(e) {
			var el = e && ( (e instanceof Event) ? e.currentTarget : e )
			,	srow = this.tbl.querySelector('.selected')
			,	ramcer = this.form.elements.material_controls.querySelector('.ram')
			;
			if (srow != el) {
				srow.removeAttribute('class');

				var t_ramova_konstrukcia = srow.querySelector('.t_ramova_konstrukcia')
				,	ramova_konstrukcia = srow.querySelector('input.edit_ramova_konstrukcia')
				;
				if (t_ramova_konstrukcia.textContent == "1") {	// != '', != 'undefined' ... strictly 1 !!!
					ramova_konstrukcia.checked = true;
				}
				this.ram(ramova_konstrukcia, true);
				
				ramcer.style.backgroundColor = '';
			}
		}
	,	select : function(e) {
			this.deselect(e);
			var el = (e instanceof Event) ? e.currentTarget : e;
			el.className = "selected";
			var ramcer = this.form.elements.material_controls.querySelector('.ram')
			,	bck = ramcer.style.backgroundColor
			,	isOn = (bck == 'chartreuse')
			,	imel = el.querySelector('.ident_mat')
			,	iram = el.querySelector('.ident_ram')
			,	hrub = el.querySelector('.t_hrubka input')
			,	ramova_konstrukcia = el.querySelector('input.edit_ramova_konstrukcia')
			,	form = this.form
			;
// kopia riadkovych udani do formulara
			this.defAssign.forEach( function(v,i,a) {
				var tel = el.querySelector(v.t)
				;
				form.elements[v.f].value = tel[v.v ? v.v : 'textContent'];
			});
// zobrazenie prepinaca materialu izolacia / ram			
			this.form.elements.material_controls.querySelector('.ram').style.display 
				= (ramova_konstrukcia.checked) ? 'initial' : '';
			
// aby sa spravne osadil vlastny material

			form.elements.ident_material.value = (isOn ? iram : imel).textContent;
			IdentifyMaterial();
			form.elements.hrubka_materialu.value = hrub.value;
			form.elements.hrubka_materialu.disabled = isOn;
			if (isOn) { 
				form.elements.vlastny_material.checked = false;
			}
		}
	,	create : function() {
			var tr = document.createElement('tr');
			tr.onclick = function(e){ vrstvyTab.select(); }
			tr.innerHTML = this.tbl_row_content;
			return tr;
		}
	,	add : function(e) {
			var el = e && ( (e instanceof Event) ? e.currentTarget : e )
			,	sel_row = this.tbl.querySelector('tbody tr.selected') 
			,	proforma = this.tbl.querySelector('tbody tr.proforma') 
					|| this.tbl.querySelector('tbody').lastElementChild 
					|| this.create()
			,	form = this.form
			,	vals_ok = true
			,	vlastny_mat = form.elements.vlastny_material.checked
			,	ramcer = el && el.parentNode.querySelector('input.ram')
			,	onlyRam = ramcer && (ramcer.style.backgroundColor == 'chartreuse') || false
			;
			if (vlastny_mat) {
				form.elements['ident_material'].value="-1/-1/-1";
			}
			if (onlyRam) {
				sel_row.querySelector('.t_ram_nazov').textContent = form.elements.fyz_material.value;
				sel_row.querySelector('.ident_ram').textContent = form.elements['ident_material'].value;
				sel_row.querySelector('.t_suc_tep_vod_ram').textContent = form.elements.suc_tep_vod_exterier.value;
			} else {
				var	new_row = proforma.cloneNode(true);
				
				this.defAssign.forEach( function(v,i,a) {
					var iel = new_row.querySelector(v.t)
					,	val = form.elements[v.f].value
			//		,	dis = form.elements[v.f].disabled
					;
					vals_ok &= ((val.trim() != '') || v.ex);	// ex ... mozne vynimky
					iel[v.v ? v.v : 'textContent'] = val;
			//		if ((v.v == 'value') && dis) {
			//			iel.disabled = dis;
			//		}
				});
				new_row.querySelector('td.t_hrubka input').disabled = false;
				if (form.elements.hrubka_materialu_fix.value == 1) {
					new_row.querySelector('td.t_hrubka input').disabled = true;
				}
				new_row.className = "selected";
				if (vals_ok) {
					this.deselect();
					proforma.parentNode.insertBefore(
						new_row
					,	sel_row && sel_row.nextElementSibling
					);
					dragNdrop.switchRegime('_move');
				} else {
	konzola('Pridaj vrstvu :\n   Chýbajúce parametre !');				
				}
			}
			draw_fragment_vrstvy();
		}
	,	delete : function(e) {
			var me = this
			,	tr = e.currentTarget.parentNode.parentNode
			;
			setTimeout( function() {	// aby sa stihol oznacit riadok !
				var naozaj = confirm("Naozaj odstrániť položku ?\n (Niet cesty späť)");
				if (!naozaj) {
					return;
				}
				var sel = tr.className == 'selected'
				,	nEl = tr.nextElementSibling
				,	pEl = tr.previousElementSibling
				;
				tr.parentNode.removeChild(tr);
				if (sel) {
					if (nEl) {
						nEl.className = 'selected';
					} else if (pEl && (pEl.className !='proforma')) {
						pEl.className = 'selected';
					}
				}
//				e.stopPropagation();	// aby nesiel do oznacenia riadku !
				draw_fragment_vrstvy();
			}, 10);
		}
	,	move_up : function(e) {
			var tr = e.currentTarget.parentNode.parentNode
			,	pEl = tr.previousElementSibling
			;
			if (pEl.className != 'proforma') {	
				tr.parentNode.insertBefore( tr, pEl );
			}
			e.stopPropagation();	// aby nesiel do oznacenia riadku !
			draw_fragment_vrstvy();
		}
	,	move_down : function(e) {
			var tr = e.currentTarget.parentNode.parentNode
			,	nEl = tr.nextElementSibling
			;
			if (nEl) {	
				tr.parentNode.insertBefore( tr, nEl.nextElementSibling );
			}
			e.stopPropagation();	// aby nesiel do oznacenia riadku !
			draw_fragment_vrstvy();
		}
	,	chrubka : function() {
			// zmena hrubky - treba prepocet !
			draw_fragment_vrstvy();
		}
	,	read : function() {
			var arr = [], r, rows = this.tbl.querySelectorAll('tbody>tr');
			for (var r = 1; r < rows.length; r++) {
				var obj = {}; 
				this.defAssign.forEach( function(v,i,a) {
					var el = rows[r].querySelector(v.t);
					if (v.np) {
						obj[v.f] = el[v.v ? v.v : 'textContent'];
					} else {
						obj[v.f] = parseFloat( el[v.v ? v.v : 'textContent'] );
					}
				});
				arr.push(obj);
			}
			return arr;
		}
	,	write : function( arr ) {
			arr = arr || this.fragment_project.vrstvy;
			this.clear();
			var form = this.form;
			try {
				for (var r = 0; r < arr.length; r++) {
					this.defAssign.forEach( function(v,i,a) {
						form.elements[v.f].value = arr[r][v.f];
						if (typeof v.wc == 'function') {
							v.wc( form.elements[v.f] );
						}
					});
	form.elements.vlastny_material.checked = (form.elements.ident_material.value.indexOf('-') >= 0);
					this.add();
					IdentifyMaterial();
				}
			} catch(e) {
konzola("Chyba vrstiev fragmentu !");
			}
			draw_fragment_vrstvy();
		}

	,	ramcer : function(e) {
//console.log('ramcer');
			var el = (e instanceof Event) ? e.currentTarget : e
			,	form = this.form
			,	bck = el.style.backgroundColor
			,	toOn = (bck != 'chartreuse')
			,	tr = vrstvyTab.tbl.querySelector('tr.selected')
			;
			if (! tr) {
				toOn = false;
				el.style.backgroundColor = '';
				el.style.display = '';
				form.elements.hrubka_materialu.disabled = false;
				return;
			}
			var	hrub = tr.querySelector('.t_hrubka input')
			,	imel = tr.querySelector('.ident_mat')
			,	iram = tr.querySelector('.ident_ram')
			;
		//	form.elements.ident_material.value = (toOn ? iram : imel).textContent;
			if (!toOn) {
				form.elements.ident_material.value = imel.textContent;
			} else if (iram.textContent.match(/\d+\/\d+\/\d+/)) {	// stlacenie Ramcer-a po AZ po zvoleni materialu 
							// t.j. osadeni ident_material by sa v tomto okamihu bez kontroly
							// na pripadne uz zadany material ramu VYmazalo !
				form.elements.ident_material.value = iram.textContent;
			}
			IdentifyMaterial();
			form.elements.hrubka_materialu.value = hrub.value;
			form.elements.hrubka_materialu.disabled = toOn;
			if (toOn) { 
				form.elements.vlastny_material.checked = false;
			}
//			form.elements.vlastny_material.disabled = toOn;
			el.style.backgroundColor = toOn ? 'chartreuse' : '';
		}
	,	ram : function(e, force) {
			var el = (e instanceof Event) ? e.target : e
			,	typ = el.type
			,	tr = nearestParent(el,'tr')
			,	rams = tr.querySelectorAll('.ram')
			,	ram_nazov = tr.querySelector('.t_ram_nazov')
			,	suc_tep_vod_ram = tr.querySelector('.t_suc_tep_vod_ram')
			,	ram_podiel = tr.querySelector('input[name=edit_ram_pomer]')
			,	iram = tr.querySelector('.ident_ram')
			,	t_ramova_konstrukcia = tr.querySelector('.t_ramova_konstrukcia')
			;
			switch(typ) {
				case 'checkbox':	// jediny === tr.querySelector('input.edit_ramova_konstrukcia')
					var checked = el.checked;
					if (checked) {
						t_ramova_konstrukcia.textContent = '1';
						for (var i=0; i<rams.length; i++) {
							rams[i].style.display = 'block';
						}
						blinker(ram_podiel);
		advisor.kuk('ramova_konstrukcia');
					} else {	// vypnutim ramovej konstrukcie vrstvy prestavim do default stavu
						var naozaj = force || (ram_podiel.value==0) || confirm("Naozaj zrušiť rámovú konštrukciu vrstvy ?\n (vymaže sa info o materiáli rámu)");
						if (naozaj) {
							t_ramova_konstrukcia.textContent = '';
							ram_podiel.value = 0;
							ram_nazov.textContent = '';
							iram.textContent = '';
							suc_tep_vod_ram.textContent = '';
							for (var i=0; i<rams.length; i++) {
								rams[i].style.display = ''	// 'initial' / default CSS none
							}
						} else {
							el.checked = true;
// zobrazenie prepinaca materialu izolacia / ram	(nahrada zrusenia v this.select)		
							this.form.elements.material_controls.querySelector('.ram').style.display 
								= 'initial';
						}
					}
					break;
				default:
					var value = parseFloat(el.value);
					break;
			}
			draw_fragment_vrstvy();
		}
	}

	


// drag drop
	dragNdrop = {
		regime : '_use'
	,	registered_classes : ['tema','blok','prikaz']
	,	settings : {
			_use: {
				drag: null
			,	drop: null
			}
		,	_move: {
				drag: 'tbody tr'
//			,	dragSelectDrop : function( regime, el) {
//					return	(regime == '_add') 
//						?	"#edit_formular"
//						:	el.tagName.toLowerCase() +"."+el.className
//					;
//				}
			,	drop: 'tbody tr'
			,	dropClbk : 'moveItem'
			}
		,	_edit: {
				drag: null
			,	drop: null
			}
		,	_delete: {
				drag: null
			,	drop: null
			}
		,	_add: {
				drag: null
			,	drop: null
			}
		}
	,	holder : null
	,	outlined_element : null
	,	outlined : function( el ) {
			if (this.outlined_element) {
				this.outlined_element.style.outline = null; 
			}
			if (el) {
				this.outlined_element = el;
				this.outlined_element.style.outline = "1px solid red"; 
			}
		}
	,	konzola : function() {
consolo.log(txt);
		}
	,	initialize: function( holder, konzola ) {
			this.holder = holder;
			if (konzola) {
				this.konzola = konzola;
			}
		}
	,	moveItem: function( ev, mel, tel, par ) {
			if (mel) {
				var el = mel.previousElementSibling
				,	smer = 1
				;
				while(el) {
					if (tel == el) {
						smer = -1;
						break;
					} 
					el = el.previousElementSibling;
				}
				if (smer < 0) {
					par.insertBefore(mel, tel);
				} else {
					par.insertBefore(mel, tel.nextElementSibling);
				}
vrstvyTab.select(mel);				
			draw_fragment_vrstvy();
			}
		}	
	,	switchRegime : function(e) {
			this.unselectDropZone();
			this.unselectDragZone();
	//		this.contextMenu();
			this.regime = (e instanceof Event) ? e.currentTarget.value : e;
			this.konzola('regime : '+this.regime);
			this.selectDragZone();
	//		this.togglePopups();
			this.outlined();
			switch(this.regime) {
				case '_use' : 
					break;
				case '_move' : 
		//			this.selectDragZone(move_selector)('li.tema,li.blok,li.prikaz');
					break;
				case '_edit' : 
	//				this.contextMenu( this.editValue );
					break;
				case '_delete' : 
	//				this.contextMenu( this.deleteItem );
					break;
				case '_add' : 
	//				this.edit_form.parentNode.style.display = 'block';
					break;
			}
		}

	,	checkHierarchy: function() {
		}
		
	,	selectDragZone: function( selector ) {
			selector = selector || this.settings[this.regime].drag;
			var liblo = this.holder.querySelectorAll(selector)	//('li.tema,li.blok')
			,	i, len = selector && liblo && liblo.length
			;
			for (i=0; i<len; i++) {
				liblo[i].draggable = true;
				liblo[i].ondragstart = this.dragstart_handler;
				liblo[i].ondragend = this.dragend_handler;
			}		
		}
	,	unselectDragZone: function( selector ) { // bud konkretne, alebo vsetko draggable
			selector = selector || '*[draggable]'; 
			var liblo = this.holder.querySelectorAll(selector)
			,	i
			;
			for (i=0; i<liblo.length; i++) {
				liblo[i].draggable = false;
				liblo[i].ondragstart = null;
				liblo[i].ondragend = null;
			}
		}
	,	selectDropZone: function( selector, el ) {
			selector = selector || this.settings[this.regime].drop;
			var liblo = this.holder.querySelectorAll(selector)
			,	i, len = selector && liblo && liblo.length
			;
	this.konzola(selector+' '+liblo.length);
			for (i=0; i<len; i++) {
				if (el !== liblo[i]) {
					liblo[i].ondrop = this.drop_handler;
					liblo[i].ondragover = this.dragover_handler;
					liblo[i].ondragleave = this.dragleave_handler;
					liblo[i].setAttribute('droppable', true);
				} else {
	this.konzola('skipped called element');
				}
			}
		}
	,	unselectDropZone: function(selector) {
			selector = selector || '*[droppable]'; 
			var liblo = this.holder.querySelectorAll(selector)
			,	i
			;
			for (i=0; i<liblo.length; i++) {
				liblo[i].ondrop = null;
				liblo[i].ondragover = null;
				liblo[i].ondragleave = null;
			}
		}
	// pomocka : http://mdn.github.io/drag-and-drop/copy-move-DataTransfer.html
	,	dragstart_handler: function (ev) {
			ev.stopPropagation();
			var el = ev.currentTarget
	// rozhodujeme podla rezimu:
			,	selFn = dragNdrop.settings[dragNdrop.regime].dragSelectDrop
			,	selector = selFn ? selFn( dragNdrop.regime, el) 
					: dragNdrop.settings[dragNdrop.regime].drop 
			;			
			dragNdrop.konzola("dragStart: "+selector);
			ev.dataTransfer.setData("text", cssPath(el));
			// Tell the browser both copy and move are possible
			ev.effectAllowed = "move";	//"copyMove";
			dragNdrop.selectDropZone( selector, el);
		}
	,	dragover_handler: function (ev) {
			// dragNdrop.konzola("dragOver");
			dragNdrop.outlined(ev.currentTarget);
			ev.preventDefault();
		}
	,	dragleave_handler: function (ev) {
			// dragNdrop.konzola("dragLeave");
			dragNdrop.outlined();
			ev.preventDefault();
		}
	,	drop_handler: function (ev) {
			ev.preventDefault();
			dragNdrop.outlined();
			// Get the cssPath of drag source element (that was added to the drag data
			// payload by the dragstart event handler)
			var cssp = ev.dataTransfer.getData("text");
			dragNdrop.konzola("Drop: "+cssp);
			var mel = document.querySelector( cssp )
			,	tel = ev.currentTarget
			,	par = tel.parentNode
			;		
			var clbk = dragNdrop.settings[dragNdrop.regime].dropClbk;
			if (clbk) {
				dragNdrop[clbk]( ev, mel, tel, par );
			}
			ev.dataTransfer.clearData();
			dragNdrop.unselectDropZone();
			dragNdrop.checkHierarchy();
		}
	,	dragend_handler: function (ev) {
			//  dragNdrop.konzola("dragEnd");
			dragNdrop.outlined();
			// Remove all of the drag data
			ev.dataTransfer.clearData();
			dragNdrop.unselectDropZone();
		}
	}	
	
	
__init = function() {
	var tI = setInterval( function() {
		if (typeof fragments_db == 'undefined') { 
// alert('fragments_db');		
			return; 
		}
		clearInterval(tI);
// alert('fragments_db OK');		
	switch_professional( 1/*0*/, true );		// firefox po reloade ponecha checked - PREPNI !

board_V = JXG.JSXGraph.initBoard('jxgbox_vrstvy',{boundingbox:[-10,100,100,-10], axis:false });
board_T = JXG.JSXGraph.initBoard('jxgbox_tepl',{boundingbox:[-10,100,100,-10], axis:true });
board_P = JXG.JSXGraph.initBoard('jxgbox_tlak',{boundingbox:[-10,100,100,-10], axis:true });
board_Te = JXG.JSXGraph.initBoard('jxgbox_tepl_ekvi',{boundingbox:[-10,100,100,-10], axis:true });
board_Pe = JXG.JSXGraph.initBoard('jxgbox_tlak_ekvi',{boundingbox:[-10,100,100,-10], axis:true });
board_SP = JXG.JSXGraph.initBoard('jxgbox_tlaky',{boundingbox:[-10,100,100,-10], axis:true });
board_ME = JXG.JSXGraph.initBoard('jxgbox_mesiace',{boundingbox:[-10,100,100,-10], axis:true });
  }, 100)};
  
  
window.onload = function() {

	__init();

	$('#constructions').find('svg').svgPanZoom( {
		maxZoom : 100
	} )  
	
// ocackanie prostredia podla protokolu http:// resp. file://	
	var nho = document.querySelectorAll('.non_http_only')
	,	ho = document.querySelectorAll('.http_only')
	,	i
	;
	for(i=0;i<nho.length;i++) {
		nho[i].style.display = (is_http ? 'none' : '');
	}
	for(i=0;i< ho.length;i++) {
		 ho[i].style.display = (is_http ? '' : 'none');
	}
	
// volba nestandartnych podmienok
		var nptv = document.querySelectorAll('#table_nestandartne_podm td.vyber')
		,	i
		;
		for (i = 0; i < nptv.length; i++) {
			nptv[i].addEventListener('click', set_NestandartnePodmienky);
		}
		
// nacitanie databaz:
	//	load_sw_DB( null, function() { 
		load_fragments_DB( null, function() { 
			PopulateParamTables();

			PopulateDruhKonstrukcie();  			
			PopulateRozdielyTeplot();  
			
			PopulateHlavnaSkupina();  
			PopulatePodskupina();  
			PopulateObjemovaHmotnost();
			PopulateMaterial();
			
			PopulateKraj();
//			PopulateMesto();
//			PopulateVonkTeplota();			
//			PopulateParametreKonstrukcie();
		} )	
// inicializacia vrstvyTab tabulky
		vrstvyTab.init();

// osad pozicie klikerov do 3D obrazku
/*
		var holder3D = document.getElementById('schema_domu_3D')
		,	cDiv, dr_ko
		;
		for(var i=0; i<db_isover.druh_konstrukcie.length; i++) {
			dr_ko = db_isover.druh_konstrukcie[i];
			cDiv = holder3D.appendChild(holder3D.ownerDocument.createElement('div'));
			cDiv.style = dr_ko.style3D;
			cDiv.className = 'kliker';
			cDiv.dataset.konstrukcia = dr_ko.id;
			cDiv.innerHTML = escapeLTGT(dr_ko.popis);
		}
*/			
// aktivuj dragNdrop-er
	dragNdrop.initialize(
		document.querySelector('div#fragment table.vrstvy_table')	//('#fragment .material_table table')
	,	konzola
	);
	
	if (is_http) {
		load_constructions();
	}
	
// aktivuj uzivatelske nastavenia : 
	if ( (typeof defaultUser != 'undefined') && defaultUser ) {
		set_user(true, defaultUser);
	}	
	if ( (typeof defaultSkill != 'undefined') && defaultSkill ) {
		switch_laikExpert(defaultSkill.toLowerCase() == 'expert' ? 1:0);
	}	
	if ( (typeof defaultHandling != 'undefined') && defaultHandling ) {
		switch_professional(defaultHandling.toLowerCase() == 'professional' ? 1:0);
	}	
	if ( (typeof defaultTheme != 'undefined') && defaultTheme ) {
		switch_theme(defaultTheme.toLowerCase() == 'windows' ? 1:0);
	}	
	
	advisor.kuk('uvodna_hlaska');
	
	
	CLOUDhandler.contact(true);
// teoreticky by sa dal priamo natiahnut projekt: (z CLOUD-u pomocou passport-u)	
	var loc = locationSearchToObject();
	if (loc && (loc.activity == 'load')) {
console.log('load: ',loc.id, loc.pass);		
		CLOUDhandler.extern_load(loc);
	}
	
};
	
/* vyroba selektora SVG konstrukcii
	
	FreeCommander  ... find files *.SVG  ... export do
		C:\xampp\htdocs\TUZV\fragment5\CAD\fc_findfiles.txt
	
	Notepad++ ... open, prekonvertovat do UTF-8 bez BOM
		replace "\"  "\\"  All


CREATE TABLE `isover`.`cad_svg_files` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `svg_filename` TINYTEXT NULL,
  `svg_directory` TINYTEXT NULL,
  PRIMARY KEY (`id`))
ENGINE = MyISAM
DEFAULT CHARACTER SET = utf8
COLLATE = utf8_bin;

TRUNCATE `isover`.`cad_svg_files`;

LOAD DATA LOCAL INFILE 
'C:\\xampp\\htdocs\\TUZV\\fragment5\\CAD\\fc_findfiles.txt' 
INTO TABLE `isover`.`cad_svg_files`
FIELDS TERMINATED BY "\t"
(@fi, @pa)
SET svg_filename = TRIM(@fi),
    svg_directory = TRIM(@pa)
;	

SELECT @@group_concat_max_len INTO @orig_group_concat_max_len;
SET @@group_concat_max_len = 64000;

SELECT concat('<optgroup label="'
	,replace(replace(svg_directory,"C:\\xampp\\htdocs\\","/"),"\\","/")
	,'">'
	,"<option>"
	,group_concat(svg_filename SEPARATOR "</option>\n<option>")
	,"</option></optgroup>"
) FROM isover.cad_svg_files group by svg_directory;


SET @@group_concat_max_len = @orig_group_concat_max_len;
	

*/


printPDF = function() {
	var wnd = window.open("ISOVER Fragment PDF", "ISOVER Fragment PDF");	//, "scrollbars=1,resizable=1,width=1000,height=580,left=0, top=0");
//	var wnd = window.open("ISOVER Fragment", "", 'fullscreen=yes');
	wnd.document.title="ISOVER Fragment PDF"
	var html = ''
+	'<!DOCTYPE html>\n'
+	'<html xmlns="http://www.w3.org/1999/xhtml" xmlns:svg="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:kres="http://www.sbmintegral.sk/docdefs/kres" xml:lang="sk">\n'
+	'<head>\n'
+	'    <meta http-equiv="Pragma" content="no-cache" />\n'
+	'    <meta http-equiv="Expires" content="-1" />\n'
+	'    <meta http-equiv="Content-type" content="text/html; charset=utf-8"/>\n'
+	'    <title>ISOVER fragment PDF</title>\n'
+	'	<script type="text/javascript" src="../js/jquery.js"></script>\n'
+	'	<script src="../js/jquery.columnizer.js" type="text/javascript" charset="utf-8"></script>\n'
+	'	<link rel="stylesheet" type="text/css" href="../css/columnizer.css"/>\n'
//+	'	<script type="text/javascript" src="../js/dragndrop.js"></script>\n'
+	'	<script src="../js/fragment_print.js"></script>\n'
+	'<style type="text/css">\n'
+	'body {'
+	'	max-width: 595px;'
+	'}'
+	'	</style>\n'
// +	document.querySelector('div#main_report>style').outerHTML
+	'</head>\n'
+	'<body>\n'
+	document.querySelector('div#main_report').outerHTML
+	'\n</body>\n'
+	'	<script type="text/javascript">setTimeout(toPrint,300);</script>\n'
+	'</html>\n'
;
	wnd.document.write(html);
	wnd.document.close(); //missing code

    wnd.focus();
}


// TODO : pouvazovat nad presunom NEXT BACK tlacitkovych funkcionalit
//	z XHTML onclick-ov sem do javascript source code file
// t.j.  input name="new_project" onclick="new_project(this);"
// ... 
function new_project(el) {	// pomocka pre vycistenie priestoru pre vyber vzorovej konstrukcie
	/*window.location.reload();*/ 
	Fproject.init_clear(); 
	cleanMesiace(); 
	if (el) {
		blinker(el.nextElementSibling); 
		el.form.elements.filename.value='';    	
	}
/*		document.forms.postupnost.elements.krok_1_did.checked = false; 
	document.forms.postupnost.elements.krok_1.classList.remove('vykonane');	*/ 
	document.forms.postupnost.elements.krok_2_did.checked = false; 
	document.forms.postupnost.elements.krok_2.classList.remove('vykonane'); 
	document.forms.postupnost.elements.krok_3_did.checked = false; 
	document.forms.postupnost.elements.krok_3.classList.remove('vykonane'); 
	document.forms.postupnost.elements.krok_4_did.checked = false; 
	document.forms.postupnost.elements.krok_4.classList.remove('vykonane'); 
	document.forms.postupnost.elements.krok_5_did.checked = false; 
	document.forms.postupnost.elements.krok_5.classList.remove('vykonane'); 
	document.forms.postupnost.elements.krok_9_did.checked = false; 
	document.forms.postupnost.elements.krok_9.classList.remove('vykonane'); 
	document.forms.postupnost.elements.krok_7_did.checked = false; 
	document.forms.postupnost.elements.krok_7.classList.remove('vykonane'); 
	document.forms.postupnost.elements.krok_8_did.checked = false; 
	document.forms.postupnost.elements.krok_8.classList.remove('vykonane'); 
}

