//byThreejs.js

//	GEOMETRY
//	----------------------------------------------
//	http://localhost/GITHUB/threeJS_v85/editor/js/Sidebar.Geometry.BoxGeometry.js
//	----------------------------------------------		

objekt = editor.selected;

//	editor.scene.children[...]

editor.execute( new SetGeometryCommand( objekt, new THREE[ objekt.geometry.type ](
			4,		//	width.getValue(),
			3,		//	height.getValue(),
			0.2,	//	depth.getValue(),
			0,		//	widthSegments.getValue(),
			0,		//	heightSegments.getValue(),
			0		//	depthSegments.getValue()
		) ) );

//	----------------------------------------------
//	http://localhost/GITHUB/threeJS_v85/editor/js/Sidebar.Object.js
//	----------------------------------------------		
//var newPosition = new THREE.Vector3( 
editor.execute( new SetPositionCommand( objekt, new THREE.Vector3(
			10,		//	objectPositionX.getValue(), 
			10,		//	objectPositionY.getValue(), 
			10,		//	objectPositionZ.getValue() 
		) ) );
//		);
//if ( objekt.position.distanceTo( newPosition ) >= 0.01 ) {
//	editor.execute( new SetPositionCommand( objekt, newPosition ) );
//}

//			var newRotation = new THREE.Euler( objectRotationX.getValue() * THREE.Math.DEG2RAD, objectRotationY.getValue() * THREE.Math.DEG2RAD, objectRotationZ.getValue() * THREE.Math.DEG2RAD );
//			if ( object.rotation.toVector3().distanceTo( newRotation.toVector3() ) >= 0.01 ) {
//				editor.execute( new SetRotationCommand( object, newRotation ) );
//			}
editor.execute( new SetRotationCommand( objekt, new THREE.Euler( 
			30*THREE.Math.DEG2RAD,		//	objectRotationX.getValue() * THREE.Math.DEG2RAD, 
			30*THREE.Math.DEG2RAD,		//	objectRotationY.getValue() * THREE.Math.DEG2RAD, 
			30*THREE.Math.DEG2RAD,		//	objectRotationZ.getValue() * THREE.Math.DEG2RAD 
		) ) );

//	----------------------------------------------
//	http://localhost/GITHUB/threeJS_v85/editor/js/Sidebar.Material.js		
//	----------------------------------------------
//				material = new THREE[ materialClass.getValue() ]();	//	"LineBasicMaterial"
//				editor.execute( new SetMaterialCommand( currentObject, material ), 'New Material: ' + materialClass.getValue() );
//				editor.execute( new SetMaterialColorCommand( currentObject, 'color', materialColor.getHexValue() ) );
editor.execute( new SetMaterialCommand( objekt, new THREE["LineBasicMaterial"](), 'New Material: '+"LineBasicMaterial" ) );
editor.execute( new SetMaterialColorCommand( objekt, 'color', /*materialColor.getHexValue()*/parseInt( '#0000FF'.substr( 1 ), 16 ) ) );	
editor.execute( new SetMaterialValueCommand( objekt, 'transparent', /*materialTransparent.getValue()*/true ) );	
editor.execute( new SetMaterialValueCommand( objekt, 'opacity', /*materialOpacity.getValue()*/0.5 ) );

// C:\xampp\htdocs\TUZV\CLOUD\three-js-csg-picking.zip\js\lpjpwj.js		... pekny grid aj s textami na osiach
//	zaroven slusna interakcia


function exBlock( shape ) {
	if (! shape) {
		var length = 4, width = 4;

		/*var*/ shape = new THREE.Shape();
		shape.moveTo( 0,0 );
		shape.lineTo( 0, width );
		shape.lineTo( length, width );
		shape.lineTo( length, 0 );
		shape.lineTo( 0, 0 );
	}

	var extrudeSettings = {
		steps: 2,
		amount: 32,
		bevelEnabled: false,	// true
		bevelThickness: 1,
		bevelSize: 1,
		bevelSegments: 1
	};

	var geometry = new THREE.ExtrudeGeometry( shape, extrudeSettings );
	var material = new THREE.MeshBasicMaterial( { color: 0x00ff00 } );
	var mesh = new THREE.Mesh( geometry, material ) ;
	
	return mesh;
}
//	app3D.scene.add( exBlock()/*mesh*/ );

function exHole( noex ) {
	var FAR = 10;	//10000

	var points = []
	points.push( new THREE.Vector2( +FAR,+FAR ))
	points.push( new THREE.Vector2( +FAR,-FAR ))
	points.push( new THREE.Vector2( -FAR,-FAR ))
	points.push( new THREE.Vector2( -FAR,+FAR ))
	points.push( new THREE.Vector2( +FAR,+FAR ))
	var shape = new THREE.Shape( points )
	points = []
	var ts0 = 0// (lastLoadEx-lastLoadx)(tileDistMax+0)
	var ts1 = 0// (lastLoadz-lastLoadEz)(tileDistMax+1)
	ts0=3;	//744.31 //.3099999999//.3162744867122
	ts1=4;	//992.4 //.4078465743082//.4078465743082
	points.push( new THREE.Vector2( -ts0,+ts0 ))
	points.push( new THREE.Vector2( -ts0,-ts1 ))
	points.push( new THREE.Vector2( +ts1,-ts1 ))
	points.push( new THREE.Vector2( +ts1,+ts0 ))
	points.push( new THREE.Vector2( -ts0,+ts0 ))
	shape.holes.push(new THREE.Shape( points ))
	
	if (noex) {
		var geometry = new THREE.ShapeGeometry(shape)
		var mate = new THREE.MeshLambertMaterial( {color: 0x00ff00, side: THREE.DoubleSide} )
		var lowBox = new THREE.Mesh(geometry,mate)
		return lowBox;
	} else {
		return exBlock(shape);
	}
	
}
//	app3D.scene.add(exHole());

