/*
Komukoľvek, kto získa kópiu tohto softvéru a súvisiacich súborov dokumentácie („Softvér“), 
sa týmto udeľuje bezplatné povolenie obchodovať so Softvérom bez obmedzení, 
ako aj neobmedzené právo na použitie, kopírovanie, úpravu, spojenie, zverejnenie, 
distribuovanie, ďalšie udelenie licencie a/alebo predaj kópií Softvéru a umožnenie osobám, 
ktorým sa Softvér poskytuje, aby tak učinili, a to za nasledovných podmienok:
Hore uvedené oznámenie o autorských právach a toto oznámenie o povolení budú súčasťou 
všetkých kópií alebo zásadných častí Softvéru. 
 
TENTO SOFTVÉR SA POSKYTUJE „TAK, AKO JE“, BEZ AKÝCHKOĽVEK ZÁRUK, VYJADRENÝCH PRIAMO ČI NEPRIAMO, 
VRÁTANE (NIE VŠAK VÝLUČNE) ZÁRUKY PREDAJNOSTI, VHODNOSTI NA KONKRÉTNY ÚČEL A NEPORUŠENIA PRAVIDIEL. 
AUTORI ALEBO DRŽITELIA AUTORSKÝCH PRÁV V NIJAKOM PRÍPADE NEMÔŽU BRAŤ ZODPOVEDNOSŤ 
ZA AKÉKOĽVEK REKLAMÁCIE, ŠKODY ALEBO BYŤ INAK ZODPOVEDNÍ, ČI UŽ PRI UPLATŇOVANÍ ZMLÚV, 
PRI PREČINOCH ALEBO INÝCH ČINOCH VYPLÝVAJÚCICH, SÚVISIACICH I NESÚVISIACICH SO SOFTVÉROM 
ALEBO POUŽITÍM SOFTVÉRU ALEBO OBCHODOVANÍM SO SOFTVÉROM.
*/

//<script type="text/javascript"><![CDATA[

	load_constructions = function ( url ) {
		function callback( xmlDoc ) {
			var xml = document.documentElement.appendChild( document.createElement('xml') );
			xml.setAttribute('style','display:none');
			xml.appendChild( xmlDoc.documentElement );
			document.getElementById("construction_loader_div").style.display = "none";
		} 
	
		url = url || '../CAD/constructions_min.xml';
		if (is_http) {
	konzola("loading: "+url);		
//			$.get('/TUZV/fragment5/CAD/Masívna konštrukcia/1. Stena suterénu, strop pivnice/MC-CS-02-03-01, nevykurovaná pivnica 1-Model.svg', undefined, function(r){ssss = r;})	
			$.get(url
				, undefined
				, callback
			);	
		} else {
			var el = url && url.currentTarget
			,	files = el && el.files
			;
			if (files) {
				readFileAsText( files
				,	function( xmltxt ) {
						callback ( (new DOMParser).parseFromString(xmltxt, "application/xml") );
					} 
				);
			}
/*
$.ajax({
       url: '../CAD/constructions_min.xml',
       type: "GET",
       dataType: "xml",
       success: function (r) {
            			debugger;
alert(r);
           }
       });
jquery-2.0.3.js:7845 XMLHttpRequest cannot load file:///C:/xampp/htdocs/TUZV/fragment5/CAD/constructions_min.xml. Cross origin requests are only supported for protocol schemes: http, data, chrome, chrome-extension, https, chrome-extension-resource.send @ jquery-2.0.3.js:7845ajax @ jquery-2.0.3.js:7301(anonymous function) @ VM294:1
Object {readyState: 4, responseXML: undefined, status: 404, statusText: "error"}
*/			
		}
	}
	
// TODO ... presun do fragment_forms.js
fragment_druh_konstrukcie_callback = function(val) {
	var frm = document.forms.fragment;
	frm.elements.druh_konstrukcie.value = val;
// tu zavadzia buildup-om	advisor.kuk(advisor.zmena_druhu_konstrukcie, 610);
	PopulateParametreKonstrukcie();
	document.getElementById('fragment_z_konstrukcii').style.display='block';
}

druh_konstrukcie_callback = fragment_druh_konstrukcie_callback;

select_druh_konstrukcie = function( val ) {
	document.getElementById('schema_domu_3D').style.display='';	//null;
	load_buildups(val);
	if (typeof druh_konstrukcie_callback == 'function') {
		druh_konstrukcie_callback( val );
	}
}

/*
	Rozsvietenie obrazkov vhodnych konstrukcii podla vyberu druhu konstrukcie 
	je normalne podmienene pristupom na web (aby sa mohli zobrazovat obrazky
	aj ked teoreticky obrazok samotny nemusi byt potrebny ... )
Postup : 
	mame XML subor, obsiahnuty v 
		../CAD/constructions_min.xml
	mame vycuc z tabulky priradujuci buldup-y (skladby) ku druhu konstrukcie
		-- SELECT id,buildup,construction_summary_FS,asignment3D FROM zberdat_isover.construction_buidups;
		set @druh_konstr = x;
		SELECT id,buildup,construction_summary_FS,asignment3D FROM zberdat_isover.construction_buidups
			where find_in_set( @druh_konstr, asignment3D ) > 0
		;
	mame vycuc z tabulky priradujuci materialy buldup-ov (skladieb) konkretnym nasim materialom (DruhMaterialu)
		SELECT id,product_description,density,druhmaterialu FROM zberdat_isover.construction_products_unigue;
		
	Primarnou otazkou je royhodnutie o WWW pristupe.
		Pokial tieto aktivity budu striktne podmienene internet pristupom, moze t vsetko vykonat PHP
	,	pokial chceme aj lokalne bez obrazkov, MUSI to vykonat javasript, ktory vsak narazi na 
		problem s LOAD xml suboru z lokalneho priestoru !!!
*/		
actual_id_druh_konstrukcie = 0;

fragment_load_buildups_callback = function(id_druh_konstrukcie){} // nic

load_buildups_callback = fragment_load_buildups_callback;

	load_buildups = function ( id_druh_konstrukcie ) {
/*	unverzalna rutina pre nacitanie buildup-ov podla druhu konstrukcie
-- --------------------------------------------------------------------------------
-- Routine DDL
-- Note: comments before and after the routine body will not be stored by the server
-- --------------------------------------------------------------------------------
DELIMITER $$

CREATE DEFINER=`root`@`%` PROCEDURE `buildups_podla_konstrukcie`(id_druh_konstrukcie varchar(32), frm varchar(32))
BEGIN
set @gcml = @@group_concat_max_len;
set @@group_concat_max_len = 1000000;
--
-- frm :  'json' ... javascriptove pole
-- 		  'xml' ... najobsaznejsi vypis priamo pre XSLT transformaciu pomocou CAD/constructions_DB_view.xsl, realizovany v php/genConstructions.php
--  	cokolvek ine ... tabulkovy vypis
--
--  Call Examples :
-- 		-- vypis vsetkych
-- 	call buildups_podla_konstrukcie('[0-9]+','xml');
-- 	call buildups_podla_konstrukcie('[0-9]+','json');
-- 	call buildups_podla_konstrukcie('[0-9]+','');
-- 		-- vypis iba pre druh_konstrukcie 3
-- 	call buildups_podla_konstrukcie('3','xml');
-- 	call buildups_podla_konstrukcie(3,'json');
-- 	call buildups_podla_konstrukcie(3,'');
-- 		-- vypis iba pre druh_konstrukcie 11
-- 	call buildups_podla_konstrukcie(11,'xml');
-- 	call buildups_podla_konstrukcie('11','json');
-- 	call buildups_podla_konstrukcie(10+1,'jcsdkskdhklashdl');
-- 
if (frm='xml') then
-- ----------------------------------- XML ----------
	select concat('<xml><id_druh_kostrukcie>',id_druh_konstrukcie,'</id_druh_kostrukcie>') chunk
	;
	select concat('<popis_konstrukcie>',popis,'</popis_konstrukcie>') chunk
		from zberdat_isover.druh_konstrukcie
			where id = id_druh_konstrukcie
	;
	select concat('<item>
	<construction_summary_FS>',a.construction_summary_FS,'</construction_summary_FS>
	<buildup>',upper(replace(a.buildup,'buildup_','')),'</buildup>
	<asignment3D>',a.asignment3D,'</asignment3D>
	<construction_lang>',coalesce(a.construction_lang,''),'</construction_lang>
	<www_href>',replace(coalesce(a.www_href,''),'&','&amp;'),'</www_href>
	<image_href>',replace(coalesce(a.image_href,''),'&','&amp;'),'</image_href>
	<U>',coalesce(a.U,''),'</U>
	<R>',coalesce(a.R,''),'</R>
	<layers>',
	group_concat('<layer><position>',a.position,'</position>
	<layer_thickness>',a.layer_thickness,'</layer_thickness>
	<layer_thickness_unit>',a.layer_thickness_unit,'</layer_thickness_unit>
	<density>',coalesce(a.density,''),'</density>
	<product_description>',a.product_description,'</product_description>
	<id_typ_materialu>',coalesce(a.id_typ_materialu,''),'</id_typ_materialu>
	<id_druh_materialu>',coalesce(a.id_druh_materialu,''),'</id_druh_materialu>
	<id_materialu>',coalesce(a.id_materialu,''),'</id_materialu>
	<assM>',coalesce(
		( select concat(tm.id,'/',nm.id,'/',dm.id)
			from 		zberdat_isover.DruhMaterialu dm 
				left join zberdat_isover.NazovMaterialu nm on nm.ID = dm.CisloDruhu
				left join zberdat_isover.TypMaterialu tm on tm.ID = nm.CisloMaterialu
			where a.id_materialu = dm.ID
		)
	,''),'</assM>
	<hrubka>',coalesce(a.hrubka,''),'</hrubka>
	</layer>' ORDER BY concat(a.construction_summary_FS,'_',a.buildup),a.position SEPARATOR '')
	,'</layers></item>') chunk
	 from (
	select cb.id, cb.construction_summary_FS, cb.buildup, 
		asignment3D, construction_lang, image_href, www_href, U, R,
		position,layer_thickness,layer_thickness_unit,density,product_description,id_typ_materialu,id_nazov_materialu,id_druh_materialu,id_materialu,hrubka
	 from zberdat_isover.construction_buildups cb
		left join zberdat_isover.construction_buildups_layers cbl
		on cb.construction_summary_FS = binary cbl.construction_summary_FS
			and cb.buildup = binary cbl.buildup
	-- 	ORDER BY concat(cbl.construction_summary_FS,'_',cbl.buildup),cbl.position
	) a
	where concat(',',asignment3D,',') rlike concat(',',BINARY id_druh_konstrukcie,',') -- like concat('%,',BINARY id_druh_konstrukcie,',%')
	group by concat(a.construction_summary_FS,'_',a.buildup) 
	-- 	ORDER BY concat(a.construction_summary_FS,'_',a.buildup),a.position
	;
	select '</xml>' chunk;

elseif frm='json' then
-- ----------------------------------- JSON ----------
	select('[null');	-- select('buildups = [null');
	select concat(',{
		"construction_summary_FS":"',a.construction_summary_FS,'"
	,	"buildup":"',a.buildup,'"
	,	"asignment3D":"',a.asignment3D,'"
	,	"construction_lang":"',coalesce(a.construction_lang,'null'),'"
	,	"www_href":"',replace(coalesce(a.www_href,''),'"','\\"'),'"
	,	"image_href":"',replace(coalesce(a.image_href,''),'"','\\"'),'"
	,	"U":',coalesce(a.U,'null'),'
	,	"R":',coalesce(a.R,'null'),'
	,	"layers":[',
	group_concat('{"position":',a.position,'
	,	"layer_thickness":',a.layer_thickness,'
	,	"layer_thickness_unit":"',a.layer_thickness_unit,'"
	,	"density":',coalesce(a.density,'null'),'
	,	"product_description":"',a.product_description,'"
 	,	"id_typ_materialu":',coalesce(a.id_typ_materialu,'null'),'
	,	"id_druh_materialu":',coalesce(a.id_druh_materialu,'null'),'
	,	"id_materialu":',coalesce(a.id_materialu,'null'),'
	,	"assM":"',coalesce(
		( select concat(tm.id,'/',nm.id,'/',dm.id)
			from 		zberdat_isover.DruhMaterialu dm 
				left join zberdat_isover.NazovMaterialu nm on nm.ID = dm.CisloDruhu
				left join zberdat_isover.TypMaterialu tm on tm.ID = nm.CisloMaterialu
			where a.id_materialu = dm.ID
		)
	,'null'),'"
	,	"hrubka":',coalesce(a.hrubka,'null'),'
	}' ORDER BY concat(a.construction_summary_FS,'_',a.buildup),a.position SEPARATOR ',')
	,']}')
	 from (
	select cb.id, cb.construction_summary_FS, cb.buildup, 
		asignment3D, construction_lang, image_href, www_href,U,R,
		position,layer_thickness,layer_thickness_unit,density,product_description,id_typ_materialu,id_nazov_materialu,id_druh_materialu,id_materialu,hrubka
	 from zberdat_isover.construction_buildups cb
		left join zberdat_isover.construction_buildups_layers cbl
		on cb.construction_summary_FS = binary cbl.construction_summary_FS
			and cb.buildup = binary cbl.buildup
	-- 	ORDER BY concat(cbl.construction_summary_FS,'_',cbl.buildup),cbl.position
	) a
	where concat(',',asignment3D,',') rlike concat(',',BINARY id_druh_konstrukcie,',') -- like concat('%,',BINARY id_druh_konstrukcie,',%')
	group by concat(a.construction_summary_FS,'_',a.buildup) 
	-- 	ORDER BY concat(a.construction_summary_FS,'_',a.buildup),a.position
	;
	select(']');

else -- default organized table 
-- ----------------------------------- table ----------
	select cb.id, cb.construction_summary_FS, cb.buildup
	, 	asignment3D, construction_lang, image_href, www_href,U,R
	,	position,layer_thickness,layer_thickness_unit,density,product_description
-- 	,	id_typ_materialu,id_nazov_materialu,id_druh_materialu
	,	cbl.id_materialu
	,	( select concat(tm.id,'/',nm.id,'/',dm.id)
			from 		zberdat_isover.DruhMaterialu dm 
				left join zberdat_isover.NazovMaterialu nm on nm.ID = dm.CisloDruhu
				left join zberdat_isover.TypMaterialu tm on tm.ID = nm.CisloMaterialu
			where cbl.id_materialu = dm.ID
		) assM
	,	hrubka
	 from zberdat_isover.construction_buildups cb
		left join zberdat_isover.construction_buildups_layers cbl
		on cb.construction_summary_FS = binary cbl.construction_summary_FS
			and cb.buildup = binary cbl.buildup
	where concat(',',asignment3D,',') rlike concat(',',BINARY id_druh_konstrukcie,',') -- like concat('%,',BINARY id_druh_konstrukcie,',%')
	ORDER BY concat(cbl.construction_summary_FS,'_',cbl.buildup),cbl.position
	;

end if;

set @@group_concat_max_len = @gcml;

END
*/
console.log('load_buildups : id_druh_konstrukcie='+id_druh_konstrukcie);
		var holder = document.querySelector('div#fragment_z_konstrukcii div.encapsulator')
		,	tblHolder = holder && holder.querySelector('div#constructions')
		,	alg = document.querySelector('#pending_ajax_loader')
		;
		if (actual_id_druh_konstrukcie == id_druh_konstrukcie) {
			return;
		}
actual_id_druh_konstrukcie = id_druh_konstrukcie;	
		if (holder) {
			tblHolder.innerHTML = '';
			if (alg) { alg.style.display=''; }
			$.ajax({
				url: '/TUZV/fragment5/php/genBuildups.php',
				type: "POST",
				data : {id_druh_konstrukcie:id_druh_konstrukcie,format:'xslt'},
				dataType: "xml",
				success: function (r) {
				//		alert(r);
last_buildup = r;				
					var c = r && r.querySelector && r.querySelector('div.encapsulator');	//('div#constructions');
					if (c) {
						holder.innerHTML = c.innerHTML;
						$('#constructions').find('svg').svgPanZoom( {
							maxZoom : 100
						} )  
					} else {
						tblHolder.innerHTML = '<h2 style="background-color:salmon">Problém načítania skladieb zo servera !</h2>';						
					}					
				},
				complete: function() {
					if (alg) { alg.style.display='none'; }
					if (typeof load_buildups_callback == 'function') {
						load_buildups_callback( id_druh_konstrukcie );
					}
				}
			});
		}
	}

// TODO ... presun do fragment_forms.js
fragment_buildup_opener_callback = function( el ) {
	if ( ! Fproject.fragment_project) {
		new_project();
	}
// vyplnime vrstvy :
// [key]	faktor_dif_odporu	fyz_material	hrubka_materialu	
//	ident_material	mer_tep_kap	objemova_hmotnost	
//	suc_tep_vod_exterier	suc_tep_vod_interier				
	var tds = el.querySelectorAll('table tbody tr td.assMat')
	,	cnt = tds && tds.length
	,	rgxp = /^(\d+)\/(\d+)\/(\d+)$/, matches
	,	xyz, validM = [], mat, hr, hrj
	;
// najprv skontrolujeme uplnost zadania vrstiev
	for(var i=0; i<cnt; i++) {
		rgxp.index = 0;
		xyz = tds[i].textContent.trim();
		matches = rgxp.exec(xyz);
		if (matches) {
			validM.push( {assM:xyz
				, novypocet: tds[i].parentNode.classList.contains('novypocet') 
			} );
		}
	}
	if (!cnt || (cnt != validM.length)) {
		document.querySelector('#fragment_z_konstrukcii div.sorry').style.display='block';
	} else {
// pokial pozname materialy vsetkych vrstiev, mozeme oznacit vybranu konstrukciu
		document.forms.fragment.vzorova_konstrukcia.value = el.dataset.ident;
// a vykonat pracu : mozeme pripravit vrstvy
Fproject.fragment_project.vrstvy = [];				
		for(var i=0, k=0; i<cnt; i++) {
			if ( ! validM[i].novypocet ) {
				xyz = validM[i].assM;
				hr = parseFloat(tds[i].parentNode.querySelector('td.thickness span.value').textContent);
				hrj = tds[i].parentNode.querySelector('td.thickness span.unit').textContent.trim();
				switch(hrj) {
					case 'mm' :	hr*=1; break;
					case 'cm' :	hr*=10; break;
					case 'dm' :	hr*=100; break;
					case 'm' :	hr*=1000; break;
				}
				mat = IdentifyMaterial(xyz);
Fproject.fragment_project.vrstvy[k] = mat.frm;				
Fproject.fragment_project.vrstvy[k].key = k;
Fproject.fragment_project.vrstvy[k].hrubka_materialu = Math.round(hr*1000)/1000;
				k++;
			}
		}
// osadime do tabulky:
		vrstvyTab.init();
		vrstvyTab.write(Fproject.fragment_project.vrstvy);
// zatvorime vyber konstrukcii
		document.getElementById('fragment_z_konstrukcii').style.display='';
	}
}

buildup_opener_callback = fragment_buildup_opener_callback;

function buildup_opener( evt, what, value ) {
	var tel = (evt instanceof Event) ? evt.target : evt
	,	el = tel
	;	
	while (el && el.tagName && (el.tagName.toLowerCase() != 'tr')) {
		el = el.parentNode;
	}
	if (el && !(el instanceof Document)) {	// handle operation in table of buildups
		var val = 0
		,	nel = el && el.nextElementSibling
		;
		switch (what) {
			case 0: {	// ZAVRI buildup
				el.classList.remove('opened');
				break;
			} 
			case 1: {	// SKLADBA tlacitko viazane na SELECT
				var selEl = el.querySelector('select');
				val = selEl && selEl.value
				break;
			}
			case 2: {	// priame tlacitko BUILDUP_x
				val = tel.value;
				break;
			}
			case 3: {	// priama hodnota ( = 'layers' )
				val = value;
				break;
			}
			case 10: {	// vyber do skladby fragmentu
				if (typeof buildup_opener_callback == 'function') {
					buildup_opener_callback(el);
				}
				val = 0;	// uz ziadne blikanie
				break;
			}
		}
		if (val) {
			while( nel && nel.classList && nel.classList.contains('buildup') ) {
				if (nel.dataset.buildup != val) {
					nel.classList.remove('opened');
				} else {
					nel.classList.add('opened');
					var t = nel.querySelector('table');
					if (t) {
						t.scrollIntoView(false);
					}
					blinker(el);
					colorBackgrounder(nel, 'rgb(245, 206, 155)','rgb(245, 218, 183)');
				}
				nel = nel.nextElementSibling;
			}
		}
	} else {	// handle global invokes
		switch (what) {
			case 'select':
				var val = tel.value
				,	summary_FS = document.querySelectorAll('#constructions .summary')
				,	cnt = summary_FS && summary_FS.length
				;
				for (var i=0; i<cnt; i++) {
					if (summary_FS[i].textContent == val) {
						buildup_opener( summary_FS[i], 3, 'layers' );
						break;
					}
				}
				break;
			default:
				break;
		}
	}
}
//]]></script>
